#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <process.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>

#define MAXR 40
#define LG_CHART 50

FILE *F,*OT;

int MOIS;
int MOISD;
float TABV[3][MAXR][14]; /* 0 = Annuel et 1 = YTD */
char TABR[MAXR][5];
char TABO[MAXR];
char NBR;

void Analyse(char TAB); /* TAB= 0(Budget) 1(En cours) */
void Tableau(char Typ); /* Typ= 1(Budget) 2(En cours) 4(Ecart) */
void Chart(char *Texte1, char *Texte2, float Value, float Max);
void Etat(void);
void Repart(char Typ);
void Month(char *ch, char m);
void Exclude(void);

main(int argc,char *argv[])
{
  char N_F[150];
  char Res,Typ;
  char N_OT[150];

  clrscr();
  NBR=0;

  Res=1;
  Typ=7;
  if (argc>4) /* if (argv[4][0]=='/') */
   switch(toupper(argv[4][1]))
   {
     case 'T' : Res=1;
                if (argc>5) Typ=atoi(argv[5]);
                break;

     case 'R' : Res=2;
                if (argc>5) Typ=atoi(argv[5]);
                MOISD=atoi(&(argv[4][2]));
                break;

     case 'E' : Res=3;
                MOISD=atoi(&(argv[4][2]));
                break;

     default : printf(" Erreur de syntaxe : \n");
               printf("   BUDGET Budget.txt Encours.txt Result.txt Mode\n");
               printf("      Mode = /T xx      - Tableau \n");
               printf("      Mode = /Emm       - Etat des rubriques \n");
               printf("      Mode = /Rmm yy    - Rpartition par mois \n");
               printf("        xx : (+) 1=Budget 2=EnCours 4=Ecart \n");
               printf("        yy : (+) 1=Budget 2=PRV/ACT 4=Annuel \n");
               printf("  \n");
               printf("  Dans fichier Exclude.txt : \n");
               printf("    +TYPE  : Activer type \n");
               printf("    -TYPE  : Dsactiver type \n");
               printf("    *+     : Activer tout \n");
               printf("    *-     : Dsactiver tout \n");
               printf("\n");
               exit(1);
   }

  strcpy(N_F,"BUDGET.TXT");
  if (argc>1) strcpy(N_F,argv[1]);
  F=fopen(N_F,"rt");
  if (F==NULL)
     { printf("Impossible d'ouvrir le fichier %s\n",N_F); exit(1); }
  Analyse(0);
  fclose(F);
  strcpy(N_F,"ENCOURS.TXT");
  if (argc>2) strcpy(N_F,argv[2]);
  F=fopen(N_F,"rt");
  if (F==NULL)
     { printf("Impossible d'ouvrir le fichier %s\n",N_F); exit(1); }
  Analyse(1);
  fclose(F);
  strcpy(N_F,"EXCLUDE.TXT");
  F=fopen(N_F,"rt");
  if (F==NULL)
     { printf("Note : pas de fichier %s\n",N_F); }
  else Exclude();
  fclose(F);

  strcpy(N_OT,"RESULT.TXT");
  if (argc>3) strcpy(N_OT,argv[3]);
  OT=fopen(N_OT,"wt");
  if (OT==NULL)
     { printf("Impossible d'ouvrir le fichier %s\n",N_OT); exit(1); }

   switch (Res)
   {
     case 1 : Tableau(Typ);
              break;
     case 2 : Repart(Typ);
              break;
     case 3 : Etat();
              break;
   }

  fclose(OT);

  return 0;

}

void Analyse(char TAB)
{
  char Buf[100];
  char Rub2[5];
  char *Rub;
  char i,j;
  float solde;

  while (fgets(Buf,sizeof(Buf)-1,F)!=NULL)
  {
     if (strstr(Buf,"ANNUEL")!=NULL) MOIS=0;
     if (strstr(Buf,"JANVIER")!=NULL) MOIS=1;
     if (strstr(Buf,"FEVRIER")!=NULL) MOIS=2;
     if (strstr(Buf,"MARS")!=NULL) MOIS=3;
     if (strstr(Buf,"AVRIL")!=NULL) MOIS=4;
     if (strstr(Buf,"MAI")!=NULL) MOIS=5;
     if (strstr(Buf,"JUIN")!=NULL) MOIS=6;
     if (strstr(Buf,"JUILLET")!=NULL) MOIS=7;
     if (strstr(Buf,"AOUT")!=NULL) MOIS=8;
     if (strstr(Buf,"SEPTEMBRE")!=NULL) MOIS=9;
     if (strstr(Buf,"OCTOBRE")!=NULL) MOIS=10;
     if (strstr(Buf,"NOVEMBRE")!=NULL) MOIS=11;
     if (strstr(Buf,"DECEMBRE")!=NULL) MOIS=12;

     Rub=NULL;
     if (strstr(Buf,"SOLDE")!=NULL) Buf[0]=0;
     if (strchr(Buf,',')!=NULL) Rub=strtok(Buf,",");
     if (Rub!=NULL)
     if ((Rub[0]!='\n')&&(Rub[0]!=' '))
     {
        strupr(Rub);
        strcpy(Rub2,"    ");
        if (strlen(Rub)>0) Rub2[0]=Rub[0];
        if (strlen(Rub)>1) Rub2[1]=Rub[1];
        if (strlen(Rub)>2) Rub2[2]=Rub[2];
        if (strlen(Rub)>3) Rub2[3]=Rub[3];
        for(i=0;i<4;i++)
        {
          if (Rub2[i]=='.') Rub2[i]=' ';
          if (Rub2[i]=='\n') Rub2[i]=' ';
        }
        Rub=strtok(NULL,","); /* CREDIT */
        Rub=strtok(NULL,","); /* DEBIT */
        Rub=strtok(NULL,","); /* SOLDE */
        solde=atof(Rub);
        if (solde!=0)
        {
          for(i=0;(i<NBR)&&(strcmp(Rub2,TABR[i])!=0);i++);
          if (i==NBR) /* cration */
          {
             NBR++;
             strcpy(TABR[i],Rub2);
             for(j=0;j<14;j++) TABV[TAB][i][j]=0;
             TABO[i]=1;
          }
          if (MOIS!=0) TABV[TAB][i][0]+=solde;   /* Cumul Annuel */
          if ((MOIS!=0)&&(MOIS<MOISD)) TABV[TAB][i][13]+=solde;   /* Cumul YTD */
          TABV[TAB][i][MOIS]+=solde; /* MOIS en cours */
        }
     }
  }

}

void Tableau(char Typ)
{
  char i,j;

  if ((Typ & 1)==1)
  {
    fprintf(OT,"\nBUDGET\n");
    fprintf(OT,"RUBR|JANVIER  |FEVRIER  |MARS     |AVRIL    |MAI      |JUIN     ");
    fprintf(OT,    "|JUILLET  |AOUT     |SEPTEMBRE|OCTOBRE  |NOVEMBRE |DECEMBRE |ANNUEL \n");
    for(i=0;i<NBR;i++) /* Pour chaque Rub */
     if (TABO[i])
      {
         fprintf(OT,"%s|",TABR[i]);
         for(j=1;j<13;j++) fprintf(OT,"%9.2f|",TABV[0][i][j]);
         fprintf(OT,"%10.2f\n",TABV[0][i][0]);
      }
  }
  if ((Typ & 2)==2)
  {
    fprintf(OT,"\nENCOURS\n");
    fprintf(OT,"RUBR|JANVIER  |FEVRIER  |MARS     |AVRIL    |MAI      |JUIN     ");
    fprintf(OT,    "|JUILLET  |AOUT     |SEPTEMBRE|OCTOBRE  |NOVEMBRE |DECEMBRE |ANNUEL \n");
    for(i=0;i<NBR;i++) /* Pour chaque Rub */
     if (TABO[i])
      {
         fprintf(OT,"%s|",TABR[i]);
         for(j=1;j<13;j++) fprintf(OT,"%9.2f|",TABV[1][i][j]);
         fprintf(OT,"%10.2f\n",TABV[1][i][0]);
      }
  }
  if ((Typ & 4)==4)
  {
    fprintf(OT,"\nECART\n");
    fprintf(OT,"RUBR|JANVIER  |FEVRIER  |MARS     |AVRIL    |MAI      |JUIN     ");
    fprintf(OT,    "|JUILLET  |AOUT     |SEPTEMBRE|OCTOBRE  |NOVEMBRE |DECEMBRE |ANNUEL \n");
    for(i=0;i<NBR;i++) /* Pour chaque Rub */
     if (TABO[i])
      {
         fprintf(OT,"%s|",TABR[i]);
         for(j=1;j<13;j++) fprintf(OT,"%9.2f|",TABV[1][i][j]-TABV[0][i][j]);
         fprintf(OT,"%10.2f\n",TABV[1][i][0]-TABV[0][i][0]);
      }
  }
  fprintf(OT,"\n");

}

void Chart(char *Texte1, char *Texte2, float Value, float Max)
{
  int Long,i;
  float Scale;

  fprintf(OT,"%-4s %-3s ",Texte1,Texte2);
  Scale=(LG_CHART/Max);
  Long=Scale*Value;
  for(i=0; i<abs(Long) ; i++)
    if (Long<0) fprintf(OT,""); else fprintf(OT,""); /* fprintf(OT,""); */
  fprintf(OT," %2.2f\n",Value);

}

void Etat(void)
{
  float Max;
  int i;

  Max=1;
  for(i=0;i<NBR;i++) /* Pour chaque Rub */
     if (TABO[i])
     {
       if (fabs(TABV[0][i][0])>Max) Max=fabs(TABV[0][i][0]);
       if (fabs(TABV[1][i][0])>Max) Max=fabs(TABV[1][i][0]);
       if (fabs(TABV[1][i][13])>Max) Max=fabs(TABV[1][i][13]);
     }

  for(i=0;i<NBR;i++) /* Pour chaque Rub */
     if (TABO[i])
      {
         Chart(TABR[i],"ACT",TABV[1][i][13],Max);
         Chart("","PRV",TABV[1][i][0],Max);
         Chart("","BUD",TABV[0][i][0],Max);
         fprintf(OT,"\n");
      }
}


void Repart(char Typ)
{
  float Max,MaxA;
  int i,j;
  char MoisCh[5];

  for(i=0;i<NBR;i++) /* Pour chaque Rub */
     if (TABO[i])
      {
        fprintf(OT,"Rpartition du type %s \n",TABR[i]);
        Max=1;
        MaxA=1;
        for(j=1;j<13;j++)
        {
          if ((Typ & 1)==1) if (fabs(TABV[0][i][j])>Max) Max=fabs(TABV[0][i][j]);
          if ((Typ & 2)==2) if (fabs(TABV[1][i][j])>Max) Max=fabs(TABV[1][i][j]);
          if ((Typ & 8)==8) if (fabs(TABV[1][i][j]-TABV[0][i][j])>Max) Max=fabs(TABV[1][i][j]-TABV[0][i][j]);
        }
        if ((Typ & 1)==1) if (fabs(TABV[0][i][0])>MaxA) MaxA=fabs(TABV[0][i][0]);
        if ((Typ & 2)==2) if (fabs(TABV[1][i][0])>MaxA) MaxA=fabs(TABV[1][i][0]);
        if ((Typ & 2)==2) if (fabs(TABV[1][i][13])>MaxA) MaxA=fabs(TABV[1][i][13]);
        if ((Typ & 8)==8) if (fabs(TABV[1][i][0]-TABV[0][i][0])>MaxA) MaxA=fabs(TABV[1][i][0]-TABV[0][i][0]);

        for(j=1;j<13;j++)
         {
            Month(MoisCh,j);
            if ((Typ & 2)==2)
              if (j<MOISD)
                     { Chart(MoisCh,"ACT",TABV[1][i][j],Max); MoisCh[0]=0; }
                else { Chart(MoisCh,"PRV",TABV[1][i][j],Max); MoisCh[0]=0; }
            if ((Typ & 1)==1) { Chart(MoisCh,"BUD",TABV[0][i][j],Max); MoisCh[0]=0; }
            if ((Typ & 8)==8) { Chart(MoisCh,"DIF",TABV[1][i][j]-TABV[0][i][j],Max); MoisCh[0]=0; }
         }
         fprintf(OT,"\n");
         strcpy(MoisCh,"ANN");
         if ((Typ & 6)==6) { Chart(MoisCh,"ACT",TABV[1][i][13],MaxA); MoisCh[0]=0; }
         if ((Typ & 6)==6) { Chart(MoisCh,"PRV",TABV[1][i][0],MaxA); MoisCh[0]=0; }
         if ((Typ & 5)==5) { Chart(MoisCh,"BUD",TABV[0][i][0],MaxA); MoisCh[0]=0; }
         if ((Typ & 12)==12) { Chart(MoisCh,"DIF",TABV[1][i][0]-TABV[0][i][0],MaxA); MoisCh[0]=0; }
         fprintf(OT,"\n");
         fprintf(OT,"\n");
      }
}

void Month(char *ch, char m)
{
  switch (m)
  {
     case 1: strcpy(ch,"JAN");
               break;
     case 2: strcpy(ch,"FEV");
               break;
     case 3: strcpy(ch,"MAR");
               break;
     case 4: strcpy(ch,"AVR");
               break;
     case 5: strcpy(ch,"MAI");
               break;
     case 6: strcpy(ch,"JUN");
               break;
     case 7: strcpy(ch,"JUL");
               break;
     case 8: strcpy(ch,"AOU");
               break;
     case 9: strcpy(ch,"SEP");
               break;
     case 10: strcpy(ch,"OCT");
               break;
     case 11: strcpy(ch,"NOV");
               break;
     case 12: strcpy(ch,"DEC");
               break;
  }

}

void Exclude()
{
  char Buf[100];
  int i;

  while (fgets(Buf,sizeof(Buf)-1,F)!=NULL)
  {
    strupr(Buf);
    Buf[5]=0;
    switch (Buf[0])
    {
      case '+' : for(i=0;i<NBR;i++) if (strcmp(&(Buf[1]),TABR[i])==0) TABO[i]=1;
                 break;
      case '-' : for(i=0;i<NBR;i++) if (strcmp(&(Buf[1]),TABR[i])==0) TABO[i]=0;
                 break;
      case '*' : for(i=0;i<NBR;i++) TABO[i]=(Buf[1]='+');
                 break;
    }
  }
}
