{************************************************}
{                                                }
{   VEDIT.PAS                                    }
{   Editeur de Texte en turbo vision             }
{                                                }
{************************************************}

PROGRAM TVEdit;

{$M 8192,8192,655360}
{$X+,S-}

{ Dmonstration de l'utilisation des units BUFFERS et EDITORS.     }
{ Etudiez les documentations magntiques BUFFERS.DOC et EDITORS.DOC }
{ stocks dans le sous-rpertoire  DOC et imprimez-les.             }

USES Dos, Objects, Drivers, Memory, Views, Menus, Dialogs,
  StdDlg, MsgBox, App, Calc, Buffers, Editors, gadgets;

CONST
  HeapSize = 5 * 1024;

CONST
  cmOpen       = 100;
  cmNew        = 101;
  cmChangeDir  = 102;
  cmDosShell   = 103;
  cmCalculator = 104;
  cmShowClip   = 105;
  cmvideomode  = 106;
  cmtabselect  = 107;

TYPE
  PEditorApp = ^TEditorApp;
  TEditorApp = object(TApplication)
    Heap:PHeapView;
    constructor Init;
    destructor Done; virtual;
    procedure Idle; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure OutOfMemory; virtual;
  end;

VAR
  EditorApp: TEditorApp;
  ClipWindow: PEditWindow;

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;

function CreateFindDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 38, 12);
  D := New(PDialog, Init(R, 'Chercher'));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.Assign(3, 3, 32, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 25, 3);
    Insert(New(PLabel, Init(R, '~T~exte  chercher', Control)));
    R.Assign(32, 3, 35, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 5, 35, 7);
    Insert(New(PCheckBoxes, Init(R,
      NewSItem('~C~aractres maj/min',
      NewSItem('~M~ots distincts', nil)))));

    R.Assign(14, 9, 24, 11);
    Insert(New(PButton, Init(R, 'O~k~', cmOk, bfDefault)));
    Inc(R.A.X, 12); Inc(R.B.X, 12);
    Insert(New(PButton, Init(R, 'Annuler', cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateFindDialog := D;
end;

function CreateReplaceDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 40, 16);
  D := New(PDialog, Init(R, 'Remplacer'));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.Assign(3, 3, 34, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 20, 3);
    Insert(New(PLabel, Init(R, '~T~exte  chercher', Control)));
    R.Assign(34, 3, 37, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 6, 34, 7);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 5, 20, 6);
    Insert(New(PLabel, Init(R, '~N~ouveau texte', Control)));
    R.Assign(34, 6, 37, 7);
    Insert(New(PHistory, Init(R, PInputLine(Control), 11)));

    R.Assign(3, 8, 37, 12);
    Insert(New(PCheckBoxes, Init(R,
      NewSItem('~C~aractres maj/min',
      NewSItem('~M~ots distincts',
      NewSItem('~D~emander pour chaque?',
      NewSItem('~R~emplacer tous', nil)))))));

    R.Assign(17, 13, 27, 15);
    Insert(New(PButton, Init(R, 'O~k~', cmOk, bfDefault)));
    R.Assign(28, 13, 38, 15);
    Insert(New(PButton, Init(R, 'Annuler', cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateReplaceDialog := D;
end;

function DoEditDialog(Dialog: Integer; Info: Pointer): Word; far;
var
  R: TRect;
  T: TPoint;
begin
  case Dialog of
    edOutOfMemory:
      DoEditDialog := MessageBox('Mmoire insuffisante pour cette opration.',
        nil, mfError + mfOkButton);
    edReadError:
      DoEditDialog := MessageBox('Erreur en lecture de %s.',
        @Info, mfError + mfOkButton);
    edWriteError:
      DoEditDialog := MessageBox('Erreur en criture de %s.',
        @Info, mfError + mfOkButton);
    edCreateError:
      DoEditDialog := MessageBox('Erreur en cration de %s.',
        @Info, mfError + mfOkButton);
    edSaveModify:
      DoEditDialog := MessageBox('%s a t modifi. Sauver ?',
        @Info, mfInformation + mfYesNoCancel);
    edSaveUntitled:
      DoEditDialog := MessageBox('Sauver ce fichier sans nom ?',
        nil, mfInformation + mfYesNoCancel);
    edSaveAs:
      DoEditDialog := ExecDialog(New(PFileDialog, Init('*.*',
        'Sauver ficher comme ', '~N~om', fdOkButton, 101)), Info);
    edFind:
      DoEditDialog := ExecDialog(CreateFindDialog, Info);
    edSearchFailed:
      DoEditDialog := MessageBox('Chane demande introuvable.',
        nil, mfError + mfOkButton);
    edReplace:
      DoEditDialog := ExecDialog(CreateReplaceDialog, Info);
    edReplacePrompt:
      begin
          { Evitons de placer la bote sur la ligne curseur }
        R.Assign(0, 1, 40, 8);
        R.Move((Desktop^.Size.X - R.B.X) div 2, 0);
        Desktop^.MakeGlobal(R.B, T);
        Inc(T.Y);
        if TPoint(Info).Y <= T.Y then
          R.Move(0, Desktop^.Size.Y - R.B.Y - 2);
        DoEditDialog := MessageBoxRect(R, 'Remplacer cette occurrence?',
          nil, mfYesNoCancel + mfInformation);
      end;
  end;
end;

function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
var
  P: PView;
  R: TRect;
begin
  DeskTop^.GetExtent(R);
  P := Application^.ValidView(New(PEditWindow,
    Init(R, FileName, wnNoNumber)));
  if not Visible then P^.Hide;
  DeskTop^.Insert(P);
  OpenEditor := PEditWindow(P);
end;

constructor TEditorApp.Init;
var
  H: Word;
  R: TRect;
  i:byte;
  Dir:DirStr;
  Name:NameStr;
  Ext:ExtStr;
  SRec:SearchRec;

begin
  H := PtrRec(HeapEnd).Seg - PtrRec(HeapPtr).Seg;
  if H > HeapSize then BufHeapSize := H - HeapSize else BufHeapSize := 0;
  InitBuffers;
  TApplication.Init;

  GetExtent(R);
  Dec(R.B.X);
  R.A.X:=R.B.X-9;
  R.A.Y:=R.B.Y-1;
  Heap:=new(PHeapView, Init(R));
  Heap^.GrowMode:=GfGrowAll;
  Insert(Heap);

  DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
    cmUndo, cmFind, cmReplace, cmSearchAgain]);
  EditorDialog := DoEditDialog;
  ClipWindow := OpenEditor('', False);
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;
  for i:=1 to paramcount do
   if (pos('*',paramstr(i))<>0) or (pos('?',paramstr(i))<>0) then
    begin
     Fsplit(paramstr(i),dir,name,ext);
     findfirst(paramstr(i),anyfile,Srec);
     while (Doserror<>2) and (Doserror<>18) do
      begin
      if (Srec.attr and $18)=0 then
         begin
         OpenEditor(dir+Srec.name,true);
         end;
      findnext(Srec)
      end;
    end else OpenEditor(paramstr(i),true);
  MessageBox(^C+'VEDIT Version 1.0'+#13+#13+^C+' (C)1991 Patrick BORY',
        nil, mfInformation + mfOkButton);

end;

destructor TEditorApp.Done;
begin
  TApplication.Done;
  DoneBuffers;
end;

procedure TEditorApp.HandleEvent(var Event: TEvent);

procedure ShowHelp;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 70, 20);
  D := New(PDialog, Init(R, 'Aide'));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.Assign(5, 1, 65, 2);
    Control := New(PStatictext, Init(R, 'SHIFT + TAB : Fixe longueur des tabulations (1=symbolique)'));
    Insert(Control);

    R.Assign(5, 3, 65, 10);
    Control := New(PStatictext, Init(R, 'CTRL + L : Cherche occurence suivante'+#13+
                                        'CTRL + O : Indentation Automatique'+#13+
                                        'CTRL + P : Ajoute un caractre ASCII'+#13+
                                        'CTRL + A : Dplacement d''un mot vers la gauche'+#13+
                                        'CTRL + F : Dplacement d''un mot vers la droite'+#13+
                                        'CTRL + T : Efface le mot'+#13+
                                        'CTRL + Y : Efface la ligne'
                                    ));
    insert(control);

    R.Assign(5, 11, 65, 16);
    Control := New(PStatictext, Init(R, 'CTRL + Q puis A : Remplace une chaine par une autre'+#13+
                                        '              F : Recherche une chaine'+#13+
                                        '              H : Efface le debut de la ligne'+#13+
                                        '              Y : Efface la fin de la ligne'+#13+
                                        'CTRL + K puis Y : Efface le bloc'
                                    ));
    Insert(Control);

{    R.Assign(5, 14, 65, 16);
    Control := New(PStatictext, Init(R, 'CTRL + K puis Y : Efface Block'+#13+
                                        '              H : Cache Block'+#13
                                    ));
    Insert(Control);
}
    R.Assign(30, 17, 40, 19);
    Insert(New(PButton, Init(R, 'O~k~', cmOk, bfDefault)));

    SelectNext(False);
  end;

  Execview(D);

end;


procedure FileOpen;
var
  FileName: FNameStr;
begin
  FileName := '*.*';
  if ExecDialog(New(PFileDialog, Init('*.*', 'Ouverture fichier',
    '~N~om', fdOpenButton, 100)), @FileName) <> cmCancel then
    OpenEditor(FileName, True);
end;

procedure FileNew;
begin
  OpenEditor('', True);
end;

procedure ChangeDir;
begin
  ExecDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
end;

procedure DosShell;
begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
  SetMemTop(Ptr(BufHeapPtr, 0));
  PrintStr('Frappez EXIT pour revenir dans VEDIT...');
  SwapVectors;
  Exec(GetEnv('COMSPEC'), '');
  SwapVectors;
  SetMemTop(Ptr(BufHeapEnd, 0));
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
end;

procedure ShowClip;
begin
  ClipWindow^.Select;
  ClipWindow^.Show;
end;

procedure Tile;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Tile(R);
end;

procedure Cascade;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Cascade(R);
end;

procedure Calculator;
begin
  DeskTop^.Insert(ValidView(New(PCalculator, Init)));
end;

var SS:string;
    err:integer;

begin
  TApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmOpen: FileOpen;
        cmNew: FileNew;
        cmChangeDir: ChangeDir;
        cmDosShell: DosShell;
        cmCalculator: Calculator;
        cmShowClip: ShowClip;
        cmTile: Tile;
        cmCascade: Cascade;
        cmhelp:ShowHelp;
        cmtabselect:begin
                    SS:='7';
                    if InputBox('Fixe longueur tabulations','Longueur tabulation :',SS,2)=cmok then
                       begin
                       val(SS,TABSIZE,err);
                       if (err<>0) or (TABSIZE<1) then TABSIZE:=7;
                       Event.Command:=cmRedrawEdit;
                       Event.what:=evbroadcast;
                       PutEvent(Event);
                       end;
                    end;
        cmvideomode:begin
                    if (ScreenMode and smfont8x8)=0
                       then ShadowSize.X := 1
                       else ShadowSize.X := 2;
                    setscreenmode(Screenmode xor smFont8x8);
                    end;
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure TEditorApp.Idle;

begin
TApplication.Idle;
Heap^.Update;
end;


procedure TEditorApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ichier', hcNoContext, NewMenu(
      NewItem('~N~ouveau', 'CTRL-F3', kbCtrlF3, cmNew, hcNoContext,
      NewItem('~O~uvrir...', 'F3', kbF3, cmOpen, hcNoContext,
      NewItem('~S~auver', 'F2', kbF2, cmSave, hcNoContext,
      NewItem('S~a~uver dans...', '', kbNoKey, cmSaveAs, hcNoContext,
      NewLine(
      NewItem('~C~hanger rp...', '', kbNoKey, cmChangeDir, hcNoContext,
      NewItem('accs au ~D~OS', '', kbNoKey, cmDosShell, hcNoContext,
      NewItem('~Q~uitter', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil))))))))),
    NewSubMenu('~E~dition', hcNoContext, NewMenu(
      NewItem('~A~nnuler', 'CTRL - ', kbCTRLBACK, cmUndo, hcNoContext,
      NewLine(
      NewItem('~C~ouper', 'Shift-Del', kbShiftDel, cmCut, hcNoContext,
      NewItem('Co~p~ier', 'Ctrl-Ins', kbCtrlIns, cmCopy, hcNoContext,
      NewItem('C~o~ller', 'Shift-Ins', kbShiftIns, cmPaste, hcNoContext,
      NewItem('~M~ontrer Presse-papier', 'F4', kbF4, cmShowClip, hcNoContext,
      NewLine(
      NewItem('~E~ffacer', 'Ctrl-Del', kbCtrlDel, cmClear, hcNoContext,
      nil))))))))),
    NewSubMenu('~R~echerche', hcNoContext, NewMenu(
      NewItem('~C~hercher...', 'F7', kbF7, cmFind, hcNoContext,
      NewItem('~R~emplacer...', 'F8', kbF8, cmReplace, hcNoContext,
      NewItem('~S~uivant', 'CTRL-L', kbNoKey, cmSearchAgain, hcNoContext,
      nil)))),
    NewSubMenu('~V~isuel', hcNoContext, NewMenu(
      NewItem('Mode ~V~ido', 'Alt-F7', kbAltF7, cmvideomode, hcNoContext,
      NewLine(
      NewItem('~R~etaille/Bouge','Ctrl-F5', kbCtrlF5, cmResize, hcNoContext,
      NewItem('~Z~oom', 'F5', kbF5, cmZoom, hcNoContext,
      NewItem('~M~osaque', '', kbNoKey, cmTile, hcNoContext,
      NewItem('~C~ascade', '', kbNoKey, cmCascade, hcNoContext,
      NewItem('~S~uivante', 'F6', kbF6, cmNext, hcNoContext,
      NewItem('~P~rcdente', 'Shift-F6', kbShiftF6, cmPrev, hcNoContext,
      NewItem('~F~ermer', 'Alt-F4', kbAltF4, cmClose, hcNoContext,
      NewLine(
      NewItem('Ca~l~culette', 'F9', kbF9, cmCalculator, hcNoContext,
      nil)))))))))))),
    NewSubMenu('~A~ide', hcNoContext, NewMenu(
      NewItem('~C~ommandes...', 'F1', kbF1, cmhelp, hcNoContext,
      nil)),
    nil))))))));
end;

procedure TEditorApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~F2~ Sauver', kbF2, cmSave,
      NewStatusKey('~F3~ Ouvrir', kbF3, cmOpen,
      NewStatusKey('~Alt-F4~ Fermer', kbAltF4, cmClose,
      NewStatusKey('~F5~ Zoom', kbF5, cmZoom,
      NewStatusKey('~F6~ Suivante', kbF6, cmNext,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('',kbshiftTab,cmtabselect,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil)))))))),
    nil)));
end;

procedure TEditorApp.OutOfMemory;
begin
  MessageBox('Mmoire insuffisante pour cette opration.',
    nil, mfError + mfOkButton);
end;

begin
  EditorApp.Init;
  EditorApp.Run;
  EditorApp.Done;
end.

{   EOS VEDIT.PAS     }
