{************************************************}
{   MSGBOX.PAS                                   }
{   Turbo Pascal 6.0                             }
{   Objet Bote message                          }
{                                                }
{   Unit standard de Turbo Vision               }
{   Copyright (c) 1990 by Borland International  }
{************************************************}

UNIT MsgBox;

{$F+,O+,X+,D-}

{ ********************************************** Partie publique INTERFACE }
INTERFACE

USES Objects;

CONST

   { Catgories de botes Message }

  mfWarning      = $0000;       { Bote Warning }
  mfError        = $0001;       { Bote Erreur  }
  mfInformation  = $0002;       { Bote Information  }
  mfConfirmation = $0003;       { Bote Confirmation }

   { Indicateurs des boutons de bote (flags) }

  mfYesButton    = $0100;       { Insre bouton Yes }
  mfNoButton     = $0200;       { Insre bouton No  }
  mfOKButton     = $0400;       { Insre bouton OK  }
  mfCancelButton = $0800;       { Insre bouton Annuler (Cancel) }

  mfYesNoCancel  = mfYesButton + mfNoButton + mfCancelButton;
                                { Dialogue standard avec Yes, No et Cancel }
  mfOKCancel     = mfOKButton + mfCancelButton;
                                { Dialogue standard OK ou Cancel }

   { MessageBox affiche une chane dans une bote de taille normalise.      }
   { Les paramtres Msg et Params sont d'abord transmis  FormatStr.         }
   { Le rsultat est affich comme elvis statique TStaticText dans la bote. }

function MessageBox(Msg: String; Params: Pointer; AOptions: Word): Word;

   { MessageBoxRec permet de spcifier un TRect pour la bote. }
function MessageBoxRect(var R: TRect; Msg: String; Params: Pointer;
  AOptions: Word): Word;

   { InputBox affiche une bote de saisie de chane.                         }

function InputBox(Title: String; ALabel: String; var S: String;
  Limit: Byte): Word;

   { InputBoxRect ressemble  InputBox avec dfinition d'un rectangle.       }

function InputBoxRect(var Bounds: TRect; Title: String; ALabel: String;
  var S: String;  Limit: Byte): word;

{ ******************************************* Partie prive IMPLEMENTATION }
IMPLEMENTATION

USES Drivers, Views, Dialogs, App;

function MessageBox(Msg: String; Params: Pointer;
  AOptions: Word): Word;
var
  R: TRect;
begin
  R.Assign(0, 0, 40, 9);
  R.Move((Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
  MessageBox := MessageBoxRect(R, Msg, Params, AOptions);
end;

function MessageBoxRect(var R: TRect; Msg: String; Params: Pointer;
  AOptions: Word): Word;
const
  ButtonName: array[0..3] of string[7] =
    ('~O~ui', '~N~on', 'O~K~', 'Annuler');
  Commands: array[0..3] of word =
    (cmYes, cmNo, cmOK, cmCancel);
  Titles: array[0..3] of string[11] =
    ('Attention', 'Erreur', 'Information', 'Confirmer');
var
  I, X, ButtonCount: Integer;
  Dialog: PDialog;
  Control: PView;
  T: TRect;
  ButtonList: array[0..4] of PView;
  S: String;
begin
  Dialog := New(PDialog,
    Init(R, Titles[AOptions and $3]));
  with Dialog^ do
  begin
    R.Assign(3, 2, Size.X - 2, Size.Y - 3);
    FormatStr(S, Msg, Params^);
    Control := New(PStaticText, Init(R, S));
    Insert(Control);
    X := -2;
    ButtonCount := 0;
    for I := 0 to 3 do
      if AOptions and ($0100 shl I) <> 0 then
      begin
        R.Assign(0, 0, 10, 2);
        Control := New(PButton, Init(R, ButtonName[I], Commands[i],
          bfNormal));
        Inc(X, Control^.Size.X + 2);
        ButtonList[ButtonCount] := Control;
        Inc(ButtonCount);
      end;
    X := (Size.X - X) shr 1;
    for I := 0 to ButtonCount - 1 do
    begin
      Control := ButtonList[I];
      Insert(Control);
      Control^.MoveTo(X, Size.Y - 3);
      Inc(X, Control^.Size.X + 2);
    end;
    SelectNext(False);
  end;
  MessageBoxRect := DeskTop^.ExecView(Dialog);
  Dispose(Dialog, Done);
end;

function InputBox(Title: String; ALabel: String; var S: String;
  Limit: Byte): Word;
var
  R: TRect;
begin
  R.Assign(0, 0, 60, 8);
  R.Move((Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
  InputBox := InputBoxRect(R, Title, ALabel, S, Limit);
end;

function InputBoxRect(var Bounds: TRect; Title: String; ALabel: String;
  var S: String;  Limit: Byte): Word;
var
  Dialog: PDialog;
  Control: PView;
  R: TRect;
  C: Word;
begin
  Dialog := New(PDialog, Init(Bounds, Title));
  with Dialog^ do
  begin
    R.Assign(4 + CStrLen(ALabel), 2, Size.X - 3, 3);
    Control := New(PInputLine, Init(R, Limit));
    Insert(Control);
    R.Assign(2, 2, 3 + CStrLen(ALabel), 3);
    Insert(New(PLabel, Init(R, ALabel, Control)));
    R.Assign(Size.X - 24, Size.Y - 4, Size.X - 14, Size.Y - 2);
    Insert(New(PButton, Init(R, 'O~K~', cmOk, bfDefault)));
    Inc(R.A.X, 12); Inc(R.B.X, 12);
    Insert(New(PButton, Init(R, 'Annuler', cmCancel, bfNormal)));
    Inc(R.A.X, 12); Inc(R.B.X, 12);
    SelectNext(False);
  end;
  Dialog^.SetData(S);
  C := DeskTop^.ExecView(Dialog);
  if C <> cmCancel then Dialog^.GetData(S);
  Dispose(Dialog, Done);
  InputBoxRect := C;
end;

END.

{   EOS MSGBOX.PAS                                   }
