{ Unit de gestion d'une alarme - de 1990  2050 }
{ Correction le 10/11/93 du Bug dans Checkit (ins et del dans un foreach) }

unit Alarm;

{$O+}
{$F+}

interface

uses Drivers,crt,Views,App,Objects,Dialogs,XBeep,Dos,MsgBox,stdbox;

const AlTousAn   = 1;
      AlTousMo   = 2;
      AlRepApres = 4;

const haCancelbtn  :word=hcnocontext;
      haOkbtn      :word=hcnocontext;
      haRadiobtn   :word=hcnocontext;
      haAnneeAlarm :word=hcnocontext;
      haMoisAlarm  :word=hcnocontext;
      haJourAlarm  :word=hcnocontext;
      haHeureAlarm :word=hcnocontext;
      haMinutAlarm :word=hcnocontext;
      haMessage    :word=hcnocontext;
      haAlarmBox   :word=hcnocontext;
      haSuivantBtn :word=hcnocontext;
      haDetruitBtn :word=hcnocontext;
      haMAlarmBox  :word=hcnocontext;

type MessStr=String[80];

type PAlarmItem = ^TAlarmItem;
     TAlarmItem = record
                  Jo,Mo,An,He,Mi,Se,Typ:word;
                  Mess:MessStr;
                  end;


type PAlarmColl = ^TAlarmColl;
     TAlarmColl = object(TSortedCollection)

       constructor Init(ALimit, ADelta: Integer);
       function Compare(Key1, Key2: Pointer): Integer; virtual;
       procedure Check; virtual;          { Verifie si une alarme est atteinte }
       procedure ModifAlarm;              { Boite de dialogue d'edition des alarmes }
       procedure FreeItem(Item: Pointer); virtual;
       procedure PutItem(var S:TStream; Item:Pointer);  virtual;
       function Getitem(var S:TStream):Pointer; virtual;
       end;


const RAlarmColl:TStreamRec = (
          objtype:10100;
          vmtLink:Ofs(TypeOf(TAlarmColl)^);
          Load:@TAlarmColl.Load;
          Store:@TAlarmColl.Store
          );

var RepeatColl:TAlarmColl; { Doit tre initilis pour contenir les rappels }

procedure RegisterAlarmColl;

function NewAlarmItem(Jo,Mo,An,He,Mi,Se,Typ:word; Mess:MessStr):PAlarmItem;

procedure CheckItem(Item:Pointer);     { Vrifie si l'heure de Item est atteinte }

procedure AlarmRing(Al:PAlarmItem);    { Signale Al }

function InputAlarmItem:PAlarmItem;    { Cration par boite de dialogue d'une date d'alarme }

procedure ConfirmAlarm(Al:PAlarmItem); { Detruit Al ou reporte la date }

procedure EditAlarm(Al:PAlarmItem);    { Boite de dialogue d'edition d'alarme }

implementation

const maxjour:array[1..12] of byte=(31,27,31,30,31,30,31,31,30,31,30,31);

var Incheck:boolean;            { Indique si on est en train de vrifier }
    CheckedColl:PAlarmColl;     { Pointe vers la collection en cours de vrification }
    AddColl:TAlarmColl;         { Contient les lments  ajouter a CheckedColl }
    DelColl:TAlarmColl;         { Contient les lments  supprimer de CheckedColl }
                                { Note: Les items de DelColl seront aussi librs par Free }

constructor TAlarmColl.Init(ALimit, ADelta: Integer);

begin
TSortedCollection.Init(ALimit, ADelta);
Duplicates:=true;
end;

function TAlarmColl.Compare(Key1, Key2: Pointer): Integer;

var l1,l2:longint;
    K:PAlarmItem;

begin
K:=Key1;
l1:=longint(K^.He)*3600+K^.Mi*60+K^.Se+K^.Jo*86400+K^.Mo*2678400+(K^.An-1990)*32140800;
K:=Key2;
l2:=longint(K^.He)*3600+K^.Mi*60+K^.Se+K^.Jo*86400+K^.Mo*2678400+(K^.An-1990)*32140800;
if l1=l2 then begin
              Compare:=0;
              if PAlarmItem(Key1)^.Mess>PAlarmItem(Key2)^.Mess then compare:=1;
              if PAlarmItem(Key1)^.Mess<PAlarmItem(Key2)^.Mess then compare:=-1;
              end
         else if l1>l2 then Compare:=1
                       else Compare:=-1;
end;

procedure TAlarmColl.FreeItem(Item: Pointer);

begin
Dispose(PAlarmItem(Item));
end;

procedure TAlarmColl.Check;

  procedure CheckIt(Item:Pointer); { Effectue un test dans le foreach }

  begin
  CheckItem(Item);
  end;

  procedure AddIt(Item:Pointer); { Pour eviter des Add dans le foreach de CheckedColl }

  begin
  CheckedColl^.insert(Item);
  end;

  procedure DelIt(Item:Pointer); { Pour eviter des Del dans le foreach de CheckedColl }

  begin
  CheckedColl^.delete(Item);
  end;


begin
if not incheck then
   begin
   CheckedColl:=@self;
   incheck:=true;        { Evite un boucle infini si appel de check dans Idle }
   foreach(@CheckIt);    { Ici , aucun lment ne doit tre del ou ins dans CheckedColl }
   incheck:=false;
   AddColl.foreach(@AddIt);  { Effectue les ins necessaires dans CheckedColl }
   AddColl.DeleteAll;
   DelColl.foreach(@DelIt);  { Effectue les del necessaires dans CheckedColl }
   DelColl.FreeAll;          { puis libre les items de la mmoire }
   end;
end;

procedure TAlarmColl.ModifAlarm;

var R:TRect;
    C:PRadioButtons;
    S:PNumInputLine;
    SS:PInputLine;
    E:integer;
    Dialog:PDialog;
    Control:Word;
    V:PView;
    AlarmData:record
              Jo,Mo:string[2];
              An:string[4];
              He,Mi:string[2];
              Typ:word;
              Mess:string[255];
              end;
    Al:PAlarmItem;
    ALR:TAlarmItem;
    i:integer;

begin
if count=0 then exit;
i:=0;
repeat
 Al:=At(i);
 R.Assign(0,0,45,13);
 Dialog:=New(PDialog,Init(R, 'Modification des alarmes'));
 with Dialog^ do
   begin
   R.Assign(33,2,44,4);
   V:=(New (PButton, Init(R,'Ok', cmok, bfDefault)));
   V^.HelpCtx:=haokbtn;
   insert(V);
   R.Assign(33,4,44,6);
   V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
   V^.helpCtx:=hacancelbtn;
   insert(V);

   R.Assign(9,6,13,7);
   S:=New(PNumInputLine, Init(R, 2,1,31,^C+'Jour incorrect'));
   S^.HelpCtx:=haMoisAlarm;
   insert(S);
   R.Assign(1,6,9,7);
   Insert(New(PLabel, Init(R, '~J~our : ' , S)));
   R.Assign(22,6,26,7);
   S:=New(PNumInputLine, Init(R, 2,1,12,^C+'Mois incorrect'));
   S^.HelpCtx:=haMoisAlarm;
   insert(S);
   R.Assign(14,6,22,7);
   Insert(New(PLabel, Init(R, 'Mois : ' , S)));
   R.Assign(36,6,42,7);
   S:=New(PNumInputLine, Init(R, 4,1990,2050,^C+'Anne incorrecte'));
   S^.HelpCtx:=haAnneeAlarm;
   insert(S);
   R.Assign(27,6,36,7);
   Insert(New(PLabel, Init(R, 'Anne : ' , S)));

   R.Assign(28,2,32,3);
   S:=New(PNumInputLine, Init(R, 2,0,23,^C+'Heure incorrecte'));
   S^.HelpCtx:=haHeureAlarm;
   insert(S);
   R.Assign(18,2,28,3);
   Insert(New(PLabel, Init(R, '~H~eure  : ' , S)));
   R.Assign(28,4,32,5);
   S:=New(PNumInputLine, Init(R, 2,0,59,^C+'Heure incorrecte'));
   S^.HelpCtx:=haMinutAlarm;
   insert(S);
   R.Assign(18,4,28,5);
   Insert(New(PLabel, Init(R, 'M~i~nute : ' , S)));

   R.assign(3,2,18,5);
   C:=New(PRadioButtons, Init(R, NewSItem('~N~ormal',
                                 NewSItem('~M~ensuel',
                                 NewSItem('~A~nnuel',
                                 nil)))));
   C^.HelpCtx:=haRadioBtn;
   insert(C);
   R.Assign(1,1,15,2);
   Insert(New(PLabel, Init(R, '~T~ype : ' , C)));

   R.Assign(11,8,43,9);
   SS:=New(PInputLine, Init(R,255));
   SS^.helpCtx:=hamessage;
   insert(SS);
   R.Assign(1,8,11,9);
   Insert(New(PLabel, Init(R, 'M~e~ssage : ' , SS)));

   R.Assign(27,10,39,12);
   V:=(New (PButton, Init(R,'~D~truit', cmno, bfNormal)));
   V^.HelpCtx:=haDetruitbtn;
   insert(V);
   R.Assign(7,10,19,12);
   V:=(New (PButton, Init(R,'~S~uivant', cmyes, bfNormal)));
   V^.helpCtx:=haSuivantbtn;
   insert(V);


   Str(Al^.An:4,AlarmData.An);
   Str(Al^.Mo:2,AlarmData.Mo);
   Str(Al^.Jo:2,AlarmData.Jo);
   Str(Al^.He:2,AlarmData.He);
   Str(Al^.Mi:2,AlarmData.Mi);
   AlarmData.Typ:=Al^.Typ;
   AlarmData.Mess:=Al^.Mess;
   SetData(AlarmData);
   Options:=Options or ofCentered;
   helpctx:=haMAlarmBox;
   end;

Control:=DeskTop^.ExecView(Dialog);

Dialog^.GetData(AlarmData);

R.assign(20,5,60,12);

val(AlarmData.An,ALR.An,E);
val(AlarmData.Mo,ALR.Mo,E);
val(AlarmData.Jo,ALR.Jo,E);
val(AlarmData.He,ALR.He,E);
val(AlarmData.Mi,ALR.Mi,E);
ALR.Typ:=AlarmData.Typ;
ALR.Mess:=AlarmData.Mess;
ALR.Se:=0;
Dispose(Dialog,Done);

if (control=cmok) or (control=cmyes) then
   begin
   AtDelete(i);
   Al^:=ALR;
   insert(Al);

{ CETTE PARTIE A ETE SUPPRIMER CAR ELLE NE SUIT PAS LA NOUVELLE METHODE DE INS ET DEL
   CheckedColl:=@self;
   incheck:=true;
   CheckItem(Al);
   incheck:=false;
}

   end;

if control=cmno then
   begin
   AtFree(i);
   if i>=count then i:=i-1;
   if count=0 then exit;
   end;

if control=cmyes then
   begin
   if i+1<count then i:=i+1 else i:=0;
   end;

until (control=cmcancel) or (control=cmok);
end;

procedure TAlarmColl.PutItem(var S:TStream; Item:Pointer);

begin
S.Write(PAlarmItem(Item)^,sizeof(TAlarmItem));
end;


function TAlarmColl.GetItem(var S:TStream):Pointer;

var Item:PAlarmItem;

begin
new(Item);
S.Read(Item^,sizeof(TAlarmItem));
GetItem:=Item;
end;

function NewAlarmItem(Jo,Mo,An,He,Mi,Se,Typ:word; Mess:MessStr):PAlarmItem;

var Al:PAlarmItem;

begin
new(Al);
Al^.Jo:=Jo;
Al^.Mo:=Mo;
Al^.An:=An;
Al^.He:=He;
Al^.Mi:=Mi;
Al^.Se:=Se;
Al^.Typ:=Typ;
Al^.Mess:=Mess;
NewAlarmItem:=Al;
end;


procedure ConfirmAlarm(Al:PAlarmITem);

var NAl:PAlarmItem;

begin
case Al^.Typ of
  0 : DelColl.Insert(Al); { On fera le CheckedColl.Free(Al) plustard }
  1 : begin
      DelColl.Insert(Al); { On fera le CheckedColl.Free(Al) plustard }
      New(NAl);           { On fera un CheckedColl.Free donc on recre Al }
      NAl^:=Al^;
      if NAl^.Mo<>12 then NAl^.Mo:=NAl^.Mo+1
                    else begin
                         NAl^.MO:=1;
                         NAl^.An:=NAl^.An+1;
                         end;
      AddColl.Insert(NAl); { On fera le CheckedColl.insert(NAl) plustard }
      end;
  2 : begin
      DelColl.Insert(Al); { On fera le CheckedColl.Free(Al) plustard }
      New(NAl);           { On fera un CheckedColl.Free donc on recre Al }
      NAl^:=Al^;
      NAl^.An:=NAl^.An+1;
      AddColl.Insert(NAl); { On fera le CheckedColl.insert(NAl) plustard }
      end;
  end;

end;


procedure CheckItem(Item:Pointer);

var l1,l2:longint;
    He,Mi,Se,Jo,Mo,An,x:word;
    K:PAlarmItem;

begin
getdate(An,Mo,Jo,x);
gettime(He,Mi,Se,x);
l1:=longint(He)*3600+Mi*60+Se+Jo*86400+Mo*2678400+(An-1990)*32140800;
K:=Item;
l2:=longint(K^.He)*3600+K^.Mi*60+K^.Se+K^.Jo*86400+K^.Mo*2678400+(K^.An-1990)*32140800;
if l1>=l2 then
   begin
   AlarmRing(K);
   end;
end;


procedure AlarmRing(Al:PAlarmItem);

var R:Trect;
    RAl:PAlarmItem;
    j,m,a,x:word;

begin
getdate(a,m,j,x);
R.Assign(1,9,78,18);
Beep;
if MessageBoxRect(R,^C+Al^.Mess+#13+#13+^C+'Rappeler plus tard ?',nil,mfnobutton+mfyesButton+mfinformation)=cmno
  then ConfirmAlarm(Al)
  else begin
       RAl:=NewAlarmitem(0,0,0,0,0,0,0,Al^.Mess); { On se fait une copie pour le rappel }
       ConfirmAlarm(Al);
       if j<Maxjour[M]
          then begin
               RAl^.Jo:=j+1;
               RAl^.Mo:=m;
               RAl^.An:=a;
               end
          else if M<12 then begin
                            RAl^.Mo:=M+1;
                            RAl^.Jo:=1;
                            RAl^.an:=a;
                            end
                       else begin
                            RAl^.Jo:=1;
                            RAl^.Mo:=1;
                            RAl^.An:=A+1;
                            end;
       { Si la liste en cours de test est celle des rappels on ne peut pas
         ajouter un rappel maintenant }
       if CheckedColl=@RepeatColl
          then AddColl.Insert(RAl)  { On fera le CheckedColl.insert(RAl) plustard
                                      c.a.d le RepeatColl.insert car CheckColl=RepeatColl }
          else RepeatColl.Insert(RAl); { Ok , on ajoute dans RepeatColl maintenant }
       end;
end;

function InputAlarmItem:PAlarmItem;

var Al:PAlarmItem;
    x:word;

begin
new(Al);
getdate(Al^.an,Al^.Mo,Al^.Jo,x);
Al^.He:=0;
Al^.Mi:=0;
Al^.Se:=0;
Al^.Typ:=0;
Al^.Mess:='';

EditAlarm(Al);

if Al^.Mess='' then
   begin
   dispose(Al);
   Al:=nil;
   end;

InputAlarmItem:=Al;
end;

procedure EditAlarm(Al:PAlarmItem);

var R:TRect;
    C:PRadioButtons;
    S:PNumInputLine;
    SS:PInputLine;
    E:integer;
    Dialog:PDialog;
    Control:Word;
    V:PView;
    AlarmData:record
              Jo,Mo:string[2];
              An:string[4];
              He,Mi:string[2];
              Typ:word;
              Mess:string[255];
              end;

begin
R.Assign(0,0,45,10);
Dialog:=New(PDialog,Init(R, 'Alarme'));
with Dialog^ do
  begin
  R.Assign(33,2,44,4);
  V:=(New (PButton, Init(R,'Ok', cmok, bfDefault)));
  V^.HelpCtx:=haokbtn;
  insert(V);
  R.Assign(33,4,44,6);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hacancelbtn;
  insert(V);

  R.Assign(9,6,13,7);
  S:=New(PNumInputLine, Init(R, 2,1,31,^C+'Jour incorrect'));
  S^.HelpCtx:=haMoisAlarm;
  insert(S);
  R.Assign(1,6,9,7);
  Insert(New(PLabel, Init(R, '~J~our : ' , S)));
  R.Assign(22,6,26,7);
  S:=New(PNumInputLine, Init(R, 2,1,12,^C+'Mois incorrect'));
  S^.HelpCtx:=haMoisAlarm;
  insert(S);
  R.Assign(14,6,22,7);
  Insert(New(PLabel, Init(R, 'Mois : ' , S)));
  R.Assign(36,6,42,7);
  S:=New(PNumInputLine, Init(R, 4,1990,2050,^C+'Anne incorrecte'));
  S^.HelpCtx:=haAnneeAlarm;
  insert(S);
  R.Assign(27,6,36,7);
  Insert(New(PLabel, Init(R, 'Anne : ' , S)));

  R.Assign(28,2,32,3);
  S:=New(PNumInputLine, Init(R, 2,0,23,^C+'Heure incorrecte'));
  S^.HelpCtx:=haHeureAlarm;
  insert(S);
  R.Assign(18,2,28,3);
  Insert(New(PLabel, Init(R, '~H~eure  : ' , S)));
  R.Assign(28,4,32,5);
  S:=New(PNumInputLine, Init(R, 2,0,59,^C+'Heure incorrecte'));
  S^.HelpCtx:=haMinutAlarm;
  insert(S);
  R.Assign(18,4,28,5);
  Insert(New(PLabel, Init(R, 'M~i~nute : ' , S)));

  R.assign(3,2,18,5);
  C:=New(PRadioButtons, Init(R, NewSItem('~N~ormal',
                                NewSItem('~M~ensuel',
                                NewSItem('~A~nnuel',
                                nil)))));
  C^.HelpCtx:=haRadioBtn;
  insert(C);
  R.Assign(1,1,15,2);
  Insert(New(PLabel, Init(R, '~T~ype : ' , C)));

  R.Assign(11,8,43,9);
  SS:=New(PInputLine, Init(R,255));
  SS^.helpCtx:=hamessage;
  insert(SS);
  R.Assign(1,8,11,9);
  Insert(New(PLabel, Init(R, 'M~e~ssage : ' , SS)));

  Str(Al^.An:4,AlarmData.An);
  Str(Al^.Mo:2,AlarmData.Mo);
  Str(Al^.Jo:2,AlarmData.Jo);
  Str(Al^.He:2,AlarmData.He);
  Str(Al^.Mi:2,AlarmData.Mi);
  AlarmData.Typ:=Al^.Typ;
  AlarmData.Mess:=Al^.Mess;
  SetData(AlarmData);
  Options:=Options or ofCentered;
  helpctx:=haAlarmBox;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then ;
Dialog^.GetData(AlarmData);

R.assign(20,5,60,12);

val(AlarmData.An,Al^.An,E);
val(AlarmData.Mo,Al^.Mo,E);
val(AlarmData.Jo,Al^.Jo,E);
val(AlarmData.He,Al^.He,E);
val(AlarmData.Mi,Al^.Mi,E);
Al^.Typ:=AlarmData.Typ;
Al^.Mess:=AlarmData.Mess;
Dispose(Dialog,Done);
end;


procedure RegisterAlarmColl;

begin
RegisterType(RAlarmColl);
end;


begin  { INITIALISATION }
Incheck:=false;
AddColl.Init(0,1);
DelColl.Init(0,1);
end.