{ Unit de turbo vision pour comptabilit - VIEW }

unit COMPTE;

{$O+}
{$F+}
{$B-}
{$X+}
{$R-} {Il semble que le code de cette unit soit trop gros pour faire du range checking ! }

INTERFACE

uses Crt,Dos,Views,Objects,Drivers,Dialogs,App,XBeep,MsgBox,stdbox,Xprint,vbudhelp,comptec;

{ Objet affichant le montant total d'une zone selecte }

type PTotalFen = ^TTotalFen;
     TTotalFen = object(TWindow)

       procedure sizelimits(var Min,Max:Tpoint); virtual;
       procedure Draw; virtual;
       destructor Done; virtual;
       end;


{ Objet Compte - S'occupe du contenu du compte - Insr dans FenCpt }

type  PCompte = ^TCompte;
      TCompte = object(TScroller)
        Modif:PBoolean;                          { Modif^ est vrai si compte modif }
        RFicName:string;                         { Nom du fichier disque contenant le compte (avec repertoire) }
        LastSave:string[30];                     { Message indiquant la dernire sauvegarde }
        SelecZone:TRect;                         { Zone slct dans le compte - En surbrillance }
        CaseCour:TPoint;                         { Position du curseur }
        WasDown,WasDouble:Boolean;               { Flag pour souris }
        Solde,SoldeS,Credit,CreditS:Real;        { Valeur calcules  partir du compte et mise  jour  chaque modif }
        OSolde,OSoldeS,OCredit,OCreditS:Real;    { Correpond  la copie sur disque (old value) des valeurs ci dessus }
        Editstr:string[MAX_LG_LIB];              { Tampon d'dition }
        EditMode:Boolean;                        { Indique si on est en mode dition }
        EditCur:byte;                            { Position du curseur d'dition (sur X) }
        EditLineSaved:integer;                   { Ligne en cours d'dition, utile si scrolling pendant edition }
        Lignes:TabLignes;                        { Tableau des lignes du compte - Alloues dynamiquement }
        NbLignes:integer;                        { Nombre de lignes valide dans le tableau ci-dessus }

        constructor Init(var Bounds:Trect; BarPar:PScrollBar; Name:TNAME; Rep:string);
        destructor Done; virtual;
        procedure Draw; virtual;
        procedure HandleEvent(var Event:TEvent);  virtual;
        function GetTyp:string;                                  { Renvoi le type choisi dans la boite de dialogue }
        function Selected(L:integer; Z:byte):boolean; virtual;   { Vrai si Ligne(Z), Zone(Z) slct }
        function FindCase(X:integer):byte; virtual;              { Retourne n de zone correpondant  abcisse X }
        procedure CursorSet; virtual;                            { Redessine le curseur au bon endroit }
        procedure CreerLigne(L:integer);                         { Creer une ligne dans le tableau de lignes }
        procedure LineInsert(L:integer);                         { Insre une ligne dans le tableau de lignes }
        procedure LineDelete(L:integer);                         { Dtruit une ligne dans le tableau de lignes }
        procedure MakeVisible(L:integer);                        { Scrolle pour rendre une ligne visible }
        procedure CopierSolde(SelSolde:Boolean);                 { Copier dans presse papier }
        procedure Copier(Z:TRect);                               { Copier dans presse papier }
        procedure Couper(Z:TRect);                               { Couper et placer dans presse-papier }
        procedure Coller(var Z:TRect; L:integer; C:Byte);        { Colle le presse-papier en Ligne , Case }
        function ControleDate(Date:string):string;               { Verifie si la date est correcte , retourne '' sinon }
        procedure Charger;                                       { Charge le compte depuis le disque }
        procedure Sauver;                                        { Sauve le compte sur le disque }
        procedure Calculate;                                     { Recalcule les valeurs du compte }
        procedure SelCalculate;                                  { Recalcule les valeurs de la zone selecte }
        procedure Search(Mont:real);                             { Recherche un solde egal  Mont }
        procedure Class(Z:TRect;Option:Byte);                    { Classe la slection selon 0:Sel 1:Date 2:Lib
                                                                                             + 4:Inverse ordre  }

      end;


{ Objet affichant le status du compte, c'est  dire solde et crdit - Insr dans FenCpt }

type PCptStatus = ^TCptStatus;
     TCptStatus = object(TView)
        VCompte:PCompte;

        constructor Init(Bounds:TRect;CptPointeur:PCompte);
        procedure Draw; virtual;
        procedure update; virtual;

     end;


{ Objet reprsentant le fenetre du compte. Elle  un pointeur vers le compte.
  Elle rfrence le compte dans CptList lors de sa cration.

    Valid teste si le compte est en dition et renvoi toujour faux dans ce cas
    Valid teste si le compte est sauv et propose de sauver, pas sauver et annuler
     (Commande teste : cmquit et cmclose }

type PFenCpt = ^TFenCpt;
     TFenCpt = object(TWindow)
        VCompte:PCompte;          { Pointeur vers le compte courant }
        VCptStatus:PCptStatus;    { Pointeur vers la fenetre status du compte }
        VLegend:PLegend;          { pointeur vers la fenetre lgende du compte }

        CptDef:TCptDef;  { Dfinition du compte (caractristiques }

        constructor Init(Bounds:TRect; var Cpt:TCptDef);
        destructor Done; virtual;
        function valid(com:word):boolean; virtual;
        procedure SizeLimits(var Min,Max:TPoint); virtual; { Permet de fixer la taille minimum de la fenetre }
        procedure HandleEvent(var Event:TEvent); virtual;
        procedure printCpt;                                { Permet d'imprimer un compte }
     end;


{ Objet affichant le status de la fenetre , c'est  dire date, nom ,heure de sauvegarde, ...
         - Insr dans FenCpt
}

type PFenStatus = ^TFenStatus;
     TFenStatus = object(TView)
        FenCpt:PFenCpt;

        constructor Init(Bounds:TRect; Fenetre:PFenCpt);
        procedure Draw; virtual;
        procedure update; virtual;

     end;



{ Objet permettant de rfrencer tous les comptes (fenetre compte) ouvert.
  Elle effectue la propagation des modifs sur les comptes identiques et lis }

type PCptList = ^TCptList;
     TCptList = object(TObject)
     Tableau:array[1..MAX_CPT] of PFenCPT;


      constructor Init;
      procedure Reference(Ref:PFenCpt);
      procedure UnReference(Ref:PFenCpt);
      function  LastOne(Cpt:PCompte):boolean;                   { Indique si Cpt est le dernier des copies }
      procedure SaveAll;                                        { Appelle la mthode sauver de tous les comptes }
      procedure PrintAll;                                       { Appelle la mthode print de toutes le fenetres compte }
      procedure IdMAJ(Cpt:PCompte);                             { Mais a jour les comptes identique  Cpt }
      procedure IdCOPY(Cpt:PCompte);                            { Recopie entirement les comptes identique  Cpt }
      function  Charger(Cpt:PCompte):boolean;                   { Charge un compte en mmoire ou copie s'il existe une copie}
      procedure MemMAJ(Cpt:PCompte; add,sadd:real);             { Mise  jour des comptes lis en mmoire CreditI/Solde }
      procedure OMemMAJ(Cpt:PCompte; add,sadd:real);            { Mise  jour des comptes lis en mmoire OCreditI/OSolde }
      procedure CherchePrec(Cpt:PCompte; var add,sadd:real);    { Cherche le premier mois prcdent Cpt (en memoire) }
      procedure DiskMAJ(Cpt:PCompte; add,sadd:real);            { Mise  jour des comptes lis sur disque }
      procedure DiskPrec(Cpt:PCompte; var Credit,CreditS:real); { Cherche le compte prcdent sur disque }

        destructor Done; virtual;

        end;


{ Type d'un tableau rsultat pour bilan d'un compte par type (TypBilan) }

type  TTabResEntry = record
                     Cre,Deb:real;                  { Crdit et Dbit }
                     Typ:string[LG_TYP];            { Type de mouvement }
                     end;
      TTabResult = array [1..MaxTotalType] of TTabResEntry;


{ Groupe de procdures gnrales de traitement ... }

procedure InvPressPap;
{ Inverse les colones Debit et Credit du presse papier }

procedure MakeName(var Cpt:TCptDef; var Nom:TNAme; var Info:ECatalog);
{ Creer un nom de fichier et eventuellement une entre dans le catalogue }

procedure ModifName(var Cpt,NewDef:TCptDef; var Nom:TName; var Info:ECatalog);
{ Modifie les caractristiques de Cpt avec NewDef et Info. }

function ExistCpt(Name:string;LG:byte):boolean;
{ Verifie si un compte existe dans le catalogue(compare LG caractres) }

function MakeList(var List:PStringCollection):boolean;
{ Insere dans List tous les noms de compte du catalogue, retourne vrai si pas vide }

procedure DelName(Cpt:TCptDef);
{ Efface une entre du catalogue }

procedure VidePressPap;
{ Vide le presse papier }

procedure CopyTo(Sour,Dest:TCptDef; var CreSol,SCreSol:real; premier,dernier:boolean);
{ Copie de compte Sour vers compte Dest
    - CreSol et SCreSol : En entree Credit initial, en sorti solde final
    - si premier alors CreSolx ingor en entre car calcul
    - si dernier alors propagation aux suivants de Dest
}

function CheckYear(Dest:TCptDef):boolean;
{ Verifie si une anne existe - Au moins un compte crer (Prev ou normal) }

function CheckMonth(Dest:TCptDef):boolean;
{ Verifie si un mois existe - Au moins un compte crer (Prev ou normal) }

procedure Bilan(Cpt:TCptDef); { Bilan du compte Cpt (Normal + Prvision) }

procedure TypBilan(Cpt:TCptDef; var fic:Text; var nbtyp:integer; dowr:boolean);
   { Bilan du compte Cpt (Normal seulement) par Typ }


var   CptPressPap:PFenCpt; { Compte fictif : Presse Papier }
      FenOpen:Array[1..9] of Boolean;  { Fenetre ouverte parmis le 9 premires }
      LastCptDef:TCptDef;              { Definition du dernier Compte }
      Format:byte;                     { Format d'impression : 1 = Carnet }
      CptList:TCptList;                { Liste des comptes actifs }
      TotalFen:PTotalFen;              { Fenetre d'affichage de Total et TotalS }
      DrawOn:boolean;                  { Affichage ou non }
      MacRead:boolean;                 { Lecture Macro en cours ou non }

{ Lors d'une modif du lib juste mettre a jour les autre compte referenc.

  On doit avoir vieux( au load ou au create ) et nouveau solde et credit .
  Ceci en vu d'une mise a jour lors d'un load d'un compte suivant un deja
  charg.

  Deplus , on peut autoriser l'utilisateur a ne pas sauver un compte. Il
  suffit alors de modifier tous les comptes qui le suivent en tenant compte
  de son ancien solde et de son nouveau solde.

  Attention:

    - Quand on sauve un compte :
         - Avant de sauver on calcule
              . avt=noucre-oldcre    (ce que les cpt avant ont ajout)
              . noucre=oldcre
              . noudeb=noudeb-avt
         - add=nousol-oldsol         (ce que nous on a ajout)
         - On sauve les valeurs nou...
         - Tous ses suivant sont mis a jour sur le disque (credit et solde) cre=cre+add sol=sol+add
         - Tous ses suivant sont mis a jour a memoire:
|AUTO|        . oldcre=oldcre+add
|AUTO|        . olddeb=olddeb+add
         - Sur le compte sauver (si reutilis aprs)
              . noucre=noucre+avt   ( restitue les valeurs courante )
              . olddeb=noudeb
              . noudeb=noudeb+avt

    - Quand on charge un compte (pas encore charge / sinon c'est une recopie)
         - Le credit et solde lu sont mis dans old...
         - Si pas de mois antrieur charg alors recopier old... dans nou...
           sinon       (* est le plus pres des mois antrieurs )

              . add= *nousol-*oldsol

              . noucre=oldcre+add
              . nousol=oldsol+add

    - Quand on modifie un compte:
         - On calcule old=nousol
         - On recalcule nousol a partir de noucre et tableau.
         - On a : new=nousol
         - Pour tous les mois le suivant en memoire faire:
              . noucre=noucre+(new-old)
              . nousol=nousol+(new-old)

    - Quand on ferme un compte (le dernier si plusieurs) sans le sauver.
         - On n'ecrit rien sur disque
         - On calcule sub=(nousol-oldsol)-(noucre-oldcre)
         - On met a jour tous les mois le suivant en memoire:
              . noucre=noucre-sub
              . nousol=nousol-sub

  Note: - Les valeurs affichs  l'cran sont toujours les nou...
        - Les comptes identique ont exactement les mmes valeur old... et nou...


  Remarque: - Il faut avoir old... et nou... mais aussi sold... et snou...
              Les rgle de calcul etant identique pour s......

            - On peut eviter d'avoir les valeurs old, il faut alors quand on
              en a besoin les charger depuis le disque (car elle doivent
              toujours correpondre). Les opration prcds de |AUTO| sont
              alors inutile car automatique.

}

IMPLEMENTATION

const kbshift=kbRightShift+kbLeftShift;      { Touche shift presse (droite ou gauche) }
      kbctrl=kbCtrlShift;                    { Touche Ctrl presse }
      kbAlt=kbAltshift;                      { Touche Alt presse }

var KeyState:byte absolute $40:$17;
    tabresult:^TTabresult;


{ =====> Procedure de trvail Get String Date <====== }

function GetStringDate:String;

var jo,mo,an,js:word;
    Date,NUM:string;
    i:byte;

begin
getdate(An,Mo,Jo,Js);
str(Jo:2,NUM);
Date:=NUM+'/';
str(Mo:2,NUM);
Date:=Date+NUM+'/';
str(An:4,NUM);
Date:=Date+copy(NUM,3,2);
for i:=1 to length(Date) do if Date[i]=' ' then Date[i]:='0';
GetStringdate:=Date;
end;

{ =====> Procedure de travail: GetMontant <====== }

function GetMontant(var Mont:real):boolean;

var Res:String[10];
    R,RR:Trect;
    S:PInputLine;
    E:Integer;

begin
R.Assign(16,1,26,2);
S:=New(PInputLine, Init(R, 10));
S^.HelpCtx:=hcTSMont;
R.Assign(1,1,16,2);
RR.Assign(0,0,30,3);
Res:='';
LabelInputBox(RR,S,New(PLabel, Init(R, '~S~olde cherch : ' , S)),hcTSearch,Res);
Val(Res,Mont,E);
GetMontant:=(Res<>'') and (E=0);
end;


{ =====> Procedure de travail: SelectClassMode <====== }

function SelectClassMode:Byte;

var R:TRect;
    C:PRadioButtons;
    D:PCheckBoxes;
    Dialog:PDialog;
    Control:Word;
    CData:record
          Rev:word;
          Ordre:word;
          end;
    ERR:integer;
    V:PView;

begin
R.Assign(12,5,68,15);
Dialog:=New(PDialog,Init(R, 'Classement de la slection'));
with Dialog^ do
  begin
  helpctx:=hcTClass;
  R.Assign(7,7,17,9);
  V:=(New (PButton, Init(R,' ~O~k', cmok, bfDefault)));
  V^.helpCtx:=hcnocontext;
  insert(V);
  R.Assign(30,7,43,9);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.HelpCtx:=hcCancelBtn;
  insert(V);

  R.assign(30,3,50,4);
  D:=New(PCheckBoxes, Init(R, NewSItem('~R~enverse Ordre',
                              nil)));
  d^.helpCtx:=hcTCRev;
  insert(D);

  R.assign(2,3,28,6);
  C:=New(PRadioButtons, Init(R, NewSItem('~S~lecteur',
                                NewSItem('~D~ate',
                                NewSItem('~L~ibell',
                                nil)))));
  C^.helpCtx:=hcTCSel;
  insert(C);
  R.Assign(2,2,32,3);
  insert( new(PLabel, Init(R, '~C~lassement par', C)));

  CData.Ordre:=1;
  CData.Rev:=0;
  SetData(CData);
  Options:=Options or ofCentered;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then exit;
Dialog^.GetData(CData);

Dispose(Dialog,Done);

SelectClassMode:=CData.Ordre+1+4*CData.Rev;

end;


{ =====> Procedure utilisateur: Vide Presse Papier <====== }

procedure VidePressPap;

var i:integer;

begin
for i:=0 to CptPressPap^.VCompte^.NbLignes-1 do dispose(CptPressPap^.VCOmpte^.Lignes[i]);
CptPressPap^.VCompte^.NbLignes:=0;
CptPressPap^.VCompte^.calculate;
CptPressPap^.VCompte^.setLimit(0,1);
CptList.IdCopy(CptPressPap^.VCompte);
end;



{ =====> Procedure de travail: Num <====== }

procedure Num(S:string; var R:Real); { Convertit String vers Real }

var i:integer;

begin
val(S,R,i);
if i<>0 then val(copy(S,1,i-1),R,i);
if i<>0 then R:=0;
end;


{ =====> Procedure de travail: EraseAll <====== }

procedure EraseAll(N:TName);  { Efface tous les fichiers de nom N }

 var F:File;
     S:SearchRec;

begin

FindFirst(N,AnyFile,S);
while DosError=0 do
  begin
  assign(F,S.Name);
  reset(F);
  close(F);
  erase(F);
  FindNext(S);
  end;
end;


{ ========> Procedure utilisateur: Exist Cpt <========== }

function ExistCpt(Name:string;LG:byte):boolean;

var Catalog:FCatalog;
    i:integer;
    E:ECatalog;
    An:string[4];

begin
ExistCpt:=False;
assign(Catalog,CATALOG_NAME);
{$I-}
reset(Catalog);
{$I+}
if ioresult<>0 then exit;
E.Name:='';
for i:=0 to filesize(Catalog)-1 do
  begin
  read(Catalog,E);
  if E.Valid and (copy(E.Name,1,LG)=copy(Name,1,LG)) then ExistCpt:=true;
  end;

close(Catalog);
end;


{ =======> Procedure utilisateur: Check Year <============ }

function CheckYear(Dest:TCptDef):boolean;

begin
CheckYear:=false;
for Dest.Mois:=1 to 12 do
  if CheckMonth(Dest) then
     begin
     CheckYear:=true;
     exit;
     end;
end;


{ =======> Procedure utilisateur: Check Month <============ }
function CheckMonth(Dest:TCptDef):boolean;

var Nom:TName;
    E:ECatalog;
    F:File;

begin
CheckMonth:=false;
Dest.Prev:=false;
MakeName(Dest,Nom,E);
assign(F,Nom);
{$I-}
reset(F);
{$I+}
if ioresult=0 then
   begin
   close(F);
   CheckMonth:=true;
   exit;
   end;
Dest.Prev:=true;
MakeName(Dest,Nom,E);
assign(F,Nom);
{$I-}
reset(F);
{$I+}
if ioresult=0 then
   begin
   close(F);
   CheckMonth:=true;
   exit;
   end;
end;



{ ========> Procedure utilisateur: MakeName <========== }

procedure MakeName(var Cpt:TCptDef; var Nom:TName; var Info:ECatalog);

var Catalog:FCatalog;
    E:ECatalog;
    i:integer;
    An:string[4];
    Mo:byte;
    {$ifdef DEMOVER}
    _A,_M,_J,_JS:word;
    {$endif}


    { Note le champ E.valid sert pour dire si le compte est valide }

begin
assign(Catalog,CATALOG_NAME);
{$I-}
reset(Catalog);
{$I+}
if ioresult<>0 then rewrite(catalog);  { Cration du catalogue s'il n'existe pas }
i:=0;
E.Name:='';
while (i<filesize(Catalog)) and ( (E.Name<>Cpt.NAme) or (not E.Valid) ) do
  begin
  read(Catalog,E);
  inc(i);
  end;
if E.Name=Cpt.name
  then dec(i)
  else begin
       i:=0;
       seek(Catalog,0);
       E.Valid:=true;
       while (i<filesize(Catalog)) and E.Valid do
         begin
         read(Catalog,E);
         inc(i);
         end;
       if not E.Valid then dec(i);
       seek(Catalog,i);
       E:=Info;
       E.Name:=Cpt.Name;
       E.Mode:=Cpt.Mode;
       E.Valid:=True;
       E.Version:=VER_UNIT;
       {$ifdef DEMOVER}
       getdate(_A,_M,_J,_JS);
       E.DateDemo:=longint(_A)*365+longint(_M)*12+longint(_J);
       {$endif}
       write(Catalog,E);
       end;

{$ifdef DEMOVER}
getdate(_A,_M,_J,_JS);
if (longint(_A)*365+longint(_M)*12+longint(_J))>E.DateDemo+15 then PERIME:=true;
if E.DateDemo>(longint(_A)*365+longint(_M)*12+longint(_J)) then PERIME:=true;
{$endif}
Cpt.Mode:=E.Mode;
if (Cpt.mode and mdannuel)<>mdannuel then Cpt.Annee:=0;
if (Cpt.mode and mdmensuel)<>mdmensuel then Cpt.Mois:=0;
if (Cpt.mode and mdprev)<>mdprev then Cpt.Prev:=false;
{ Pour viter un range check error dans le cas d'un appel pour des infos et
  sans avoir de nom  construire (cas de open ou modifcpt) on controle les bornes }
if Cpt.Mois>12 then Cpt.Mois:=0;
if Cpt.Mois<0 then Cpt.Mois:=0;
if Cpt.Annee>9999 then Cpt.Annee:=0;
if Cpt.Annee<0 then Cpt.Annee:=0;
Mo:=Cpt.Mois*2;
if Cpt.prev then Mo:=Mo+1;
str(Cpt.Annee,An);
An:=copy('0000',1,4-length(An))+An;
Nom:=BASE_CHAR+chr(65+i div 26)+chr(65+i mod 26)+An+chr(65+Mo)+'.'+BASE_EXT;
close(Catalog);
Info:=E;
end;


{ ========> Procedure utilisateur: ModifName <========== }

procedure ModifName(var Cpt,NewDef:TCptDef; var Nom:TName; var Info:ECatalog);

var Catalog:FCatalog;
    E:ECatalog;
    i:integer;
    An:string[4];
    Mo:byte;

    { Note le champ E.valid sert pour dire si le compte est valide }

begin
assign(Catalog,CATALOG_NAME);
{$I-}
reset(Catalog);
{$I+}
if ioresult<>0 then exit;
i:=0;
E.Name:='';
while (i<filesize(Catalog)) and ( (E.Name<>Cpt.NAme) or (not E.Valid) ) do
  begin
  read(Catalog,E);
  inc(i);
  end;
if E.Name=Cpt.name
  then dec(i)
  else begin
       close(Catalog);
       exit;
       end;

Cpt.Mode:=E.Mode;
E:=Info;
E.name:=NewDef.Name;
E.Mode:=NewDef.mode;
E.Valid:=true;
E.Version:=VER_UNIT;
seek(Catalog,i);
write(Catalog,E);
if (Newdef.mode and mdannuel)<>mdannuel then NewDef.Annee:=0;
if (NewDef.mode and mdmensuel)<>mdmensuel then NewDef.Mois:=0;
if (Newdef.mode and mdprev)<>mdprev then NewDef.Prev:=false;
Mo:=NewDef.Mois*2;
if NewDef.prev then Mo:=Mo+1;
str(Cpt.Annee,An);
An:=copy('0000',1,4-length(An))+An;
Nom:=BASE_CHAR+chr(65+i div 26)+chr(65+i mod 26)+An+chr(65+Mo)+'.'+BASE_EXT;
close(Catalog);
Info:=E;
for i:=1 to MAX_CPT do
 if (CptList.Tableau[i]<>nil) and (CptList.Tableau[i]^.CptDef.Name=Cpt.Name) then
   begin
   CptList.Tableau[i]^.VLegend^.LIB1:=E.LIB1;
   CptList.Tableau[i]^.VLegend^.LIB2:=E.LIB2;
   CptList.Tableau[i]^.VLegend^.LIB3:=E.LIB3;
   CptList.Tableau[i]^.CptDef.Name:=E.Name;
   CptList.Tableau[i]^.CptDef.Mode:=E.Mode;
   disposestr(CptList.Tableau[i]^.Title);
   CptList.Tableau[i]^.Title:=newstr(E.Name);
   CptList.Tableau[i]^.ReDraw;
   end;
end;


{ ========> Procedure utilisateur: MakeList <========== }

function MakeList(var List:PStringCollection):boolean;

var Catalog:FCatalog;
    i:integer;
    E:ECatalog;
    An:string[4];

begin
MakeList:=false;
assign(Catalog,CATALOG_NAME);
{$I-}
reset(Catalog);
{$I+}
if ioresult<>0 then exit;
E.Name:='';
for i:=0 to filesize(Catalog)-1 do
  begin
  read(Catalog,E);
  if E.Valid then begin
                  List^.insert(NewStr(E.Name));
                  MakeList:=true;
                  end;
  end;

close(Catalog);
end;



{ ===============> Procedure utilisateur : DEL NAME <=============== }

procedure DelName(Cpt:TCptDef);

var Catalog:FCatalog;
    i:integer;
    E:ECatalog;
    Nom:TName;

begin
assign(Catalog,CATALOG_NAME);
{$I-}
reset(Catalog);
{$I+}
if ioresult<>0 then exit;
i:=0;
E.Name:='';
while (i<filesize(Catalog)) and ( (E.Name<>Cpt.NAme) or (not E.Valid) ) do
  begin
  read(Catalog,E);
  inc(i);
  end;
if E.Name=Cpt.name
  then begin
       dec(i);
       E.Valid:=false;
       seek(Catalog,i);
       write(Catalog,E);
       Nom:=BASE_CHAR+chr(65+i div 26)+chr(65+i mod 26)+'*.'+BASE_EXT;
       eraseall(Nom);
       end;
close(Catalog);
end;


{ =====> Procedure utilisateur : Inverse Presse Papier <====== }

procedure InvPressPap;  { Inversion des colonnes slects seulement }

var i,deb,fin:integer;
    Temp:real;

begin
deb:=CptPressPap^.VCOmpte^.Seleczone.A.Y;
fin:=CptPressPap^.VCOmpte^.Seleczone.B.Y-1;
for i:=deb to fin do
  begin
  Temp:=CptPressPap^.VCompte^.Lignes[i]^.Cre;
  CptPressPap^.VCompte^.Lignes[i]^.Cre:=CptPressPap^.VCompte^.Lignes[i]^.Deb;
  CptPressPap^.VCompte^.Lignes[i]^.Deb:=Temp;
  end;
CptPressPap^.VCompte^.calculate;
CptList.IdCOPY(CptPressPap^.VCompte);
end;


{ +--------------------------------------------------------------------+  }
{ |                          >  TotalFen  <                            |  }
{ +--------------------------------------------------------------------+  }



{ ----------------> DRAW <----------------}

procedure TTotalFen.Draw;

var B:TDrawBuffer;
    C:Byte;
    S1,S2:string;

begin
 if macread and not DrawOn then begin Tview.Draw; exit end;
 TWindow.Draw;
 C:= getcolor(2); { 6 }
 MoveChar(B,' ',C,Size.X);
 str(Total:10:2,S1);
 str(TotalS:10:2,S2);
 MoveStr(B,' Total:'+S1+'  -  avec selecteur:'+S2,C);
 Writeline(1,1,Size.X-2,1,B);
end;

{ ----------------> SizeLimits <----------------}

procedure TTotalFen.sizelimits(var Min,Max:Tpoint);

begin
Min.X:=10;
Min.Y:=3;
Max.X:=50;
Max.Y:=3;
end;

{ ----------------> Done <----------------}

destructor TTotalFen.Done;

begin
TWindow.Done;
TotalFen:=nil;
end;




{ +--------------------------------------------------------------------+  }
{ |                           TCptStatus                               |  }
{ +--------------------------------------------------------------------+  }


{ ----------------> INIT <----------------}

Constructor TCptStatus.Init(Bounds:TRect;CptPointeur:PCompte);

begin
TView.Init(Bounds);
GrowMode:=GfGrowHix+GfGrowHiy+GfGrowLoY;
options:=options+offramed;
VCompte:=CptPointeur;
end;

{ ----------------> DRAW <----------------}

procedure TCptStatus.Draw;

const LIB1=' SOLDE  : ';
      LIB2=' avec selecteur : ('; LIB2f=') ';
      LIB3=' CREDIT : ';
      LIB4=' avec selecteur : ('; LIB4f=') ';


var Buf:TDrawBuffer;
    P,Color,ColorS:byte;
    NUM:string;

begin
if macread and not DrawOn then begin Tview.Draw;  exit; end;
Color:=getcolor(1);
ColorS:=getcolor(2);
MoveChar(Buf,' ',Color,size.X);
P:=0;

if LIB1<>'' then
  begin
  Movestr(Buf[P],LIB1,Color);
  P:=P+length(LIB1);
  str(VCompte^.Solde:8:2,NUM);
  MoveStr(Buf[P],NUM,ColorS);
  P:=P+10;
  end;

if LIB2<>'' then
  begin
  Movestr(Buf[P],LIB2,Color);
  P:=P+length(LIB2);
  str(VCompte^.SoldeS:8:2,NUM);
  MoveStr(Buf[P],NUM,ColorS);
  P:=P+10;
  Movestr(Buf[P],LIB2f,Color);
  P:=P+length(LIB2f);
  end;
Writeline(0,1,Size.x,1,Buf);

MoveChar(Buf,' ',Color,size.X);
P:=0;
if LIB3<>'' then
  begin
  Movestr(Buf[P],LIB3,Color);
  P:=P+length(LIB3);
  str(VCompte^.Credit:8:2,NUM);
  MoveStr(Buf[P],NUM,ColorS);
  P:=P+10;
  end;

if LIB4<>'' then
  begin
  Movestr(Buf[P],LIB4,Color);
  P:=P+length(LIB4);
  str(VCompte^.CreditS:8:2,NUM);
  MoveStr(Buf[P],NUM,ColorS);
  P:=P+10;
  Movestr(Buf[P],LIB4f,Color);
  P:=P+length(LIB4f);
  end;
Writeline(0,0,Size.x,1,Buf);

end;

procedure TCptStatus.update;   { = DrawView pour l'instant }

begin
DrawView;
end;

{ +--------------------------------------------------------------------+  }
{ |                           TFenStatus                               |  }
{ +--------------------------------------------------------------------+  }


{ ----------------> INIT <----------------}

Constructor TFenStatus.Init(Bounds:TRect; Fenetre:PFenCpt);

begin
TView.Init(Bounds);
GrowMode:=GfGrowHix+GfGrowHiy+GfGrowLoY;
FenCpt:=Fenetre;
end;

{ ----------------> DRAW <----------------}

procedure TFenStatus.Draw;

const LIBDS='Dernire sauvegarde le ';
      LIBAN='  Anne : ';
      LIBMO='  Mois : ';
      LIBNOPR='  Mode: ';
      LIBNO='Normal';
      LIBPR='Prvision';

var Buf:TDrawBuffer;
    P,Color,ColorS:byte;
    NUM:string;

begin
if macread and not DrawOn then begin Tview.Draw;  exit; end;
Color:=getcolor(1);
ColorS:=getcolor(2);
MoveChar(Buf,' ',Color,size.X);
P:=0;
if (FenCpt^.CptDef.Mode and mdannuel)=mdannuel then
  begin
  str(FenCpt^.CptDef.Annee:4,NUM);
  Movestr(Buf[P],LIBAN,Color);
  P:=P+length(LIBAN);
  Movestr(Buf[P],NUM,ColorS);
  P:=P+4;
  end;
if (FenCpt^.CptDef.Mode and mdmensuel)=mdmensuel then
  begin
  case FenCpt^.CptDef.Mois of
    1:NUM:='JANVIER';
    2:NUM:='FEVRIER';
    3:NUM:='MARS';
    4:NUM:='AVRIL';
    5:NUM:='MAI';
    6:NUM:='JUIN';
    7:NUM:='JUILLET';
    8:NUM:='AOUT';
    9:NUM:='SEPTEMBRE';
    10:NUM:='OCTOBRE';
    11:NUM:='NOVEMBRE';
    12:NUM:='DECEMBRE';
   end;
  Movestr(Buf[P],LIBMO,Color);
  P:=P+length(LIBMO);
  Movestr(Buf[P],NUM,ColorS);
  P:=P+length(NUM);
  end;
if (FenCpt^.CptDef.Mode and mdprev)=mdprev then
  if FenCpt^.CptDef.Prev then begin
                              Movestr(Buf[P],LIBNOPR,Color);
                              P:=P+length(LIBNOPR);
                              Movestr(Buf[P],LIBPR,ColorS);
                              end
                         else begin
                              Movestr(Buf[P],LIBNOPR,Color);
                              P:=P+length(LIBNOPR);
                              Movestr(Buf[P],LIBNO,ColorS);
                              end;

Writeline(0,0,Size.x,1,Buf);
MoveChar(Buf,' ',Color,size.X);
P:=1;
{ ??? } MoveStr(Buf[P],FenCpt^.CptDef.Repert,Color); P:=P+Length(FenCpt^.CptDef.Repert)+1;
if FenCpt^.VCompte^.LastSave<>''
          then Movestr(Buf[P],LIBDS+FenCpt^.VCompte^.LastSave,Color);


Writeline(0,1,Size.x,1,Buf);

end;

procedure TFenStatus.update; { = DrawView pour l'instant }

begin
DrawView;
end;


{ +--------------------------------------------------------------------+  }
{ |                              TCompte                               |  }
{ +--------------------------------------------------------------------+  }


{ ----------------> INIT <----------------}

constructor TCompte.Init(var Bounds:TRect; Barpar:PScrollBar;Name:TNAME;Rep:string);

  var i:integer;

begin

    TScroller.Init(Bounds,nil,Barpar);
    RFicName:=Rep+Name;
    GrowMode:=GfGrowHiy+GfGrowHix;
    Options:=options or offramed;
    EventMask:=evCommand+evBroadCast+evKeyDown+evMouseDown+evMouseUp+evMouseAuto;
    setlimit(0,1);
    SelecZone.assign(0,0,0,0);
    CaseCour.X:=0;
    CaseCour.Y:=0;
    ShowCursor;
    BlockCursor;
    WasDown:=false;
    WasDouble:=false;
    Credit:=0;
    CreditS:=0;
    Solde:=0;
    SoldeS:=0;
    OCredit:=0;
    OCreditS:=0;
    OSolde:=0;
    OSoldeS:=0;
    EditMode:=false;
    EditCur:=0;
    for i:=0 to MAX_LIGNES-1 do Lignes[i]:=nil;
    NbLignes:=0;
    LastSave:='';
    Modif:=nil;
    Charger;
end;


{ ----------------> DONE <----------------}

destructor TCompte.Done;

var i:integer;
    sub,subs:real;

begin
if CptList.LastOne(@self) then     { La destruction n'est que pour le dernier }
  begin
  for i:=0 to NbLignes-1 do dispose(Lignes[i]);
  dispose(Modif);
  sub:=(Solde-OSolde)-(Credit-OCredit);
  subs:=(SoldeS-OSoldeS)-(CreditS-OCreditS);
  CptList.MemMAJ(@self,-sub,-subs);     { On annule toute modif de solde/credit sur les autres }
  end;
TScroller.Done;
end;


{ ==================> Controle Date <================ }

function TCompte.ControleDate(Date:string):string;

var jo,mo,an:word;
    E:integer;
    Fen:PFenCpt;

begin
Fen:=PFenCpt(owner);

if (not CheckDate) or (Fen^.CptDef.Prev)
  then begin
       ControleDate:=Date;
       exit;
       end;
ControleDate:='';
val(copy(Date,1,2),jo,E);
val(copy(Date,4,2),mo,E);
val(copy(Date,7,2),an,E);
if an<50 then an:=an+2000 else an:=an+1900;
if ((Fen^.CptDef.Mode and mdannuel)=mdannuel) and
    (Fen^.CptDef.Annee<>an) then
     begin
     Beep;
     if MessageBox(^C+'Anne incompatible !'+#13+#13+^C+' Confirmez vous la date ? ',
            nil,mfWarning+mfyesbutton+mfnobutton)=cmyes
       then ControleDate:=Date;
     exit;
     end;
if ((Fen^.CptDef.Mode and mdmensuel)=mdmensuel) and
    (Fen^.CptDef.Mois<>Mo) then
     begin
     Beep;
     if MessageBox(^C+'Mois incompatible !'+#13+#13+^C+' Confirmez vous la date ? ',
            nil,mfWarning+mfyesbutton+mfnobutton)=cmyes
       then ControleDate:=Date;
     exit;
     end;

ControleDate:=Date;
end;



{ ===================> Charger <=============== }

procedure TCompte.Charger;


var i:integer;
    f:file;
    Reserved:Array[1..LGRESERV] of char;
    D:array[1..7] of word;
    NUM:string[4];
    version,add,sadd:real;
    R:TRECT;VERSTR:string;

begin
{$ifdef DEMOVER}
if PERIME then
  begin
  Beep;
  MessageBox(^C+'Version demonstration prim. Plus de chargement !',nil,mfInformation+mfOkButton);
  if Modif=nil then Modif:=new(PBoolean);   { Si premier, on doit creer Modif (sinon pointage) }
  Modif^:=false;
  Credit:=0;
  CreditS:=0;
  Solde:=0;
  SoldeS:=0;
  NbLignes:=0;
  LastSave:='';
  OCredit:=Credit;
  OCreditS:=CreditS;
  OSolde:=Solde;
  OSoldeS:=SoldeS;
  Exit;
  end;
{$endif}
if not (CptList.Charger(@self)) then    { Si pas dja en mmoire }
  begin
  if Modif=nil then Modif:=new(PBoolean);   { Si premier, on doit creer Modif (sinon pointage) }
  Modif^:=false;
  if RFicName=PP_NAME then { Cas du presse papier }
     begin
     Credit:=0;
     CreditS:=0;
     Solde:=0;
     SoldeS:=0;
     NbLignes:=0;
     LastSave:='';
     OCredit:=Credit;
     OCreditS:=CreditS;
     OSolde:=Solde;
     OSoldeS:=SoldeS;
     modif^:=false;
     exit;
     end;
  assign(f,RFicName);
  {$I-}
  reset(f,1);
  {$I+}
  if ioresult<>0 then
     begin  { Ce compte n'existe pas , il faut donc chercher une prcdent }
     CptList.DiskPrec(@self,Credit,CreditS);
     OCredit:=Credit;
     OCreditS:=CreditS;
     OSolde:=OCredit;
     OSoldeS:=OCreditS;
     CptList.CherchePrec(@self,add,sadd);
     Credit:=Credit+add;
     CreditS:=CreditS+sadd;
     Solde:=Credit;
     SoldeS:=CreditS;
     exit;
     end;
  blockread(f,version,sizeof(version));

  blockread(f,Credit,sizeof(Credit));
  blockread(f,CreditS,sizeof(CreditS));
  blockread(f,Solde,sizeof(Solde));
  blockread(f,SoldeS,sizeof(SoldeS));

  Credit:=round(Credit*100)/100;
  CreditS:=round(CreditS*100)/100;
  Solde:=round(Solde*100)/100;
  SoldeS:=round(SoldeS*100)/100;

  { Lecture de la date et heure }
  blockread(f,D,sizeof(D));

  { Lecture d'une zone reserve }
  blockread(f,Reserved,LGRESERV);

  { Destruction du tableau de ligne prcdent }
  if NbLignes>0 then for i:=0 to NbLignes-1 do dispose(Lignes[i]);

  { Lecture du tableau de lignes }
  blockread(f,NbLignes,sizeof(NbLignes));
  for i:=0 to NbLignes-1 do
   if i<MAX_LIGNES then
    begin
    New(Lignes[i]);
    blockread(f,Lignes[i]^,sizeof(TLigne));
    end;
  close(f);
  LastSave:='';
  str(D[3]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
  LastSave:=LastSave+NUM+'/';
  str(D[2]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
  LastSave:=LastSave+NUM+'/';
  str(D[1]:4,NUM);
  LastSave:=LastSave+NUM+'  ';
  str(D[5]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
  LastSave:=LastSave+NUM+':';
  str(D[6]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
  LastSave:=LastSave+NUM+':';
  str(D[7]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
  LastSave:=LastSave+NUM+' ';
  OCredit:=Credit;
  OCreditS:=CreditS;
  OSolde:=Solde;
  OSoldeS:=SoldeS;
  CptList.CherchePrec(@self,add,sadd);
  Credit:=Credit+add;
  CreditS:=CreditS+sadd;
  Solde:=Solde+add;
  SoldeS:=SoldeS+sadd;

  Credit:=round(Credit*100)/100;
  CreditS:=round(CreditS*100)/100;
  Solde:=round(Solde*100)/100;
  SoldeS:=round(SoldeS*100)/100;
  OCredit:=round(OCredit*100)/100;
  OCreditS:=round(OCreditS*100)/100;
  OSolde:=round(OSolde*100)/100;
  OSoldeS:=round(OSoldeS*100)/100;


  modif^:=false;
  end;

setlimit(0,NbLignes+1);
DrawView;
end;

{ ==============> Calculate <============ }

procedure TCompte.Calculate;

var i:integer;
    add,addS,dif:real;
    action:boolean;

begin
add:=Solde;
addS:=SoldeS;
action:=false;

SoldeS:=CreditS;
Solde:=Credit;
Dif:=0;
for i:=0 to NbLignes-1 do
   begin
   if Lignes[i]^.Date='=ACTION=' then action:=true;
   if action then
      begin
      if Lignes[i]^.Sel then SoldeS:=SoldeS+Lignes[i]^.Cre-Lignes[i]^.Deb
                        else if Lignes[i]^.Cre>0 then Dif:=Lignes[i]^.Cre;
      Solde:=Dif*SoldeS;
      end
   else
      begin
      dif:=Lignes[i]^.Cre-Lignes[i]^.Deb;
      if (length(Lignes[i]^.Date)>2) and (Lignes[i]^.Date[1]='*')
        then case upcase(Lignes[i]^.Date[2]) of
               'T': dif:=4*dif;
               'I','P': dif:=6*dif;
               'M': dif:=12*dif;
             end;
      Solde:=Solde+Dif;
      if Lignes[i]^.Sel then SoldeS:=SoldeS+dif;
      end;
   end;

add:=Solde-add;
addS:=SoldeS-addS;
if action then add:=0;

CptList.MemMAJ(@self,add,adds);

end;

{ ==============> SelCalculate <============ }

procedure TCompte.SelCalculate;

var i:integer;

begin
if TotalFen=nil then exit;

Total:=0;
TotalS:=0;

for i:=SelecZone.A.Y to SelecZone.B.Y-1 do
 if i<NbLignes then
   begin
   if (SelecZone.A.X<=3) and (SelecZone.B.X>3) then
     begin
     Total:=Total+Lignes[i]^.Cre;
     if Lignes[i]^.Sel then TotalS:=TotalS+Lignes[i]^.Cre;
     end;
   if (SelecZone.A.X<=4) and (SelecZone.B.X>4) then
     begin
     Total:=Total-Lignes[i]^.Deb;
     if Lignes[i]^.Sel then TotalS:=TotalS-Lignes[i]^.Deb;
     end;
   end;

TotalFen^.Draw;

end;


{ ===================> Sauver <================ }

procedure TCompte.Sauver;


var i:integer;
    f:file;
    Reserved:Array[1..LGRESERV] of char;
    D:array[1..7] of word;
    s100:word;
    NUM:string[4];
    version,avt,avts,add,adds:real;

begin
if RFicName=PP_NAME then exit;
assign(f,RFicName);
{$I-}
rewrite(f,1);
{$I+}
if ioresult<>0 then exit;

avt:=Credit-OCredit;
avts:=CreditS-OCreditS;
Credit:=OCredit;
CreditS:=OCreditS;
Solde:=Solde-avt;
SoldeS:=SoldeS-avts;
add:=Solde-OSolde;
adds:=SoldeS-OSoldeS;
version:=VER_UNIT;
blockwrite(f,version,sizeof(version));

Credit:=round(Credit*100)/100;
CreditS:=round(CreditS*100)/100;
Solde:=round(Solde*100)/100;
SoldeS:=round(SoldeS*100)/100;

blockwrite(f,Credit,sizeof(Credit));
blockwrite(f,CreditS,sizeof(CreditS));
blockwrite(f,Solde,sizeof(Solde));
blockwrite(f,SoldeS,sizeof(SoldeS));

{ Ecriture de la date et heure }
getdate(D[1],D[2],D[3],D[4]);
gettime(D[5],D[6],D[7],s100);
blockwrite(f,D,sizeof(D));

{ Ecriture d'une zone reserve }
Reserved[1]:=#0;
blockwrite(f,Reserved,LGRESERV);

{ Ecriture du tableau de lignes }
blockwrite(f,NbLignes,sizeof(NbLignes));
for i:=0 to NbLignes-1 do blockwrite(f,Lignes[i]^,sizeof(TLigne));

close(f);
LastSave:='';
str(D[3]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
LastSave:=LastSave+NUM+'/';
str(D[2]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
LastSave:=LastSave+NUM+'/';
str(D[1]:4,NUM);
LastSave:=LastSave+NUM+'  ';
str(D[5]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
LastSave:=LastSave+NUM+':';
str(D[6]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
LastSave:=LastSave+NUM+':';
str(D[7]:2,NUM);if NUM[1]=' ' then NUM[1]:='0';
LastSave:=LastSave+NUM+' ';
modif^:=false;

CptList.DiskMAJ(@self,add,adds);
CptList.OMemMAJ(@self,add,adds);

Credit:=Credit+avt;
OSolde:=Solde;
Solde:=Solde+avt;
CreditS:=CreditS+avts;
OSoldeS:=SoldeS;
SoldeS:=SoldeS+avts;

CptList.IdCOPY(@self);
end;


{ ===================> Search <============== }

procedure TCompte.search(Mont:Real);

var P,T:Array[0..MAX_LIGNES] of Longint;
    H,TP:Array[0..MAX_LIGNES] of Integer;

  procedure lookin(Nmax:integer;Pmax:longint);

  var I:Integer;   { Indice de parcours de l'arbre (Profondeur) }
      K:integer;   { Compteur pour l'affichage }

  begin
  I:=0;    { On se place sur la racine du sous arbre }
  H[0]:=0; { La racine du sous arbre est celle de l'arbre }
  P[0]:=T[0]; { Poids de la racine si arbre valu }

  {Tant que l'on n'a pas traitr tout l'arbre }
  H[1]:=0;
  while H[1]<>Nmax do
    begin
    {Aff gotoxy(34,13);write(H[1]:3); }
    if  (keyState and kbalt)<>0 then
       begin
       Beep;
       MessageBox(^C+'Interruption par frappe de la touche ALT .',nil,mfInformation+mfOkButton);
       exit;
       end;
    {Tant que l'on n'est pas au bout de la branche }
    while H[I]<>Nmax do
         begin
         { Prochain noeud }
         I:=I+1;
         H[I]:=H[I-1]+1;
         { valuation }
         P[I]:=P[I-1]+T[H[I]];  { T[I]=Poids du noeud I }
         if P[I]=Pmax
           then
             begin   { Poids idal }
             for K:=1 to I do
                 Lignes[TP[H[K]]]^.sel:=true;
             Beep;
             MessageBox(^C+'Montant trouv !',nil,mfInformation+mfOkButton);
             exit
             end;
         end;
    I:=I-1; { Retour sur le noeud d'origine de la branche }
    H[I]:=H[I]+1; { Branche suivante }
    P[I]:=P[I-1]+T[H[I]];  { T[I]=Poids du noeud I }
    if P[I]=Pmax
           then
             begin   { Poids idal }
             for K:=1 to I do
                 Lignes[TP[H[K]]]^.Sel:=True;
             Beep;
             MessageBox(^C+'Montant trouv !',nil,mfInformation+mfOkButton);
             exit
             end;
    end;
  Beep;
  MessageBox(^C+'Impossible de trouv ce montant !',nil,mfInformation+mfOkButton);
  end;

var i,NBn:integer;
    Event:TEvent;
    Dialog:PDialog;
    R:TRect;

begin
Nbn:=0;
for I:=0 to NbLignes-1 do
  if not(Lignes[I]^.Sel) then
      begin
      Nbn:=Nbn+1;
      T[Nbn]:=round(Lignes[I]^.cre*100-Lignes[I]^.deb*100);
      TP[Nbn]:=I
      end;
T[0]:=round(SoldeS*100);

if round(Mont*100)=round(SoldeS*100) then
             begin
             Beep;
             MessageBox(^C+'Montant Dja trouv !',nil,mfInformation+mfOkButton);
             exit
             end;


R.assign(0,0,60,5);
Dialog:=new(PDialog, Init(R,''));
Dialog^.options:=OfCentered;
Dialog^.flags:=0;
R.Assign(2,2,58,3);
Dialog^.insert(New(PStaticText, Init(R,'Recherche en cours ...   Pressez ALT pour interrompre.')));
Desktop^.insert(Dialog);


lookin(Nbn,Round(Mont*100));

Dialog^.Close;
Calculate;
Event.What:=evCommand;
Event.Command:=cmcptupdate;
Event.InfoPtr:=@self;
PutEvent(Event);
Modif^:=true;
CptList.IdCOPY(@self);
DrawView;
end;

{ ===================> Class  <============== }

procedure TCompte.Class(Z:TRect;Option:Byte);

var i,Dernier,Dern:integer;
    Aux:PLigne;

    function compare(A,B:PLigne):boolean;

    var cmp:boolean;
        C,D:String;
        j:byte;

    begin
    case (Option and 3) of
      1:Cmp:=A^.Sel>B^.Sel;
      2:begin
        C:=copy(A^.Date,7,4)+copy(A^.Date,4,2)+copy(A^.date,1,2);
        D:=copy(B^.Date,7,4)+copy(B^.Date,4,2)+copy(B^.date,1,2);
        Cmp:=C>D;
        end;
      3:begin
        C:=A^.Lib;
        D:=B^.Lib;
        for j:=1 to length(C) do C[j]:=upcase(C[j]);
        for j:=1 to length(D) do D[j]:=upcase(D[j]);
        Cmp:=C>D;
        end;
      end;
    if (option and 4)=4 then Compare:=(not cmp) else Compare:=cmp;
    end;

begin
if Z.B.Y>NbLignes then Z.B.Y:=NbLignes;  { Si la zone deborde }
if Z.B.Y-2<Z.A.Y then exit;

Dernier:=Z.B.Y-1;

while Dernier>Z.A.Y do
  begin
  Dern:=Dernier;
  Dernier:=Z.A.Y;
  for i:=Z.A.Y to Dern-1 do
    if Compare(Lignes[i],Lignes[i+1]) then
       begin
       Aux:=Lignes[i];
       Lignes[i]:=Lignes[i+1];
       Lignes[i+1]:=Aux;
       Dernier:=i;
       end;
  end;
Modif^:=true;
DrawView;
CptList.IdCOPY(@self);
end;


{ ===================> Copier <============== }

procedure TCompte.Copier(Z:TRect);

var i:integer;

begin
if Z.B.Y>NbLignes then Z.B.Y:=NbLignes;  { Si la zone deborde }
while (Z.B.Y-Z.A.Y+CptPressPap^.VCompte^.NbLignes)>=MAX_LIGNES do
     CptPressPap^.VCompte^.LineDelete(0);
CptPressPap^.VCompte^.SelecZone.A.X:=Z.A.X;
CptPressPap^.VCompte^.SelecZone.B.X:=Z.B.X;
CptPressPap^.VCompte^.SelecZone.A.Y:=CptPressPap^.VCompte^.NbLignes;
for i:=Z.A.Y to Z.B.Y-1 do
  if (i<NbLignes) and (CptPressPap^.VCompte^.NbLignes<MAX_LIGNES-1) then
    begin
    New(CptPressPap^.VCompte^.Lignes[CptPressPap^.VCompte^.NbLignes]);
    CptPressPap^.VCompte^.Lignes[CptPressPap^.VCompte^.NbLignes]^:=Lignes[i]^;
    inc(CptPressPap^.VCompte^.NbLignes);
    end;
CptPressPap^.VCompte^.SelecZone.B.Y:=CptPressPap^.VCompte^.NbLignes;
CptPressPap^.VCompte^.Calculate;
CptPressPap^.VCompte^.Setlimit(0,CptPressPap^.VCompte^.NbLignes);
CptList.IdCOPY(CptPressPap^.VCompte);
end;


{ ===================> Copier Solde <============== }

procedure TCompte.CopierSolde(SelSolde:boolean);

var i:integer;
    Ligne:TLigne;

begin
{ Vide presse pap si trop plein }
while (1+CptPressPap^.VCompte^.NbLignes)>=MAX_LIGNES do
     CptPressPap^.VCompte^.LineDelete(0);

CptPressPap^.VCompte^.SelecZone.A.X:=2;
CptPressPap^.VCompte^.SelecZone.B.X:=5;
CptPressPap^.VCompte^.SelecZone.A.Y:=CptPressPap^.VCompte^.NbLignes;

Ligne.Sel:=false;
Ligne.Date:='        ';
Ligne.Lib:=PFenCpt(Owner)^.CptDef.Name;
Ligne.Deb:=0;
Ligne.Typ:='    ';
if SelSolde then Ligne.cre:=SoldeS
            else Ligne.cre:=Solde;
if Ligne.Cre<0 then
   begin
   Ligne.Deb:=-Ligne.Cre;
   Ligne.Cre:=0;
   end;
New(CptPressPap^.VCompte^.Lignes[CptPressPap^.VCompte^.NbLignes]);
CptPressPap^.VCompte^.Lignes[CptPressPap^.VCompte^.NbLignes]^:=Ligne;
inc(CptPressPap^.VCompte^.NbLignes);

CptPressPap^.VCompte^.SelecZone.B.Y:=CptPressPap^.VCompte^.NbLignes;
CptPressPap^.VCompte^.Calculate;
CptPressPap^.VCompte^.Setlimit(0,CptPressPap^.VCompte^.NbLignes);
CptList.IdCOPY(CptPressPap^.VCompte);
end;




{ ===================> Couper <============== }

procedure TCompte.Couper(Z:TRect);  { ne fait pas d'appel  copier }

var i:integer;
    LargPressPap:TPoint;

begin
if Z.B.Y>NbLignes then Z.B.Y:=NbLignes; { Si la zone deborde }
LargPressPap.X:=Z.A.X;
LargPressPap.Y:=Z.B.X-1;
if (LargPressPap.X=0) and (LargPressPap.Y=NB_Col-1) then
     for i:=Z.A.Y to Z.B.Y-1 do LineDelete(Z.A.Y)
else for i:=Z.A.Y to Z.B.Y-1 do
       begin
       if (LargPressPap.X<=0) and (LargPressPap.Y>=0) then Lignes[i]^.Sel:=False;;
       if (LargPressPap.X<=1) and (LargPressPap.Y>=1) then Lignes[i]^.Date:='';
       if (LargPressPap.X<=2) and (LargPressPap.Y>=2) then Lignes[i]^.Lib:='';
       if (LargPressPap.X<=3) and (LargPressPap.Y>=3) then Lignes[i]^.Cre:=0;
       if (LargPressPap.X<=4) and (LargPressPap.Y>=4) then Lignes[i]^.Deb:=0;
       if (LargPressPap.X<=5) and (LargPressPap.Y>=5) then Lignes[i]^.Typ:='';
       end;
Calculate;
CptList.IdCOPY(@self);
end;

{ ===================> Coller <============== }

procedure TCompte.Coller(var Z:TRect; L:integer; C:Byte);

var i:integer;
    deb,fin:integer;
    LargPressPap:TPoint;

begin
Z.A.X:=CptPressPap^.VCOmpte^.Seleczone.A.X;
Z.B.X:=CptPressPap^.VCOmpte^.Seleczone.B.X;;
deb:=CptPressPap^.VCOmpte^.Seleczone.A.Y;
fin:=CptPressPap^.VCOmpte^.Seleczone.B.Y-1;
LargPressPap.X:=CptPressPap^.VCompte^.SelecZone.A.X;
LargPressPap.Y:=CptPressPap^.VCompte^.SelecZone.B.X-1;
Z.A.Y:=L;
Z.B.Y:=L;
if (LargPressPap.X=0) and (LargPressPap.Y=Nb_Col-1) then
   for i:=fin downto deb do
    begin
    if NbLignes<MAX_LIGNES-1 then
       begin
       if L>NbLignes-1 then CreerLigne(L) else LineInsert(L);
       Lignes[L]^:=CptPressPap^.VCompte^.Lignes[i]^;
       inc(Z.B.Y);
       end;
    end
else for i:=deb to fin do
       begin
       if L+i-deb>NbLignes-1 then CreerLigne(L+i-deb);
       if L+i-deb<NbLignes then
         begin
         if (LargPressPap.X<=0) and (LargPressPap.Y>=0) then Lignes[L+i-deb]^.Sel:=CptPressPap^.VCompte^.Lignes[i]^.Sel;
         if (LargPressPap.X<=1) and (LargPressPap.Y>=1) then Lignes[L+i-deb]^.Date:=CptPressPap^.VCompte^.Lignes[i]^.Date;
         if (LargPressPap.X<=2) and (LargPressPap.Y>=2) then Lignes[L+i-deb]^.Lib:=CptPressPap^.VCompte^.Lignes[i]^.Lib;
         if (LargPressPap.X<=3) and (LargPressPap.Y>=3) then
            if (LargPressPap.Y-LargPressPap.X=0) and (C=4)
              then begin
                   Lignes[L+i-deb]^.Deb:=CptPressPap^.VCompte^.Lignes[i]^.Cre;
                   Z.A.X:=4;
                   Z.B.X:=5;
                   end
              else Lignes[L+i-deb]^.Cre:=CptPressPap^.VCompte^.Lignes[i]^.Cre;
         if (LargPressPap.X<=4) and (LargPressPap.Y>=4) then
            if (LargPressPap.Y-LargPressPap.X=0) and (C=3)
              then begin
                   Lignes[L+i-deb]^.Cre:=CptPressPap^.VCompte^.Lignes[i]^.Deb;
                   Z.A.X:=3;
                   Z.B.X:=4;
                   end
              else Lignes[L+i-deb]^.Deb:=CptPressPap^.VCompte^.Lignes[i]^.Deb;
         if (LargPressPap.X<=5) and (LargPressPap.Y>=5) then Lignes[L+i-deb]^.Typ:=CptPressPap^.VCompte^.Lignes[i]^.Typ;
         inc(Z.B.Y);
         end;
       end;
setlimit(0,NbLignes+1);
Calculate;
CptList.IdCOPY(@self);
end;




{ ===================> Make Visible <============== }

procedure TCompte.MakeVisible(L:integer);

var D:integer;

begin
if (Delta.Y+CaseCour.Y=L) and (CaseCour.Y>=0) and (CaseCour.Y<size.y) then exit;
D:=Delta.Y;
CaseCour.Y:=size.Y div 2;
D:=L-CaseCour.Y;
if D<0 then begin CaseCour.Y:=CaseCour.Y+D; D:=0; end;
if (D>NbLignes-Size.y) then
     begin
     D:=NbLignes-Size.Y;
     if D<0 then D:=0;
     CaseCour.Y:=L-D;
     end;
ScrollTo(0,D);
end;


{ ===================> Selected <================= }

function TCompte.Selected(L:integer; Z:byte):boolean;

var P:TPoint;

begin
P.X:=Z;
P.Y:=L;
Selected:=SelecZone.contains(P);
end;

function TCompte.FindCase(X:integer):byte;

var LgLib:byte;

begin
LgLib:=Size.x-(LgDat+LgSel+LgCre+LgDeb+LgTyp+Nb_Col);
FindCase:=0;
if X>Lgsel then FindCase:=1;
if X>LgSel+LgDat+1 then FindCase:=2;
if X>LgSel+LgDat+LgLib+2 then FindCase:=3;
if X>LgSel+LgDat+LgLib+LgCre+3 then FindCase:=4;
if X>LgSel+LgDat+LgLib+LgCre+LgDeb+4 then FindCase:=5;
end;

{ ===================> Creer Ligne <================ }

procedure TCompte.CreerLigne(L:integer);

begin
if NbLignes>=MAX_LIGNES-1 then
   begin
   beep;
   exit;
   end;
new(Lignes[L]);
Lignes[L]^.Sel:=false;
Lignes[L]^.Date:='';
Lignes[L]^.Lib:='';
Lignes[L]^.Cre:=0;
Lignes[L]^.Deb:=0;
Lignes[L]^.Typ:='    ';
Lignes[L]^.Reserved[1]:=0;
inc(NbLignes);
end;

{ ===================> CursorSet <================== }

procedure TCompte.CursorSet;

var LgLib,XCas:Byte;
    P:Byte;

begin
LgLib:=Size.x-(LgDat+LgSel+LgCre+LgDeb+LgTyp+Nb_Col);
case CaseCour.X of
      0:XCas:=0;
      1:XCas:=LgSel+1;
      2:begin
        XCas:=LgDat+LgSel+2;
        if EditCur>LgLib-2 then P:=EditCur-LgLib+2 else P:=0;
        if EditMode then XCas:=XCas+EditCur-P;
        end;
      3:XCas:=(LgDat+LgSel+3)+LgLib;
      4:XCas:=(LgDat+LgSel+LgCre+4)+LgLib;
      5:XCas:=(LgDat+LgSel+LgCre+LgDeb+5)+LgLib;
      end;

if EditMode and (CaseCour.X<>2) then XCas:=XCas+EditCur;

if EditMode then NormalCursor else BlockCursor;
SetCursor(XCas,CaseCour.Y);

end;


{ =================> LINE INSERT <================= }

procedure TCompte.LineInsert(L:integer);

var i:integer;

begin
if NBLignes>=MAX_LIGNES-1 then exit;
for i:=NbLignes-1 downto L do Lignes[i+1]:=Lignes[i];
CreerLigne(L);
setlimit(0,NbLignes+1);
DrawView;
end;

{ =================> LINE DELETE <================= }

procedure TCompte.LineDelete(L:integer);

var i:integer;

begin
Dispose(Lignes[L]);
if NbLignes>1 then for i:=L to NbLignes-2 do Lignes[i]:=Lignes[i+1];
Dec(NbLignes);
setlimit(0,NbLignes+1);
DrawView;
end;


{ ----------------> DRAW <----------------}

procedure Tcompte.Draw;

var NUM:string;
    LgLib,Col,ColS,Y:Byte;
    L:Integer;
    Buf:TDrawBuffer;
    SELCHAR:Char;
    SDAT:string[LgDat];
    STYP:string[LgTyp];
    SCREDIT:string[LgCre];
    SDEBIT:string[LgDeb];
    SLIB:string[MAX_LG_LIB];
    DebLib:byte;



begin
    if macread and not DrawOn then begin Tview.Draw;  exit; end;
    if EditMode then CaseCour.Y:=EditLineSaved-Delta.Y;
    ColS:=getcolor(1);
    LgLib:=Size.x-(LgDat+LgSel+LgCre+LgDeb+LgTyp+Nb_Col);
    CursorSet;
    for Y:=0 to size.Y-1 do
         begin
         MoveChar(Buf,' ',colS,Size.X);
         MoveChar(Buf[LgSel],'',ColS,1);
         MoveChar(Buf[LgSel+LgDat+1],'',ColS,1);
         MoveChar(Buf[LgSel+LgDat+2+LgLib],'',ColS,1);
         MoveChar(Buf[LgSel+LgDat+LgCre+3+LgLib],'',ColS,1);
         MoveChar(Buf[LgSel+LgDat+LgCre+LgDeb+4+LgLib],'',ColS,1);
         L:=Delta.Y+Y;
         if L<NbLignes then
          with Lignes[L]^ do
            begin
            if EditMode and (Y=CaseCour.Y) and (EditCur>=LgLib-2)
               then DebLib:=EditCur-LgLib+3
               else DebLib:=0;
            SLIB:=Lib;
            SDAT:=Date;
            STYP:=Typ;
            str(Cre:8:2,SCREDIT);
            str(Deb:8:2,SDEBIT);
            if EditMode and (Y=CaseCour.Y) then
              case CaseCour.X of
                1:SDAT:=EditStr;
                2:SLIB:=EditStr;
                3:SCREDIT:=EditStr;
                4:SDEBIT:=EditStr;
                5:STYP:=EditStr;
              end;
            if Selected(L,0) then col:=getcolor(2) else col:=getcolor(1);
            if Sel then SELCHAR:=CAR_SELECTED else SELCHAR:=CAR_NOT_SELECTED;
            MoveChar(Buf[0],SELCHAR,Col,1);
            if  Selected(L,1) then col:=getcolor(2) else col:=getcolor(1);
            MoveStr(Buf[LgSel+1],copy(SDAT+SPACE,1,LgDat),Col);
            if  Selected(L,2) then col:=getcolor(2) else col:=getcolor(1);
            MoveStr(Buf[LgSel+LgDat+2],copy(SLIB+SPACE,DebLib,LgLib),Col);
            if  Selected(L,3) then col:=getcolor(2) else col:=getcolor(1);
            MoveStr(Buf[LgSel+LgDat+3+LgLib],SCREDIT,Col);
            if  Selected(L,4) then col:=getcolor(2) else col:=getcolor(1);
            MoveStr(Buf[LgSel+LgDat+LgCre+4+LgLib],SDEBIT,Col);
            if  Selected(L,5) then col:=getcolor(2) else col:=getcolor(1);
            MoveStr(Buf[LgSel+LgDat+LgCre+LgDeb+5+LgLib],copy(STYP+SPACE,1,LgTyp),Col);
            end;

         WriteLine(0,Y,Size.X,1,Buf);

         end;
SelCalculate;
end;


{ ----------------> HANDLE EVENT <---------------- }

procedure TCompte.HandleEvent(var Event:TEvent);

var NEvent: TEvent;
    PosM: TPoint;


  procedure HandleBefore;

  begin
  { Handle Before , not edit mode }
  if Event.what=evKeyDown then
    case Event.KeyCode of
       KbDown :begin
               if (CaseCour.Y+Delta.Y+1=NbLignes) and AutoInsert then
                 begin
                 CreerLigne(NbLignes);
                 setlimit(0,NbLignes+1);
                 CptList.IdCOPY(@self);
                 DrawView;
                 end;
               if CaseCour.Y<size.y-1 then
                  begin
                  inc(CaseCour.Y);
                  ClearEvent(Event);
                  CursorSet;
                  end;
               end;
       KbUp   :if CaseCour.Y>0 then
                  begin
                  dec(CaseCour.Y);
                  ClearEvent(Event);
                  CursorSet;
                  end;
       KbRight:if CaseCour.X<Nb_Col-1 then
                  begin
                  inc(CaseCour.X);
                  ClearEvent(Event);
                  CursorSet;
                  end;
       KbLeft :if CaseCour.X>0 then
                  begin
                  dec(CaseCour.X);
                  ClearEvent(Event);
                  CursorSet;
                  end;
       KbHome :begin
               CaseCour.X:=0;
               CaseCour.Y:=0;
               ClearEvent(Event);
               MakeVisible(0);
               CursorSet;
               end;

       KbEnd : begin
               CaseCour.X:=0; { could be at end colon : Nb_Col-1; }
               CaseCour.Y:=0; { could be at end zone  : size.y-1; }
               ClearEvent(Event);
               MakeVisible(NbLignes-1);
               CursorSet;
               end;

       end;

  if CaseCour.Y>size.y-1 then begin
                              CaseCour.Y:=size.y-1;
                              CursorSet;
                              end;

  end; { Handle Before - not edit mode }


  procedure EditHandle;

  var Max,i,DebLib,LgLib:byte;
      C:Char;
      L:integer;
      PS:TPoint;
      CurDate:string;

  begin
  { Handle , edit mode }
  case CaseCour.X of
    0:Max:=LgSel-1;
    1:Max:=LgDat-1;
    2:Max:=MAX_LG_LIB-1;
    3:Max:=LgCre-1;
    4:Max:=LgDeb-1;
    5:Max:=LgTyp-1;
    end;

  if Event.what=evKeyDown then
    case Event.KeyCode of
       KbEsc: begin
              EditMode:=false;
              DrawView;
              ClearEvent(Event);
              end;
       KbEnter:begin
               L:=CaseCour.Y+Delta.Y;
               case CaseCour.X of
                  1:if ControleDate(EditStr)<>'' then Lignes[L]^.Date:=EditStr
                                                 else exit;
                  2:Lignes[L]^.Lib:=EditStr;
                  3:num(EditStr,Lignes[L]^.Cre);
                  4:num(EditStr,Lignes[L]^.Deb);
                  5:Lignes[L]^.Typ:=EditStr;
                  end;
               EditMode:=False;
               Modif^:=true;
               DrawView;
               Calculate;

               { ATTENTION Mettre a jour autre compte }
               CptList.IdMAJ(@self);

               ClearEvent(Event);
               NEvent.What:=evCommand;
               NEvent.Command:=cmcptupdate;
               NEvent.InfoPtr:=@self;
               PutEvent(NEvent);

               end;

       KbRight:if EditCur<Max then
                  begin
                  inc(EditCur);
                  ClearEvent(Event);
                  if CaseCour.X=2 then DrawView else CursorSet;
                  end;
       KbLeft :if EditCur>0 then
                  begin
                  dec(EditCur);
                  ClearEvent(Event);
                  if CaseCour.X=2 then DrawView else CursorSet;
                  end;
       KbHome :begin
               EditCur:=0;
               ClearEvent(Event);
               if CaseCour.X=2 then DrawView else CursorSet;
               end;

       KbCtrlright : begin
                     if CaseCour.X=2 then
                        begin
                        while (EditCur<Max) and (EditStr[EditCur+1] in ['A'..'Z','a'..'z']) do inc(EditCur);
                        while (EditCur<Max) and (not (EditStr[EditCur+1] in ['A'..'Z','a'..'z'])) do inc(EditCur);
                        DrawView;
                        end;
                     ClearEvent(Event);
                     end;

       KbCtrlleft : begin
                    if CaseCour.X=2 then
                       begin
                       while (EditCur>0) and (not (EditStr[EditCur+1] in ['A'..'Z','a'..'z'])) do dec(EditCur);
                       while (EditCur>0) and (EditStr[EditCur+1] in ['A'..'Z','a'..'z']) do dec(EditCur);
                       DrawView;
                       end;
                    ClearEvent(Event);
                    end;


       KbEnd : begin
               EditCur:=Max;
               if CaseCour.X=2 then
                 while (EditCur>0) and (EditStr[EditCur]=' ') do dec(EditCur);
               ClearEvent(Event);
               if CaseCour.X=2 then DrawView else CursorSet;
               end;

       KbBack : begin
                if EditCur>0 then
                  begin
                  for i:=EditCur to Max do EditStr[i]:=EditStr[i+1];
                  EditStr[Max+1]:=' ';
                  EditCur:=EditCur-1;
                  DrawView;
                  end;
                ClearEvent(Event);
                end;

       KbDel : begin
               for i:=EditCur+1 to Max do EditStr[i]:=EditStr[i+1];
               EditStr[Max+1]:=' ';
               ClearEvent(Event);
               DrawView;
               end;

       KbIns : begin
               InsertMode:=not InsertMode;
               end;

       end;


  if (Event.what=evKeyDown) and (Event.CharCode='')
   then if (CaseCour.X=2) or (CaseCour.X=1)
         then
           begin
           CurDate:=getstringDate;
           if CaseCour.X=1 then
             begin
             for i:=1 to length(EditStr) do
               if i<=length(CurDate)
                  then EditStr[i]:=CurDate[i]
                  else EditStr[i]:=' ';
             EditCur:=length(CurDate);
             end
            else
             begin
             for i:=EditCur+1 to length(EditStr) do
               if i-EditCur<=length(CurDate)
                  then EditStr[i]:=CurDate[i-EditCur]
                  else EditStr[i]:=' ';
             EditCur:=EditCur+length(CurDate);
             if EditCur>=Length(EditStr) then EditCur:=Length(EditStr)-1;
             end;
           ClearEvent(Event);
           DrawView;
           end
         else
           begin
           Event.what:=evcommand;
           Event.command:=cmerror;
           end;

  if (Event.what=evKeyDown) and (Event.CharCode in [^A..^Z])
   then if CaseCour.X=2
         then
           begin
           for i:=1 to length(EditStr) do
             if i<=length(FastKey[Event.CharCode])
                then EditStr[i]:=FastKey[Event.CharCode][i]
                else EditStr[i]:=' ';
           EditCur:=length(FastKey[Event.CharCode]);
           ClearEvent(Event);
           DrawView;
           end
         else
           begin
           Event.what:=evcommand;
           Event.command:=cmerror;
           end;

  if (Event.what=evKeyDown) and (Event.CharCode in [' '..''])
    then begin
         MakeVisible(EditLineSaved);
         C:=Event.CharCode;
         Event.what:=evcommand;
         Event.command:=cmerror;
         if   ( (C in [' '..'']) and ( (CaseCour.X<3) or (CaseCour.X>4) ) )
           or ( (C in ['0'..'9','.',' ']) and (CaseCour.X>2) )
           then
            begin
            if InsertMode then
              for i:=max downto EditCur+1 do EditStr[i+1]:=EditStr[i];

            EditStr[EditCur+1]:=C;
            if EditCur<Max then inc(EditCur);
            ClearEvent(Event);
            DrawView;
            end;
         end;

  if Event.What=evMouseDown then
     begin
     if Event.Buttons=mbrightbutton then
               begin
               if wasdouble then ; { Double click a droite }
               Event.What:=evKeyDown;
               Event.KeyCode:=KbEnter;  { Simule une sortie d'edition }
               PutEvent(Event);
               end;
     if Event.Buttons=mbleftbutton then
               begin
               if wasdouble then ; { Double click a droite }
               makeLocal(Event.Where,PS);
               if (PS.Y=CaseCour.Y) and (findcase(PS.X)=CaseCour.X) then
                  begin
                  LgLib:=Size.x-(LgDat+LgSel+LgCre+LgDeb+LgTyp+Nb_Col);
                  if EditCur>=LgLib-2 then DebLib:=EditCur-LgLib+2
                                      else DebLib:=0;

                  case CaseCour.X of
                    1:EditCur:=PS.X-LgSel-1;
                    2:EditCur:=PS.X-LgSel-LgDat+DebLib-2;
                    3:EditCur:=PS.X-LgSel-LgDat-LgLib-3;
                    4:EditCur:=PS.X-LgSel-LgDat-LgLib-LgCre-4;
                    5:EditCur:=PS.X-LgSel-LgDat-LgLib-LgCre-LgDeb-5;
                    end;
                  end;
               if CaseCour.X=2 then DrawView else CursorSet;
               end;
     ClearEvent(Event);
     DrawView;
     end;

  end; { Handle - edit mode }



  procedure HandleAfter;

  var L:integer;
      Mont:real;
      TmpTyp:string[LgTyp];

  begin
   { Handle After - not edit mode }
  if Event.what=evKeyDown then
    case Event.KeyCode of
       Kbesc:begin
             ClearEvent(Event);
             NEvent.What:=evCommand;
             NEvent.Command:=cmclose;
             NEvent.InfoPtr:=@self;
             PutEvent(NEvent);
             end;

       KbEnter:begin
               L:=Delta.Y+CaseCour.Y;
               if L=NbLignes then begin
                                  modif^:=true;
                                  CreerLigne(L);
                                  setlimit(0,NbLignes+1);
                                  CptList.IdCOPY(@self);
                                  end;
               if L>=NbLignes then begin
                                   Event.what:=evcommand;
                                   Event.command:=cmerror;
                                   end;
               if (Event.what<>evcommand) or (Event.command<>cmerror) then
                if CaseCour.X=0
                 then begin
                      modif^:=true;
                      Lignes[L]^.Sel:=not Lignes[L]^.Sel;
                      Calculate;
                      DrawView;
                      CptList.IdMAJ(@self);
                      ClearEvent(Event);
                      NEvent.What:=evCommand;
                      NEvent.Command:=cmcptupdate;
                      NEvent.InfoPtr:=@self;
                      PutEvent(NEvent);
                      end
                 else begin
                      EditMode:=true;
                      EditLineSaved:=L;
                      EditCur:=0;
                      Case CaseCour.X of
                        1:EditStr:=copy(Lignes[L]^.Date+SPACE,1,LgDat);
                        2:EditStr:=copy(Lignes[L]^.Lib+SPACE,1,MAX_LG_LIB);
                        3:if Lignes[L]^.Cre=0
                             then EditStr:=copy(SPACE,1,LgCre)
                             else str(Lignes[L]^.Cre:LgCre:2,EditStr);
                        4:if Lignes[L]^.Deb=0
                             then EditStr:=copy(SPACE,1,LgDeb)
                             else str(Lignes[L]^.Deb:LgDeb:2,EditStr);
                        5:EditStr:=copy(Lignes[L]^.Typ+SPACE,1,LgTyp);
                        end;
                      ClearEvent(Event);
                      DrawView;
                      end;
               end;

       KbIns:begin
             ClearEvent(Event);
             L:=Delta.Y+CaseCour.Y;
             if L<NbLignes
              then begin
                   modif^:=true;
                   LineInsert(L);
                   if SelecZone.B.Y>L then SelecZone.B.Y:=SelecZone.B.Y+1;
                   if SelecZone.A.Y>L then SelecZone.A.Y:=SelecZone.A.Y+1;
                   DrawView;
                   CptList.IdCOPY(@self);
                   end
              else begin
                   Event.what:=evcommand;
                   Event.command:=cmerror;
                   end;
             end;

       KbTab:begin
             ClearEvent(Event);
             L:=Delta.Y+CaseCour.Y;
             if L<NbLignes
              then begin
                   modif^:=true;
                   Lignes[L]^.Sel:=not Lignes[L]^.sel;
                   Calculate;
                   DrawView;
                   CptList.IdMAJ(@self);
                   NEvent.What:=evCommand;
                   NEvent.Command:=cmcptupdate;
                   NEvent.InfoPtr:=@self;
                   PutEvent(NEvent);
                   end
              else begin
                   Event.what:=evcommand;
                   Event.command:=cmerror;
                   end;
             end;

       kbCtrlEnter:begin
                   ClearEvent(Event);
                   if SelecZone.B.Y>SelecZone.A.Y then
                       begin
                       {  gotoxy(1,1);
                          writeln('A=',SelecZone.A.Y,'  B=',SelecZone.B.Y);
                          delay(2000);
                       }
                       modif^:=true;
                       TmpTyp:=GetTyp;
                       for L:=SelecZone.A.Y to SelecZone.B.Y-1 do
                          begin
                          if TmpTyp<>#255 then Lignes[L]^.Typ:=TmpTyp;
                          end;
                       Calculate;
                       DrawView;
                       CptList.IdMAJ(@self);
                       NEvent.What:=evCommand;
                       NEvent.Command:=cmcptupdate;
                       NEvent.InfoPtr:=@self;
                       PutEvent(NEvent);
                       end
                   else begin
                        L:=Delta.Y+CaseCour.Y;
                        if L<NbLignes
                        then begin
                             modif^:=true;
                             TmpTyp:=GetTyp;
                             if TmpTyp<>#255 then Lignes[L]^.Typ:=TmpTyp;
                             DrawView;
                             CptList.IdMAJ(@self);
                             NEvent.What:=evCommand;
                             NEvent.Command:=cmcptupdate;
                             NEvent.InfoPtr:=@self;
                             PutEvent(NEvent);
                             end
                        else begin
                             Event.what:=evcommand;
                             Event.command:=cmerror;
                             end;
                        end;
                   end;

       KbshiftTab:begin
                  ClearEvent(Event);
                  if SelecZone.B.Y>SelecZone.A.Y then
                       begin
                       modif^:=true;
                       for L:=SelecZone.A.Y to SelecZone.B.Y-1 do
                          begin
                          Lignes[L]^.Sel:=true;
                          end;
                       Calculate;
                       DrawView;
                       CptList.IdMAJ(@self);
                       NEvent.What:=evCommand;
                       NEvent.Command:=cmcptupdate;
                       NEvent.InfoPtr:=@self;
                       PutEvent(NEvent);
                       end
                  else begin
                       Event.what:=evcommand;
                       Event.command:=cmerror;
                       end;
                  end;

       KbCtrlBack:begin
                  ClearEvent(Event);
                  L:=Delta.Y+CaseCour.Y;
                  if (L<NbLignes) and (NbLignes>0)
                    then begin
                         modif^:=true;
                         LineDelete(L);
                         if SelecZone.B.Y>L then SelecZone.B.Y:=SelecZone.B.Y-1;
                         if SelecZone.A.Y>L then SelecZone.A.Y:=SelecZone.A.Y-1;
                         Calculate;
                         DrawView;
                         NEvent.What:=evCommand;
                         NEvent.Command:=cmcptupdate;
                         NEvent.InfoPtr:=@self;
                         PutEvent(NEvent);
                         CptList.IdCOPY(@self);
                         end
                    else begin
                         Event.what:=evcommand;
                         Event.command:=cmerror;
                         end;
                  end;

       Kbdel:begin
             ClearEvent(Event);
             L:=Delta.Y+CaseCour.Y;
             if (L<NbLignes) and (NbLignes>0)
                    then begin
                         modif^:=true;
                         SelecZone.Assign(0,L,Nb_Col,L+1);
                         NEvent.What:=evCommand;
                         NEvent.Command:=cmcut;
                         NEvent.InfoPtr:=@self;
                         PutEvent(NEvent);
                         end
                    else begin
                         Event.what:=evcommand;
                         Event.command:=cmerror;
                         end;
                  end;

       else if (Event.CharCode in [^A..^Z]) or (Event.CharCode in [' '..''])
              then begin
                   Event.what:=evcommand;
                   Event.command:=cmerror;
                   end;
       end;

  if Event.What=evMouseDown then
     begin
     if Event.Buttons=mbleftbutton then WasDown:=true;
     WasDouble:=Event.Double;
     makelocal(Event.where,PosM);
     CaseCour.Y:=PosM.Y;
     CaseCour.X:=FindCase(PosM.X);
     if WasDown
      then
        begin
        if WasDouble
         then SelecZone.Assign(0,Delta.Y+CaseCour.Y,Nb_Col,Delta.Y+CaseCour.Y+1)
         else SelecZone.Assign(CaseCour.X,Delta.Y+CaseCour.Y,CaseCour.X,Delta.Y+CaseCour.Y);

        if (Keystate and kbshift)<>0 then SelecZone.B.Y:=NBLignes;
        if (Keystate and kbctrl)<>0 then SelecZone.A.Y:=0;
        end
      else if Event.Buttons=mbrightbutton then
             begin
             if wasdouble then ; { Double click a droite }
             Event.What:=evKeyDown;
             Event.KeyCode:=KbEnter;  { Simule une entre en edition }
             PutEvent(Event);
             end;
     if SelecZone.A.Y>=NbLignes then
         begin
         SelecZone.A.Y:=NbLignes-1;
         SelecZone.B.Y:=NbLignes-1;
         end;
     if SelecZone.B.Y>NbLignes then SelecZone.B.Y:=NbLignes;
     ClearEvent(Event);
     if wasdown and (RFicname=PP_NAME) then CptList.IdCOPY(@self);
     DrawView;
     end;

  if (Event.What=evMouseUp) and WasDown then
     begin
     WasDown:=false;
     makelocal(Event.where,PosM);
     if (CaseCour.Y<>PosM.Y) or (FindCase(PosM.X) <> CaseCour.X)
       then
         begin
         if WasDouble then SelecZone.B.X:=Nb_Col
                      else SelecZone.B.X:=FindCase(PosM.X)+1;
         if ((KeyState and kbShift)=0) or ((KeyState and kbctrl)=0)
             then if (keystate and kbShift)<>0
                     then SelecZone.A.Y:=Delta.Y+PosM.Y
                     else SelecZone.B.Y:=Delta.Y+PosM.Y+1;
         DrawView;
         end;
     WasDouble:=false;
     if SelecZone.A.Y>=NbLignes then
         begin
         SelecZone.A.Y:=NbLignes-1;
         SelecZone.B.Y:=NbLignes-1;
         end;
     if SelecZone.B.Y>NbLignes then SelecZone.B.Y:=NbLignes;
     if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
     ClearEvent(Event);
     end;

  if (Event.What=evMouseAuto) and WasDown then
     begin
     makelocal(Event.where,PosM);
     if WasDouble then SelecZone.B.X:=Nb_Col
                  else SelecZone.B.X:=FindCase(PosM.X)+1;
     if ((KeyState and kbShift)=0) or ((KeyState and kbctrl)=0)
        then if (keystate and kbShift)<>0
               then SelecZone.A.Y:=Delta.Y+PosM.Y
               else SelecZone.B.Y:=Delta.Y+PosM.Y+1;
     if SelecZone.A.Y>=NbLignes then
         begin
         SelecZone.A.Y:=NbLignes-1;
         SelecZone.B.Y:=NbLignes-1;
         end;
     if SelecZone.B.Y>NbLignes then SelecZone.B.Y:=NbLignes;
     DrawView;
     if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
     ClearEvent(Event);
     end;

  if Event.What=evcommand then
     case Event.command of

       cmDebZone :begin
                  SelecZone.A.X:=CaseCour.X;
                  SelecZone.A.Y:=Delta.Y+CaseCour.Y;
                  if SelecZone.A.Y>=NbLignes then
                    begin
                    SelecZone.A.Y:=NbLignes-1;
                    SelecZone.B.Y:=NbLignes-1;
                    end;
                  if SelecZone.B.Y>NbLignes then SelecZone.B.Y:=NbLignes;
                  ClearEvent(Event);
                  if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
                  DrawView;
                  end;
       cmEndZone :begin
                  SelecZone.B.X:=CaseCour.X+1;
                  SelecZone.B.Y:=Delta.Y+CaseCour.Y+1;
                  if SelecZone.A.Y>=NbLignes then
                    begin
                    SelecZone.A.Y:=NbLignes-1;
                    SelecZone.B.Y:=NbLignes-1;
                    end;
                  if SelecZone.B.Y>NbLignes then SelecZone.B.Y:=NbLignes;
                  ClearEvent(Event);
                  if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
                  DrawView;
                  end;
       cmClearZone :begin
                    SelecZone.assign(0,0,0,0);
                    ClearEvent(Event);
                    if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
                    DrawView;
                    end;
       cmDebLZone :begin
                   SelecZone.A.X:=0;
                   SelecZone.A.Y:=Delta.Y+CaseCour.Y;
                   if SelecZone.A.Y>=NbLignes then
                     begin
                     SelecZone.A.Y:=NbLignes-1;
                     SelecZone.B.Y:=NbLignes-1;
                     end;
                   if SelecZone.B.Y>NbLignes then SelecZone.B.Y:=NbLignes;
                   ClearEvent(Event);
                   if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
                   DrawView;
                   end;
       CmEndLZone :begin
                   SelecZone.B.X:=Nb_Col;
                   SelecZone.B.Y:=Delta.Y+CaseCour.Y+1;
                   if SelecZone.A.Y>=NbLignes then
                     begin
                     SelecZone.A.Y:=NbLignes-1;
                     SelecZone.B.Y:=NbLignes-1;
                     end;
                   if SelecZone.B.Y>NbLignes then SelecZone.B.Y:=NbLignes;
                   ClearEvent(Event);
                   if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
                   DrawView;
                   end;

       cmmaclire:begin
                 ClearEvent(Event);
                 L:=Delta.Y+CaseCour.Y;
                 if (L<NbLignes) and (NbLignes>0)
                    then begin
                         Case CaseCour.X of
                           0:if Lignes[L]^.Sel then MacLire:='X' else MacLire:='_';
                           1:MacLire:=copy(Lignes[L]^.Date+SPACE,1,LgDat);
                           2:MacLire:=copy(Lignes[L]^.Lib+SPACE,1,MAX_LG_LIB);
                           3:str(Lignes[L]^.Cre:LgCre:2,MacLire);
                           4:str(Lignes[L]^.Deb:LgDeb:2,MacLire);
                           5:MacLire:=copy(Lignes[L]^.Typ+SPACE,1,LgTyp);
                           end;
                         end
                    else begin
                         MacLire:='?? ERREUR ??';
                         Event.what:=evcommand;
                         Event.command:=cmerror;
                         end;
                 end;

       cmclass:begin
               Class(SelecZone,SelectClassMode);
               ClearEvent(Event);
               end;
       cmsearch:begin
                if GetMontant(Mont) then Search(Mont);
                ClearEvent(Event);
                end;
       cmSoldeCopy:begin
                   CopierSolde(False);
                   ClearEvent(Event);
                   end;
       cmSoldeSCopy:begin
                    CopierSolde(True);
                    ClearEvent(Event);
                    end;
       cmcopy:begin
              Copier(SelecZone);
              ClearEvent(Event);
              end;
       cmcut:begin
             modif^:=true;
             Copier(SelecZone);
             Couper(SelecZone);
             SelecZone.Assign(0,0,0,0);
             NEvent.What:=evCommand;
             NEvent.Command:=cmcptupdate;
             NEvent.InfoPtr:=@self;
             PutEvent(NEvent);
             ClearEvent(Event);
             DrawView;
             end;
       cmdestroy:begin
                 modif^:=true;
                 Couper(SelecZone);
                 SelecZone.Assign(0,0,0,0);
                 NEvent.What:=evCommand;
                 NEvent.Command:=cmcptupdate;
                 NEvent.InfoPtr:=@self;
                 PutEvent(NEvent);
                 ClearEvent(Event);
                 DrawView;
                 end;
       cmpaste:begin
               modif^:=true;
               if CaseCour.Y+Delta.Y>NbLignes then CaseCour.Y:=0;
               Coller(SelecZone,CaseCour.Y+Delta.Y,CaseCour.X);
               NEvent.What:=evCommand;
               NEvent.Command:=cmcptupdate;
               NEvent.InfoPtr:=@self;
               PutEvent(NEvent);
               ClearEvent(Event);
               DrawView;
               end;
       cmCnewline:begin
                  modif^:=true;
                  CreerLigne(NbLignes);
                  setlimit(0,NbLignes+1);
                  CptList.IdCOPY(@self);
                  ClearEvent(Event);
                  DrawView;
                  end;
     end;
  if SelecZone.A.Y>=NbLignes then
     begin
     SelecZone.A.Y:=NbLignes-1;
     SelecZone.B.Y:=NbLignes-1;
     if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
     DrawView;
     end;
  if SelecZone.B.Y>NbLignes then
     begin
     SelecZone.B.Y:=NbLignes;
     if (RFicname=PP_NAME) then CptList.IdCOPY(@self);
     DrawView;
     end;

  end; { Handle After - not edit mode }



begin { ------ TCompte.HandleEvent ------ }

if not EditMode then HandleBefore else EditHandle;
TScroller.HandleEvent(Event);
if not EditMode then HandleAfter;
if (SelecZone.B.Y=-1) or (SelecZone.A.Y=-1)
    then begin
         SelecZone.assign(0,0,0,0);
         DrawView;
         end;

end;


{ ----------------> GetTyp <---------------- }

function TCompte.GetTyp:string;

  var R:TRect;
      C:PRadioButtons;
      Dialog:PDialog;
      Control:Word;
      BData:record
            Form:word;
            end;
      V:PView;
      I:byte;
      Item,NItem:PSItem;
      StrItem:string;

begin
GetTyp:=#255;
R.Assign(10,3,70,12+MAX_TYP);
Dialog:=New(PDialog,Init(R,'Choix d''un type'));
with Dialog^ do
  begin
  helpctx:=hcNoContext;
  R.Assign(7,5+MAX_TYP,17,7+MAX_TYP);
  V:=(New (PButton, Init(R,' ~O~k', cmok, bfDefault)));
  V^.helpCtx:=hcOkPrintBtn;
  insert(V);
  R.Assign(30,5+MAX_TYP,43,7+MAX_TYP);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.HelpCtx:=hcCancelBtn;
  insert(V);

  R.assign(2,3,58,4+MAX_TYP);
  Item:=Nil;
  for i:= 1 to MAX_TYP do
     begin
     NItem:=Item;
     StrItem:='~'+chr(65+MAX_TYP-i)+'~ '+FastTyp[MAX_TYP-i+1];
     Item:=NewSItem(StrItem,NItem);
     end;

  C:=New(PRadioButtons, Init(R, Item));
  C^.helpCtx:=hcLibre0;
  insert(C);

  BData.Form:=0;
  SetData(BData);
  Options:=Options or ofCentered;
  end;

Control:=DeskTop^.ExecView(Dialog);
if Control=cmcancel then exit;
Dialog^.GetData(BData);
Dispose(Dialog,Done);
GetTyp:=FastTyp[BData.Form+1];
end;



{ +--------------------------------------------------------------------+  }
{ |                              TFenCpt                               |  }
{ +--------------------------------------------------------------------+  }


{ ----------------> INIT <---------------- }

Constructor TFenCpt.Init(Bounds:Trect; var Cpt:TCptDef );

var VFenStatus:PFenStatus;
    R,RS:TRect;
    ScBar:PScrollBar;
    Num:byte;
    Nom:TName;
    E:ECatalog;
    Rep:string;

begin
Num:=1;
Options := Options or ofCentered;
while (Num<=9) and FenOpen[Num] do inc(Num);
if (Cpt.Mode and mdPressPap)=0 then MakeName(Cpt,Nom,E)
                               else begin
                                    Nom:=PP_NAME;
                                    E.LIB1:=PP_LIB1;
                                    E.LIB2:=PP_LIB2;
                                    E.LIB3:=PP_LIB3;
                                    E.mode:=Cpt.Mode;
                                    end;


if (Cpt.Mode and mdVirtual)=0
                        then begin
                             if Num=10 then Num:=wnnonumber
                                       else FenOpen[Num]:=true;
                             end
                        else Num:=wnnonumber;

TWindow.init(Bounds,Cpt.Name,Num);

HelpCtx:=hcCptFen;

CptDef:=Cpt;
GetExtent(R);
R.Grow(-1,-1);
R.A.Y:=R.B.Y-2;
VFenStatus:=New(PFenStatus, Init(R,@self));
insert(VFenStatus);

GetExtent(R);
R.Grow(-2,-4);
R.B.Y:=R.B.Y-3;
RS.Assign(R.B.X,R.A.Y , R.B.X+1, R.B.Y);
ScBar:=New(PScrollBar, Init(RS));
ScBar^.options:=ScBar^.options or ofpostprocess;
getdir(0,CptDef.Repert);
Rep:=CptDef.Repert;
if rep[length(Rep)]<>'\' then rep:=rep+'\';
if nom=PP_NAME then begin
                    CptDef.Repert:='';
                    Rep:='';
                    end;
VCompte:=New(PCompte, Init(R, ScBar, Nom,Rep) );
VCompte^.DragMode:=DmLimitAll;
VCompte^.HelpCtx:=HelpCtx;

GetExtent(R);
R.Grow(-2,-2);
R.A.Y:=R.B.Y-4;
R.B.Y:=R.A.Y+2;
VCptStatus:=New(PCptStatus, Init(R,VCompte));
insert(VCptStatus);

GetExtent(R);
R.Grow(-2,-2);
R.B.Y:=R.A.Y+1;
VLegend:=New(PLegend, Init(R,E.LIB1,E.LIB2,E.LIB3));
insert(VLegend);

insert(ScBar);
insert(VCompte);

CptList.Reference(@Self);
Options:=Options or OfTileable or ofCentered;
end;

{ ----------------> VALID <----------------}

function TFenCpt.Valid(com:word):boolean;

var ok:boolean;
    R:TRect;
    Mess,NUM:string;

begin
ok:=TWindow.Valid(com);
Mess:=CptDef.Name;
if (CptDef.Mode and mdmensuel)=mdmensuel then
     begin
     case CptDef.Mois of
       1:NUM:='JANVIER';
       2:NUM:='FEVRIER';
       3:NUM:='MARS';
       4:NUM:='AVRIL';
       5:NUM:='MAI';
       6:NUM:='JUIN';
       7:NUM:='JUILLET';
       8:NUM:='AOUT';
       9:NUM:='SEPTEMBRE';
       10:NUM:='OCTOBRE';
       11:NUM:='NOVEMBRE';
       12:NUM:='DECEMBRE';
       end;
     Mess:=Mess+' '+NUM;
     end;
if (CptDef.Mode and mdannuel)=mdannuel then
     begin
     str(CptDef.Annee:4,NUM);
     Mess:=Mess+' '+NUM;
     end;
if (CptDef.Mode and mdprev)=mdprev then
     if CptDef.Prev then Mess:=Mess+' PREVISION'
                    else Mess:=Mess+' NORMAL';

if ok and ( (com=cmclose) or (com=cmquit)) and VCompte^.EditMode and ((CptDef.Mode and mdPressPap)=0) then
 begin
 Beep;
 R.Assign(1,7,78,14);
 MessageBoxRect(R,^C+'Impossible: '+Mess+' en cours d''dition.',nil, mfError + mfOkButton);
 ok:=false;
 end;

if ok and ( ((com=cmclose) and (CptList.LastOne(VCompte)) )
         or (com=cmquit) ) and (VCOmpte^.modif^) and ((CptDef.Mode and mdPressPap)=0) then
 if Autosavemode then
   begin
   VCompte^.Sauver;
   end
 else
   begin
   Beep;
   R.Assign(5,7,75,14);
   case MessageBoxRect(R,^C+'Sauver '+Mess+'.',nil, mfWarning + mfYesNoCancel) of
     cmyes: VCompte^.sauver;
     cmno:;
     cmcancel:ok:=false;
     end;

   end;
Valid:=ok;
end;



{ ----------------> SIZE LIMITS <---------------- }

procedure TFenCpt.SizeLimits(var Min,Max:TPoint);

begin
TWindow.SizeLimits(Min,Max);
Min.x:=MIN_WIN_X;
Min.y:=MIN_WIN_Y;
if ScreenWidth>100 then Min.X:=MIN_WIN_X132;
end;


{ ----------------> GET PALETTE <----------------

function TFenCpt.GetPalette:PPalette;

const

 CMaPalette = CBlueWindow+#41#42#43#44#45#46;
 PMaPalette: string[length(CMaPalette)] = CMaPalette;

var Pal:PPalette;
    f:byte;

begin

Pal:=TWindow.getpalette;
for f:=1 to length(Pal^) do PMaPalette[f]:=Pal^[f];
GetPalette:= @PMaPalette;

end;

}


{ ----------------> HANDLE EVENT <---------------- }

procedure TFenCpt.HandleEvent(var Event:TEvent);


begin

  if (Event.what=evcommand) and (Event.command=cmcptupdate) then
   begin
     VCptStatus^.update;
     ClearEvent(Event);
   end;

  TWindow.HandleEvent(Event);

  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cmclose:begin
                  ClearEvent(Event);
                  close;
                  end;
          cmCsave:begin
                 VCompte^.sauver;
                 ReDraw;
                 end;
          cmCsaveall:CptList.saveall;
          cmprint:printcpt;
          cmprintall:CptList.printall;
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
    evbroadcast:if Event.Command=cmfindcpt
                   then begin
                        OkCutCopy:=(not VCompte^.EditMode)
                               and (VCompte^.SelecZone.B.X>VCompte^.SelecZone.A.X)
                               and (VCompte^.SelecZone.B.Y>VCompte^.SelecZone.A.Y);
                        LastCptDef:=CptDef;
                        ClearEvent(Event);
                        end;


  end;

end;


{ ================> Print Cpt <============= }

procedure TFenCpt.printCpt;

const LPARPAGE=50;

var cha,time,date:string[20];
    SPC,STRCRE,STRDEB,STRLIB,Name,head,stri:string;
    m,i,l,P,LgSpc:byte;
    annee,mois,jour,joursem,heure,min,sec,sec100:word;
    code:integer;
    NUM:string;
    SoldeI,SoldeIM:real;

begin
gettime(heure,min,sec,sec100);
getdate(annee,mois,jour,joursem);
str(heure,cha);cha:=copy('0'+cha,length(cha),2);time:=cha+':';
str(min,cha);cha:=copy('0'+cha,length(cha),2);time:=time+cha;
str(jour,cha);cha:=copy('0'+cha,length(cha),2);date:=cha+'/';
str(mois,cha);cha:=copy('0'+cha,length(cha),2);date:=date+cha+'/';
str(annee:4,cha);date:=date+cha;
head:='Date : '+date+'  -  Heure : '+time+'  -  Page : ';
Name:=CptDef.Name;
if (CptDef.Mode and mdmensuel)=mdmensuel then
     begin
     case CptDef.Mois of
       1:NUM:='JANVIER';
       2:NUM:='FEVRIER';
       3:NUM:='MARS';
       4:NUM:='AVRIL';
       5:NUM:='MAI';
       6:NUM:='JUIN';
       7:NUM:='JUILLET';
       8:NUM:='AOUT';
       9:NUM:='SEPTEMBRE';
       10:NUM:='OCTOBRE';
       11:NUM:='NOVEMBRE';
       12:NUM:='DECEMBRE';
       end;
     Name:=Name+' '+NUM;
     end;
   if (CptDef.Mode and mdannuel)=mdannuel then
     begin
     str(CptDef.Annee:4,NUM);
     Name:=Name+' '+NUM;
     end;
   if (CptDef.Mode and mdprev)=mdprev then
     if CptDef.Prev then Name:=Name+' PREVISION'
                    else Name:=Name+' NORMAL';
case Format of
  1:with VCompte^ do
     begin
     if length(VLegend^.LIB1)<23 then LgSpc:=(23-length(VLegend^.LIB1)) div 2 else LgSpc:=0;
     SPC:=copy(SPACE,1,LgSpc);
     STRLIB:=copy(SPC+VLegend^.LIB1+SPC+' ',1,23);

     if length(VLegend^.LIB2)< 8 then LgSpc:=(8-length(VLegend^.LIB2)) div 2 else LgSpc:=0;
     SPC:=copy(SPACE,1,LgSpc);
     STRCRE:=copy(SPC+VLegend^.LIB2+SPC+' ',1,8);
     if length(VLegend^.LIB3)< 8 then LgSpc:=(8-length(VLegend^.LIB3)) div 2 else LgSpc:=0;
     SPC:=copy(SPACE,1,LgSpc);
     STRDEB:=copy(SPC+VLegend^.LIB3+SPC+' ',1,8);

     SoldeI:=Credit;
     l:=0;
     P:=0;
     while l<NbLignes do
      begin
      if (P and 1)=0 then
         begin
         printcmd(prinit);
         str(P+1:2,NUM);
         println(head+NUM);
         println(Name);
         end
        else
         begin
         printcmd(prinit);
         str(P+1:2,NUM);
         println(head+NUM);
         println(Name);
         end;
      SoldeIM:=SoldeI;
      for i:=0 to 14 do
        if l+i<NbLignes then SoldeIM:=SoldeIM+Lignes[l+i]^.Cre-Lignes[L+i]^.Deb;

      printcmd(pr12CPI);
      printcmd(prcondense);
      println('');
      print('ͻ');
      println('ͻ');
      print(' N   DATE  '+STRLIB+''+STRCRE+''+STRDEB+'  SOLDE  ');
      println(' N   DATE  '+STRLIB+''+STRCRE+''+STRDEB+'  SOLDE  ');
      print('͹');
      println('͹');
      for i:=0 to 14 do
         begin
         if l+i<NBLignes then
                            begin
                            str(l+i:3,NUM);
                            print(''+NUM);
                            if Lignes[l+i]^.Sel then print('') else print(' ');
                            print(''+copy(Lignes[l+i]^.date+'        ',1,8)+'');
                            print(copy(copy(Lignes[l+i]^.lib,1,23)+'                       ',1,23));
                            str(Lignes[L+i]^.Cre:8:2,NUM);
                            print(''+NUM+'');
                            str(Lignes[L+i]^.Deb:8:2,NUM);
                            print(NUM+'');
                            soldeI:=soldeI+Lignes[l+i]^.cre-Lignes[l+i]^.deb;
                            str(SoldeI:9:2,NUM);
                            print(NUM+'');
                            end
                         else
                            begin
                            str(l+i:3,NUM);
                            print(''+NUM+'   /  /  ________________________________________________');
                            end;
         if (l+i)+15<NBLignes then
                            begin
                            str(l+i+15:3,NUM);
                            print(''+NUM);
                            if Lignes[l+i+15]^.Sel then print('') else print(' ');
                            print(''+copy(Lignes[l+i+15]^.date+'        ',1,8)+'');
                            print(copy(copy(Lignes[l+i+15]^.lib,1,23)+'                       ',1,23));
                            str(Lignes[L+i+15]^.Cre:8:2,NUM);
                            print(''+NUM+'');
                            str(Lignes[L+i+15]^.Deb:8:2,NUM);
                            print(NUM+'');
                            soldeIM:=soldeIM+Lignes[l+i+15]^.cre-Lignes[l+i+15]^.deb;
                            str(SoldeIM:9:2,NUM);
                            println(NUM+'');
                            end
                         else
                            begin
                            str(l+i+15:3,NUM);
                            println(''+NUM+'   /  /  ________________________________________________');
                            end;
         end;
      print('ͼ');
      println('ͼ');
      println('');
      SoldeI:=SoldeIM;
      l:=l+30;
      P:=P+1;
      if (P and 1)=0 then endpage;
      end;
     if (P and 1)=1 then endpage;
     endprint;
     end;
  0:with VCompte^ do
     begin
     SoldeI:=Credit;
     P:=1;
     l:=0;
     while l<NbLignes do
      begin
      printcmd(prinit);
      str(P:2,NUM);
      println(head+NUM);
      println(Name);
      println('');
      if length(VLegend^.LIB1)<23 then LgSpc:=(40-length(VLegend^.LIB1)) div 2 else LgSpc:=0;
      SPC:=copy(SPACE,1,LgSpc);
      STRLIB:=copy(SPC+VLegend^.LIB1+SPC+' ',1,40);

      if length(VLegend^.LIB2)< 8 then LgSpc:=(8-length(VLegend^.LIB2)) div 2 else LgSpc:=0;
      SPC:=copy(SPACE,1,LgSpc);
      STRCRE:=copy(SPC+VLegend^.LIB2+SPC+' ',1,8);
      if length(VLegend^.LIB3)< 8 then LgSpc:=(8-length(VLegend^.LIB3)) div 2 else LgSpc:=0;
      SPC:=copy(SPACE,1,LgSpc);
      STRDEB:=copy(SPC+VLegend^.LIB3+SPC+' ',1,8);


      println('ͻ');
      println(' N   DATE  '+STRLIB+''+STRCRE+''+STRDEB+'TYPE');
      println('͹');
      for i:=0 to LPARPAGE+1 do
         begin
         if l+i<NBLignes then
                            begin
                            str(l+i:2,NUM);
                            print(' '+NUM+'');
                            if Lignes[l+i]^.Sel then print('') else print(' ');
                            print(''+copy(Lignes[l+i]^.date+'        ',1,8)+'');
                            print(copy(Lignes[l+i]^.lib+SPACE,1,40));
                            str(Lignes[L+i]^.Cre:8:2,NUM);
                            print(''+NUM+'');
                            str(Lignes[L+i]^.Deb:8:2,NUM);
                            print(NUM);
                            print(''+copy(Lignes[l+i]^.Typ+'    ',1,4));
                            println('');
                            end;
         end;
      println('ͼ');
      println('');
      l:=l+LPARPAGE+2;
      P:=P+1;
      if l>=NbLignes then
         begin
         str(Credit:11:2,NUM);
         print(' Crdit Initial : '+NUM);
         str(CreditS:11:2,NUM);
         println('   -->   Avec selecteur : '+NUM);
         str(Solde:11:2,NUM);
         print(' Solde final    : '+NUM);
         str(SoldeS:11:2,NUM);
         println('   -->   Avec selecteur : '+NUM);
         end
       else
         begin
         println('');
         println('                                                                 .../...');
         end;
      endpage;
      end;
     endprint;
     end;
  end
end;


{ ----------------> DONE <---------------- }

destructor TFenCpt.done;

begin
CptList.Unreference(@Self);
if (Number>0) and (Number<10) then FenOpen[Number]:=false;
Twindow.done;
end;


{ +--------------------------------------------------------------------+  }
{ |                             TCptList                               |  }
{ +--------------------------------------------------------------------+  }

{ ................ suivant .................. }
function suivant(a,b:string):boolean;

var l:byte;

begin
l:=length(a);
if l<>length(b) then begin suivant:=false; exit; end;
suivant:= (copy(a,1,l-9)=copy(b,1,l-9)) and ( copy(a,l-8,5)>copy(b,l-8,5) );
end;


{ ................ precedent ................ }
function precedent(a,b:string):boolean;

var l:byte;

begin
l:=length(a);
if l<>length(b) then begin precedent:=false; exit; end;
precedent:= (copy(a,1,l-9)=copy(b,1,l-9)) and ( copy(a,l-8,5)<copy(b,l-8,5) );
   { l-9 = 3 }

end;


{ ----------------> INIT <---------------- }


constructor TCptList.Init;

var i:integer;

begin
TObject.Init;
for i:=1 to MAX_CPT do Tableau[i]:=nil;

end;



{ ==============> REFERENCE <================= }


procedure TCptList.Reference(Ref:PFenCpt);

var i:integer;

begin
i:=1;
while Tableau[i]<>nil do inc(i);
Tableau[i]:=Ref;
end;


{ =============> UNREFERENCE <================ }

procedure TCptList.UnReference(Ref:PFenCpt);

var i:integer;

begin
i:=1;
while Tableau[i]<>Ref do inc(i);
Tableau[i]:=nil;
end;


{ ===============> Charger <================== }

function TCPtList.Charger(Cpt:PCompte):boolean;

var i:integer;
    ok:boolean;

begin
i:=0;
ok:=false;
while (i<MAX_CPT) and (not ok) do
    begin
    inc(i);
    ok:=(Tableau[i]<>nil) and (Tableau[i]^.VCompte<>Cpt) and (Tableau[i]^.VCompte^.RFicName=Cpt^.RFicName);
    end;
if ok then
    begin
    Cpt^.NbLignes:=Tableau[i]^.VCompte^.NbLignes;
    Cpt^.Lignes:=Tableau[i]^.VCompte^.Lignes;
    Cpt^.SoldeS:=Tableau[i]^.VCompte^.SoldeS;
    Cpt^.Solde:=Tableau[i]^.VCompte^.Solde;
    Cpt^.CreditS:=Tableau[i]^.VCompte^.CreditS;
    Cpt^.Credit:=Tableau[i]^.VCompte^.Credit;
    Cpt^.OSoldeS:=Tableau[i]^.VCompte^.OSoldeS;
    Cpt^.OSolde:=Tableau[i]^.VCompte^.OSolde;
    Cpt^.OCreditS:=Tableau[i]^.VCompte^.OCreditS;
    Cpt^.OCredit:=Tableau[i]^.VCompte^.OCredit;
    Cpt^.LastSave:=Tableau[i]^.VCompte^.LastSave;
    Cpt^.Modif:=Tableau[i]^.VCompte^.Modif;
    if Cpt^.RFicName=PP_NAME then Cpt^.SelecZone:=CptPressPap^.VCompte^.selecZone;
    end;
Charger:=Ok;
end;

{ ===============> Last One <================== }

function TCPtList.LastOne(Cpt:PCompte):boolean;

var i:integer;
    ok:boolean;

begin
i:=0;
ok:=false;
if Cpt^.RFicName=PP_NAME then begin LastOne:=false; exit; end;
while (i<MAX_CPT) and (not ok) do
    begin
    inc(i);
    ok:=(Tableau[i]<>nil) and (Tableau[i]^.VCompte<>Cpt) and (Tableau[i]^.VCompte^.RFicName=Cpt^.RFicName);
    end;
LastOne:=not Ok;
end;


{ ===============> Save All <================== }

procedure TCPtList.SaveAll;

var i:integer;

begin
for i:=1 to MAX_CPT do
  if (Tableau[i]<>nil) and (Tableau[i]^.VCompte^.Modif^) and (Tableau[i]^.VCompte^.RFicName<>PP_NAME)
    then begin
         Tableau[i]^.VCompte^.Sauver;
         Tableau[i]^.Redraw;
         end;

end;


{ ===============> Print All <================== }

procedure TCPtList.PrintAll;

var i:integer;

begin
for i:=1 to MAX_CPT do
  if (Tableau[i]<>nil) and (Tableau[i]<>CptPressPap)
    then begin
         Tableau[i]^.PrintCpt;
         end;

end;



{ ===============> ID MAJ <================== }

procedure TCPtList.IdMAJ(Cpt:PCompte);

var i:integer;

begin

for i:=1 to MAX_CPT do
 if (Tableau[i]<>nil) and (Tableau[i]^.VCompte<>Cpt) and (Tableau[i]^.VCompte^.RFicName=Cpt^.RFicName) then
   begin
   Tableau[i]^.VCompte^.SoldeS:=Cpt^.SoldeS;
   Tableau[i]^.VCompte^.Solde:=Cpt^.Solde;
   Tableau[i]^.VCompte^.CreditS:=Cpt^.CreditS;
   Tableau[i]^.VCompte^.Credit:=Cpt^.Credit;
   Tableau[i]^.VCompte^.LastSave:=Cpt^.LastSave;
   Tableau[i]^.VCompte^.DrawView;
   Tableau[i]^.VCptStatus^.Update;
   end;
end;

{ ===============> ID COPY <================== }

procedure TCPtList.IdCOPY(Cpt:PCompte);

var i:integer;

begin

for i:=1 to MAX_CPT do
 if (Tableau[i]<>nil) and (Tableau[i]^.VCompte<>Cpt) and (Tableau[i]^.VCompte^.RFicName=Cpt^.RFicName) then
   begin
   Tableau[i]^.VCompte^.NbLignes:=Cpt^.NbLignes;
   Tableau[i]^.VCompte^.Lignes:=Cpt^.Lignes;
   Tableau[i]^.VCompte^.SoldeS:=Cpt^.SoldeS;
   Tableau[i]^.VCompte^.Solde:=Cpt^.Solde;
   Tableau[i]^.VCompte^.CreditS:=Cpt^.CreditS;
   Tableau[i]^.VCompte^.Credit:=Cpt^.Credit;
   Tableau[i]^.VCompte^.OSoldeS:=Cpt^.OSoldeS;
   Tableau[i]^.VCompte^.OSolde:=Cpt^.OSolde;
   Tableau[i]^.VCompte^.OCreditS:=Cpt^.OCreditS;
   Tableau[i]^.VCompte^.OCredit:=Cpt^.OCredit;
   Tableau[i]^.VCompte^.LastSave:=Cpt^.LastSave;
   Tableau[i]^.VCompte^.EditMode:=false;
   if Cpt^.RFicName=PP_NAME then
     begin
     Tableau[i]^.VCompte^.SelecZone:=Cpt^.SelecZone;
     end;
   Tableau[i]^.VCompte^.SetLimit(0,Cpt^.NbLignes+1);
   Tableau[i]^.ReDraw;
   end;
end;


{ ===============> MEM MAJ <================== }

procedure TCPtList.MemMAJ(Cpt:PCompte; add,sadd:real);

var i:integer;

begin

for i:=1 to MAX_CPT do
 if (Tableau[i]<>nil) and (Tableau[i]^.VCompte<>Cpt) and
     suivant(Tableau[i]^.VCompte^.RFicName,Cpt^.RFicName) then
   begin
   Tableau[i]^.VCompte^.SoldeS:=Tableau[i]^.VCompte^.SoldeS+sadd;
   Tableau[i]^.VCompte^.Solde:=Tableau[i]^.VCompte^.Solde+add;
   Tableau[i]^.VCompte^.CreditS:=Tableau[i]^.VCompte^.CreditS+sadd;
   Tableau[i]^.VCompte^.Credit:=Tableau[i]^.VCompte^.Credit+add;
   Tableau[i]^.VCptStatus^.Update;
   end;
end;

{ ===============> O MEM MAJ <================== }

procedure TCPtList.OMemMAJ(Cpt:PCompte; add,sadd:real);

var i:integer;

begin

for i:=1 to MAX_CPT do
 if (Tableau[i]<>nil) and (Tableau[i]^.VCompte<>Cpt) and
     suivant(Tableau[i]^.VCompte^.RFicName,Cpt^.RFicName) then
   begin
   Tableau[i]^.VCompte^.OSoldeS:=Tableau[i]^.VCompte^.OSoldeS+sadd;
   Tableau[i]^.VCompte^.OSolde:=Tableau[i]^.VCompte^.OSolde+add;
   Tableau[i]^.VCompte^.OCreditS:=Tableau[i]^.VCompte^.OCreditS+sadd;
   Tableau[i]^.VCompte^.OCredit:=Tableau[i]^.VCompte^.OCredit+add;
   end;
end;


{ ===============> CHERCHE PREC <================== }

procedure TCPtList.CherchePrec(Cpt:PCompte; var add,sadd:real);

var I,Last:integer;
    oldsol,soldsol,x:real;

begin
Last:=0;
for i:=1 to MAX_CPT do
 if (Tableau[i]<>nil) and (Tableau[i]^.VCompte<>Cpt) and
     precedent(Tableau[i]^.VCompte^.RFicName,Cpt^.RFicName) then
   if (Last=0) or (suivant(Tableau[i]^.VCompte^.RFicName,Tableau[Last]^.VCompte^.RFicName))
     then Last:=i;

add:=0;
sadd:=0;

if Last<>0 then
   begin
   sadd:=Tableau[Last]^.VCompte^.SoldeS-Tableau[Last]^.VCompte^.OSoldeS;
   add:=Tableau[Last]^.VCompte^.Solde-Tableau[Last]^.VCompte^.OSolde;
   end;

end;


{ ===============> DISK MAJ <================== }

procedure TCPtList.DiskMAJ(Cpt:PCompte; add,sadd:real);

var DirInfo:SearchRec;
    SName,FicName:TName;
    Name:NameStr;
    Ext:ExtStr;
    OldRep:string;
    Rep:DirStr;
    f:File;
    version,Credit,CreditS,Solde,SoldeS:real;
    R:TRECT;VERSTR:string;

begin
FSplit(Cpt^.RFicName,Rep,Name,Ext);
FicName:=Name+ext;
if rep[length(rep)]='\' then rep:=copy(rep,1,length(rep)-1);
getdir(0,Oldrep);
chdir(Rep);
SName:=copy(FicName,1,3)+'*.'+BASE_EXT;
findfirst(SName,AnyFile,DirInfo);
while DosError=0 do
   begin
   if suivant(DirInfo.Name,FicName) then
      begin
      assign(f,DirInfo.Name);
      reset(f,1);
      blockread(f,version,sizeof(version));
      blockread(f,Credit,sizeof(Credit));
      blockread(f,CreditS,sizeof(CreditS));
      blockread(f,Solde,sizeof(Solde));
      blockread(f,SoldeS,sizeof(SoldeS));

      Credit:=round(Credit*100)/100;
      CreditS:=round(CreditS*100)/100;
      Solde:=round(Solde*100)/100;
      SoldeS:=round(SoldeS*100)/100;

      Credit:=Credit+add;
      Solde:=Solde+add;
      CreditS:=CreditS+sadd;
      SoldeS:=SoldeS+sadd;
      seek(f,0);
      blockread(f,version,sizeof(version));
      if version<>VER_UNIT
        then
            begin
            Beep;
            str(version,VERSTR);
            R.Assign(1,7,78,14);
            MessageBoxRect(R,^C+'Problme de version:'+VERSTR,nil, mfError + mfOkButton);
            end;

      Credit:=round(Credit*100)/100;
      CreditS:=round(CreditS*100)/100;
      Solde:=round(Solde*100)/100;
      SoldeS:=round(SoldeS*100)/100;

      blockwrite(f,Credit,sizeof(Credit));
      blockwrite(f,CreditS,sizeof(CreditS));
      blockwrite(f,Solde,sizeof(Solde));
      blockwrite(f,SoldeS,sizeof(SoldeS));
      close(f);
      end;
   findnext(DirInfo);
   end;
chdir(OldRep);
end;

{ ===============> DISK PREC <================== }

procedure TCPtList.DiskPrec(Cpt:PCompte; var Credit,CreditS:real);

var
    version,oldsol,soldsol,x:real;
    DirInfo:SearchRec;
    SName,Last,FicName:TNAME;
    Name:NameStr;
    Ext:ExtStr;
    OldRep:string;
    Rep:DirStr;
    f:File;
    R:TRECT;VERSTR:string;

begin
FSplit(Cpt^.RFicName,Rep,Name,Ext);
FicName:=Name+Ext;
if rep[length(rep)]='\' then rep:=copy(rep,1,length(rep)-1);
getdir(0,Oldrep);
chdir(Rep);
SName:=copy(FicName,1,3)+'*.'+BASE_EXT;
findfirst(SName,AnyFile,DirInfo);
Last:='';
while DosError=0 do
   begin
   if precedent(DirInfo.Name,FicName) and
      ( (Last='') or suivant(DirInfo.Name,Last) ) then Last:=DirInfo.Name;
   findnext(DirInfo);
   end;

Credit:=0;
CreditS:=0;

if last<>'' then
      begin
      assign(f,Last);
      reset(f,1);
      blockread(f,version,sizeof(version));

if version<>VER_UNIT
        then
            begin
            Beep;
            str(version,VERSTR);
            R.Assign(1,7,78,14);
            MessageBoxRect(R,^C+'Problme de version:'+VERSTR,nil, mfError + mfOkButton);
            end;

      blockread(f,Credit,sizeof(Credit));
      blockread(f,CreditS,sizeof(CreditS));
      blockread(f,Credit,sizeof(Credit));     { En fait Solde  }
      blockread(f,CreditS,sizeof(CreditS));   { En fait SoldeS }

      Credit:=round(Credit*100)/100;
      CreditS:=round(CreditS*100)/100;

      close(f);
      end;
chdir(OldRep);
end;


{ ----------------> DONE <---------------- }

destructor TCptList.Done;

begin
TObject.Done;
end;


{ =====> Procedure utilisateur: Bilan d'un compte <==== }

procedure Bilan(Cpt:TCptDef);

var Last,SName,NCpt:TName;
    ECpt:ECatalog;
    f:file;
    Credit,CreditS,Solde,SoldeS,version:real;
    NUM:String;
    DirInfo:SearchRec;

begin
Cpt.Prev:=false;
MakeName(Cpt,NCpt,ECpt);

if (Cpt.Mode and mdmensuel)=mdmensuel then
   begin
   case Cpt.Mois of
       1:NUM:='JANVIER';
       2:NUM:='FEVRIER';
       3:NUM:='MARS';
       4:NUM:='AVRIL';
       5:NUM:='MAI';
       6:NUM:='JUIN';
       7:NUM:='JUILLET';
       8:NUM:='AOUT';
       9:NUM:='SEPTEMBRE';
       10:NUM:='OCTOBRE';
       11:NUM:='NOVEMBRE';
       12:NUM:='DECEMBRE';
       end;
   printcmd(prgras);
   print('Mois de '+NUM);
   if (Cpt.Mode and mdannuel)=mdannuel then
     begin
     str(Cpt.Annee,NUM);
     print(' '+NUM);
     end;
   println(' : ');
   printcmd(prfingras);
   end;

assign(f,NCpt);
{$I-}
reset(f,1);
{$I+}
if ioresult<>0
  then begin
       SName:=copy(NCpt,1,3)+'*.'+BASE_EXT;
       findfirst(SName,AnyFile,DirInfo);
       Last:='';
       while DosError=0 do
         begin
       if precedent(DirInfo.Name,NCpt) and
         ( (Last='') or suivant(DirInfo.Name,Last) ) then Last:=DirInfo.Name;
       findnext(DirInfo);
       end;

       Credit:=0;
       CreditS:=0;

       if last<>'' then
         begin
         assign(f,Last);
         reset(f,1);
         blockread(f,version,sizeof(version));
         blockread(f,Credit,sizeof(Credit));
         blockread(f,CreditS,sizeof(CreditS));
         blockread(f,Credit,sizeof(Credit));     { En fait Solde  }
         blockread(f,CreditS,sizeof(CreditS));   { En fait SoldeS }
         close(f);
         end;

       Solde:=Credit;
       SoldeS:=CreditS;
       end
  else begin
       blockread(f,version,sizeof(version));
       blockread(f,Credit,sizeof(Credit));
       blockread(f,CreditS,sizeof(CreditS));
       blockread(f,Solde,sizeof(Solde));
       blockread(f,SoldeS,sizeof(SoldeS));
       close(f);
       end;

str(Credit:10:2,NUM);
print('    Crdit Initial  : '+NUM);
str(CreditS:10:2,NUM);
println('   -    avec slecteur : '+NUM);
str(Solde:10:2,NUM);
print('    Solde Final     : '+NUM);
str(SoldeS:10:2,NUM);
println('   -    avec slecteur : '+NUM);

if (Cpt.Mode and mdprev)=mdprev then
  begin
  Cpt.Prev:=true;
  MakeName(Cpt,NCpt,ECpt);
  assign(f,NCpt);
  {$I-}
  reset(f,1);
  {$I+}
  if ioresult=0
    then begin
         blockread(f,version,sizeof(version));
         blockread(f,Credit,sizeof(Credit));
         blockread(f,CreditS,sizeof(CreditS));
         blockread(f,Solde,sizeof(Solde));
         blockread(f,SoldeS,sizeof(SoldeS));
         close(f);
         end;
  str(Solde:10:2,NUM);
  print('    Solde Prvision : '+NUM);
  str(SoldeS:10:2,NUM);
  println('   -    avec slecteur : '+NUM);
  end;
println('');

end;

{ =====> Procedure utilisateur: Bilan d'un compte par type <==== }

procedure TypBilan(Cpt:TCptDef; var Fic:text; var nbtyp:integer ; dowr:boolean);

var Last,SName,NCpt:TName;
    ECpt:ECatalog;
    f:file;
    Credit,CreditS,Solde,SoldeS,version:real;
    NUM:String;
    DirInfo:SearchRec;
    Ligne:TLigne;
    Reserved:Array[1..LGRESERV] of char;
    D:array[1..7] of word;
    NbLig,i:integer;
    p:byte;
    findtyp:boolean;


begin
MakeName(Cpt,NCpt,ECpt);
if (Cpt.Mode and mdmensuel)=mdmensuel then
   begin
   case Cpt.Mois of
       1:NUM:='JANVIER';
       2:NUM:='FEVRIER';
       3:NUM:='MARS';
       4:NUM:='AVRIL';
       5:NUM:='MAI';
       6:NUM:='JUIN';
       7:NUM:='JUILLET';
       8:NUM:='AOUT';
       9:NUM:='SEPTEMBRE';
       10:NUM:='OCTOBRE';
       11:NUM:='NOVEMBRE';
       12:NUM:='DECEMBRE';
       end;
   if dowr then write(fic,'Mois de '+NUM);
   if (Cpt.Mode and mdannuel)=mdannuel then
     begin
     str(Cpt.Annee,NUM);
     if dowr then write(fic,' '+NUM);
     end;
   if dowr then write(fic,' ');
   end
   else if dowr then write(fic,'Compe unique (ANNUEL)  ');
if (Cpt.Mode and mdprev)=mdprev then
  if Cpt.prev then if dowr then write(fic,'[PREV] ');
if dowr then writeln(fic,': ');
if dowr then writeln(fic,'TYPE,CREDIT,DEBIT,SOLDE');
assign(f,NCpt);
{$I-}
reset(f,1);
{$I+}
if ioresult<>0
  then begin
       if dowr then writeln(fic);
       end
  else begin
       blockread(f,version,sizeof(version));
       blockread(f,Credit,sizeof(Credit));
       blockread(f,CreditS,sizeof(CreditS));
       blockread(f,Solde,sizeof(Solde));
       blockread(f,SoldeS,sizeof(SoldeS));

       { Lecture de la date et heure }
       blockread(f,D,sizeof(D));

       { Lecture d'une zone reserve }
       blockread(f,Reserved,LGRESERV);

       { Lecture du tableau de lignes }
       blockread(f,Nblig,sizeof(NbLig));
       for i:=0 to NbLig-1 do
       if i<MAX_LIGNES then
         begin
         blockread(f,Ligne,sizeof(TLigne));
         findtyp:=false;
         if (length(Ligne.Date)>2) and (Ligne.Date[1]='*')
            then case upcase(Ligne.Date[2]) of
               'T': begin Ligne.Cre:=4*Ligne.Cre; Ligne.Deb:=4*Ligne.Deb; end;
               'I','P': begin Ligne.Cre:=6*Ligne.Cre; Ligne.Deb:=6*Ligne.Deb; end;
               'M': begin Ligne.Cre:=12*Ligne.Cre; Ligne.Deb:=12*Ligne.Deb; end;
             end;
         for p:=1 to nbtyp do if tabresult^[p].Typ=Ligne.Typ then
            begin
            findtyp:=true;
            tabresult^[p].Cre:=tabresult^[p].Cre+Ligne.Cre;
            tabresult^[p].Deb:=tabresult^[p].Deb+Ligne.Deb;
            end;
         if not findtyp then
            begin
            if nbtyp<MaxTotalType then nbtyp:=nbtyp+1;
            tabresult^[nbtyp].typ:=Ligne.Typ;
            tabresult^[nbtyp].Cre:=Ligne.Cre;
            tabresult^[nbtyp].Deb:=Ligne.Deb;
            end;
         end;
       close(f);
       end;
if dowr then for p:=1 to nbtyp do
  begin
  write(fic,tabresult^[p].Typ,',');
  write(fic,tabresult^[p].Cre:9:2,',');
  write(fic,tabresult^[p].Deb:9:2,',');
  writeln(fic,tabresult^[p].Cre-tabresult^[p].Deb:10:2);
  end;
if dowr then writeln(fic);
end;


{ =====> Procedure utilisateur: Copie de compte vers compte <===== }

procedure CopyTo(Sour,Dest:TCptDef; var CreSol,SCreSol:real; premier,dernier:boolean);

var Last,SName,NSour,NDest:TName;
    ESour,EDest:ECatalog;
    f,ff:file;
    Reserved:Array[1..LGRESERV] of char;
    D:array[1..7] of word;
    s100:word;
    NUM:string[4];
    version,Credit,Solde,CreditS,SoldeS,add,sadd,Diff,SDiff:real;
    i,NBLIGNES:integer;
    Ligne:TLigne;
    DirInfo:SearchRec;
    Stop:boolean;

begin
Stop:=false;
MakeName(Sour,NSour,Esour);
MakeName(Dest,NDest,EDest);

assign(f,NSour);
{$I-}
reset(f,1);
{$I+}
if ioresult<>0 then
     begin  { Ce compte n'existe pas , donc rien a faire a par detruire l'autre }
     assign(f,Ndest);
     {$I-}
     erase(f);
     {$I+}
     if ioresult<>0 then; { Lecture de ioresult pour purge }

     stop:=true;
     end;

if premier then
   begin
   SName:=copy(NDest,1,3)+'*.'+BASE_EXT;
   findfirst(SName,AnyFile,DirInfo);
   Last:='';
   while DosError=0 do
     begin
     if precedent(DirInfo.Name,NDest) and
       ( (Last='') or suivant(DirInfo.Name,Last) ) then Last:=DirInfo.Name;
     findnext(DirInfo);
     end;

   CreSol:=0;
   SCreSol:=0;

   if last<>'' then
      begin
      assign(ff,Last);
      reset(ff,1);
      blockread(ff,version,sizeof(version));
      blockread(ff,CreSol,sizeof(CreSol));
      blockread(ff,SCreSol,sizeof(SCreSol));
      blockread(ff,CreSol,sizeof(CreSol));     { En fait Solde  }
      blockread(ff,SCreSol,sizeof(SCreSol));   { En fait SoldeS }
      close(ff);
      end;

   end;

if not stop then
  begin
  assign(ff,NDest);
  {$I-}
  rewrite(ff,1);
  {$I+}
  if ioresult<>0 then exit; { Rien a faire si on peut pas vreer }

  blockread(f,version,sizeof(version));
  blockread(f,Credit,sizeof(Credit));
  blockread(f,CreditS,sizeof(CreditS));
  blockread(f,Solde,sizeof(Solde));
  blockread(f,SoldeS,sizeof(SoldeS));
  version:=VER_UNIT;
  blockwrite(ff,version,sizeof(version));

  add:=Solde-Credit;
  sadd:=SoldeS-CreditS;

  Credit:=CreSol;   { On propage le solde final du precedent sur le credit initial }
  CreditS:=SCreSol;

  Solde:=Credit+add;
  SoldeS:=CreditS+sadd;

  CreSol:=Solde;       { On transmet le solde final pour propagation vers credit initial du suivant }
  SCreSol:=SoldeS;

  Credit:=round(Credit*100)/100;
  CreditS:=round(CreditS*100)/100;
  Solde:=round(Solde*100)/100;
  SoldeS:=round(SoldeS*100)/100;

  seek(ff,0);
  version:=VER_UNIT;
  blockwrite(ff,version,sizeof(version));
  blockwrite(ff,Credit,sizeof(Credit));
  blockwrite(ff,CreditS,sizeof(CreditS));
  blockwrite(ff,Solde,sizeof(Solde));
  blockwrite(ff,SoldeS,sizeof(SoldeS));

  { Lecture de la date et heure }
  blockread(f,D,sizeof(D));

  { Lecture d'une zone reserve }
  blockread(f,Reserved,LGRESERV);

  { Ecriture de la date et heure }
  getdate(D[1],D[2],D[3],D[4]);
  gettime(D[5],D[6],D[7],s100);
  blockwrite(ff,D,sizeof(D));

  { Ecriture d'une zone reserve }
  Reserved[1]:=#0;
  blockwrite(ff,Reserved,LGRESERV);

  { Copie du tableau de lignes }
  blockread(f,NbLignes,sizeof(NbLignes));
  blockwrite(ff,NbLignes,sizeof(NbLignes));
  for i:=0 to NbLignes-1 do
   if i<MAX_LIGNES then
    begin
    blockread(f,Ligne,sizeof(TLigne));
    blockwrite(ff,Ligne,sizeof(TLigne));
    end;

  close(ff);
  close(f);
  end;

if dernier then { Propager aux autres ... }
  begin
   SName:=copy(NDest,1,3)+'*.'+BASE_EXT;
   findfirst(SName,AnyFile,DirInfo);
   Last:='';
   while DosError=0 do
     begin
     if suivant(DirInfo.Name,NDest) and
       ( (Last='') or precedent(DirInfo.Name,Last) ) then Last:=DirInfo.Name;
     findnext(DirInfo);
     end;

  if last='' then exit;

  assign(f,Last);
  reset(f,1);
  blockread(f,version,sizeof(version));
  blockread(f,Diff,sizeof(Diff));
  blockread(f,SDiff,sizeof(SDiff));
  close(f);

  Diff:=Solde-Diff;
  SDiff:=SoldeS-SDiff;

  SName:=copy(NDest,1,3)+'*.'+BASE_EXT;
  findfirst(SName,AnyFile,DirInfo);
  while DosError=0 do
   begin
   if suivant(DirInfo.Name,NDest) then
      begin
      assign(f,DirInfo.Name);
      reset(f,1);
      blockread(f,version,sizeof(version));
      blockread(f,Credit,sizeof(Credit));
      blockread(f,CreditS,sizeof(CreditS));
      blockread(f,Solde,sizeof(Solde));
      blockread(f,SoldeS,sizeof(SoldeS));

      Credit:=Credit+Diff;
      Solde:=Solde+Diff;
      CreditS:=CreditS+sDiff;
      SoldeS:=SoldeS+sDiff;

      seek(f,0);
      blockread(f,version,sizeof(version));
      Credit:=round(Credit*100)/100;
      CreditS:=round(CreditS*100)/100;
      Solde:=round(Solde*100)/100;
      SoldeS:=round(SoldeS*100)/100;

      blockwrite(f,Credit,sizeof(Credit));
      blockwrite(f,CreditS,sizeof(CreditS));
      blockwrite(f,Solde,sizeof(Solde));
      blockwrite(f,SoldeS,sizeof(SoldeS));
      close(f);
      end;
   findnext(DirInfo);
   end;
  end;
end;




{ ************** Initialisation de l'unit COMPTE *************** }

var f:byte;
    c:char;
    Def:TCptDef;
    R:TRect;

begin
{$ifdef DEMOVER}
PERIME:=false;
{$endif}
new(tabresult);
InsertMode:=true;
AutoInsert:=false;
for f:=1 to 9 do FenOpen[f]:=False;
CptList.Init;                            { ?? Done en fin de programme ?? }
AutoSaveMode:=false;
CheckDate:=false;
Format:=0;
for c:=^A to ^Z do FastKey[c]:='';       { Purge les touches raccourcis }
for f:=1 to MAX_TYP do FastTyp[f]:='';   { Purge les types raccourcis }
Def.Name:=PP_FEN_NAME;
Def.Prev:=false;
Def.Mois:=0;
Def.Annee:=0;
Def.Mode:=mdnorm+mdseul+mdVirtual+mdPressPap;
R.Assign(1,1,40,10);
CptPressPap:=New(PFenCpt, Init(R, Def));
TotalFen:=nil;
Total:=0;
TotalS:=0;
end.

