{ Constantes de l'unit comptes }

unit comptec;

interface

uses Crt,Views,Objects,Drivers;

const VER_UNIT:real=6.00;                { N de version de l'unit }
      SPACE='                                                                                         ';
      LgSel=1; LgDat=8; LgCre=8; LgDeb=8; LgTyp=4; Nb_Col=6;
      MaxTotalType=100;             { Nombre maximum de type dans un bilan par type }
      MIN_WIN_X=50; MIN_WIN_Y=14;   { Taille minimum de la fentre de compte }
      MIN_WIN_X132=80;              { Taille minimum en x pour 132 colonnes }
      MAX_LIGNES=150;               { Nombre maximum de lignes dans le tableau }
      MAX_TYP=16;                   { Nombre maximum de types }
      LG_TYP=LgTyp;                 { Nombre max de caractre dans le type de mouvement }
      MAX_LG_LIB=60;                { Longueur maximum des libells }
      MAX_CPT=300;                  { Nombre maximum de compte ouvert }
      CAR_SELECTED    =#224;        { Caractre pour case coche }
      CAR_NOT_SELECTED=' ';         { Caractre pour case non cohe }
      LG_NAME=20;                   { Longueur Max d'un nom de compte }
      CATALOG_NAME = 'COMPTES.CAT'; { Nom du fichier catalogue }
      BASE_CHAR='C';                { Caractre de base des fichiers comptes }
      BASE_EXT='CPT';               { Extention de base des fichiers comptes }
      PP_NAME=#255+'PP'+#255;       { Nom de code Presse Papier }
      PP_FEN_NAME='Presse-Papier';  { Nom de la fenetre Presse Papier }
      PP_LIB1='LIBELLE';            { Libells de la fenetre Presse Papier }
      PP_LIB2='CREDIT';             { .................................... }
      PP_LIB3='DEBIT';              { .................................... }

const LGRESERV=50;


const mdprev     = 1;    { Constantes pour le type de mois : TFenCpt.Mode }
      mdnorm     = 0;
      mdseul     = 2;
      mdmensuel  = 6;
      mdannuel   = 14;
      mdVirtual  = 64;   { Fenetre Virtuelle - Non affiche }
      mdPressPap = 128;  { Fenetre Presse-Papier }

const  { Liste des commandes invalidables }
      cmCsave       = 110;   { Demande la sauvegarde du compte courant }
      cmCsaveall    = 111;   { Demande la sauvegarde de tous les comtpes }
      cmCnewline    = 112;   { Demande l'insertion d'une ligne en fin du compte }
      cmprint       = 113;   { Demande impression du compte courant }
      cmprintall    = 114;   { Demande impression de tous les comptes }
      cmDebZone     = 115;   { Indique un dbut de zone de slction }
      cmEndZone     = 116;   { Indique la fin de la zone de slection }
      cmClearZone   = 117;   { Dselectionne - (Suppression de la slection }
      cmDebLZone    = 118;   { Slectionne le dbut d'une zone (par ligne) }
      cmEndLZone    = 119;   { Indique le fin d'une zone (par ligne) }
      cminvpresspap = 120;   { Inverse les colonnes DEBIT-CREDIT du presse papier }
      cmdestroy     = 121;   { Detruit la slection sans le mettre dans le presse-papier }
      cmclass       = 122;   { Classe la slection }
      cmsearch      = 123;   { Recherche un montant }
      cmSoldeCopy   = 124;   { Copie le solde du compte dans le presse papier }
      cmSoldeSCopy  = 125;   { Copie le solde slect du compte dans le presse papier }

      { Liste des commandes non invalidables }
      cmcptupdate   = 10000; { Demande une mise a jour du status du compte }
      cmopen        = 10001; { Ouvre un compte - pour consultation/Modif }
      cmnouveau     = 10002; { Creer un nouveau compte }
      cmfindcpt     = 10003; { Recherche si un compte est ouvert - Si oui MAJ de LastCptDef }
      cmMacLire     = 10004; { Lecture de la case courante - Pour macros }

type TNAME = string[12];      { Type pour les noms de fichiers }
     CNAME = string[LG_NAME]; { Type pour les noms de comptes }
     PBoolean = ^Boolean;     { Pointeur sur boolen - Utile dans Compte pour modif^ }



{ Type pour la dfinition d'un compte.
       Utilis dans: - FenCpt
                     - Make Name
                     - Del Name
                     - LastCptDef  (variable globale pour diffusion)
}

type PCptDef = ^TCptDef;
     TCptDef = record
                 Name:string[LG_NAME];
                 Annee:word;
                 Mois:byte;
                 Prev:boolean;
                 Mode:Byte;
                 Repert:string;
               end;

{ Type des enregistrements du catalogue des comptes la Taille dot tre de 152 Octets }

type ECatalog = record
                 LIB1:string[MAX_LG_LIB];
                 LIB2:string[LgCre];
                 LIB3:string[LgDeb];
                 Name:string[LG_NAME];
                 Valid:boolean;
                 Mode:Byte;
                 Version:real;
                 {$ifdef DEMOVER}
                   DateDemo:longint;
                   Reserved:array[1..44-sizeof(Longint)] of byte;
                 {$else}
                   Reserved:array[1..44] of byte;
                 {$endif}
                end;

     FCatalog = File of ECatalog; { Type fichier du catalogue }


{ Type des lignes de la comptabilit - Sauve tel quel dans le fichier compte
     La taille est fix  100 Octets
}

type PLigne = ^TLigne;
     TLigne = record
                Sel:Boolean;                   { Selecteur }
                Date:string[8];                { Date }
                Lib:string[MAX_LG_LIB];        { Libell }
                Cre,Deb:real;                  { Crdit et Dbit }
                Typ:string[LG_TYP];            { Type de mouvement }
                Reserved:array[1..12] of byte; { Rserv pour futur }
              end;

type TabLignes=array[0..MAX_LIGNES-1] of PLigne;  { Tableau des lignes }

{ Objet reponsable de l'affichage de l'en tte du tableau - Insr dans FenCpt }

type PLegend = ^TLegend;
     TLegend = object(TView)
       LIB1:string[MAX_LG_LIB];
       LIB2:string[LgCre];
       LIB3:string[LgDeb];
        constructor Init(Bounds:TRect; L1,L2,L3:string);
        procedure Draw; virtual;

     end;

{ Structure de donne des touches raccourcis - Accessible par CTRL+Lettre }

type PFastKey = ^TFastKey;
     TFastKey = array[^A..^Z] of string[MAX_LG_LIB];

{ Structure de donne des types raccourcis - Accessible par CTRL+ENTREE }

type PFastTyp = ^TFastTyp;
     TFastTyp = array[1..MAX_TYP] of string[LgTyp];


var
      FastKey:TFastKey;                { Touches raccourcis }
      FastTyp:TFastTyp;                { Types raccourcis }
      Total,TotalS:real;               { Montant total d'une zone selecte - Affich par TotalFen }
      InsertMode:Boolean;              { Mode insertion de caractre }
      AutoInsert:Boolean;              { Auto insertion de ligne a la fin }
      AutoSaveMode:Boolean;            { Auto sauvegarde des comptes }
      CheckDate:Boolean;               { Controle ou pas les dates entres }
      MacLire:string;                  { Variable tampon pour macro - reponse  cmmacLire }
      OkCutCopy:Boolean;               { Indique si oprations cut et copy possible
                                         pour le compte choisi par cmfindcpt       }


      {$ifdef DEMOVER}
      PERIME:Boolean;                  { Indique que la version dmonstration est prim }
      {$endif}


implementation

{ +--------------------------------------------------------------------+  }
{ |                          >  TLegend   <                            |  }
{ +--------------------------------------------------------------------+  }


{ ----------------> INIT <----------------}

Constructor TLegend.Init(Bounds:TRect; L1,L2,L3:string);

begin
TView.Init(Bounds);
GrowMode:=GfGrowHix;
options:=options+offramed;
LIB1:=L1;
LIB2:=L2;
LIB3:=L3;
end;


{ ----------------> DRAW <----------------}

procedure TLegend.Draw;

var Buf:TDrawBuffer;
    LgSpc,LgLib,Color:byte;
    LIB,SPC:string;

begin
LgLib:=Size.x-(LgDat+LgSel+LgCre+LgDeb+LgTyp+Nb_Col);
if length(LIB1)<LgLib then LgSpc:=(LgLib-length(LIB1)) div 2 else LgSpc:=0;
SPC:=copy(SPACE,1,LgSpc);
LIB:=copy(SPC+LIB1+SPC+' ',1,LgLib);

if length(LIB2)<Lgcre then LgSpc:=(Lgcre-length(LIB2)) div 2 else LgSpc:=0;
SPC:=copy(SPACE,1,LgSpc);
LIB2:=copy(SPC+LIB2+SPC+' ',1,LgCre);
if length(LIB3)<Lgcre then LgSpc:=(Lgdeb-length(LIB3)) div 2 else LgSpc:=0;
SPC:=copy(SPACE,1,LgSpc);
LIB3:=copy(SPC+LIB3+SPC+' ',1,LgDeb);


Color:=getcolor(6);
MoveChar(Buf,' ',Color,size.X);
Movestr(Buf,'   DATE  '+LIB+''+LIB2+''+LIB3+'TYPE',Color);
Writeline(0,0,Size.x,1,Buf);
end;


begin

end.