unit gestmath;

interface

const nivmax=20;
      err_opinc='Operande incorrecte';
      err_syn='Erreur de syntaxe';
      err_dz='Division par zero';
      err_vid='Formule vide';

type reel=real;
     Pointeur_mathpile=^mathpile;
              mathpile=record
                       typ:byte;
                       val:real;
                       suivant:Pointeur_mathpile
                       end;


var matherr:boolean;
    mathmess:string[20];
    variable:array[1..26] of reel;

function tan(x:reel):reel;

function arcsin(x:reel):reel;

function arccos(x:reel):reel;

function ch(x:reel):reel;

function sh(x:reel):reel;

function th(x:reel):reel;

function argch(x:reel):reel;

function argsh(x:reel):reel;

function argth(x:reel):reel;

function puiss(x,y:reel):reel;

function racine(x,y:reel):reel;

function fact(x:reel):reel;

function log(x:reel):reel;

procedure comp(ch:string;var Tetepile:Pointeur_mathpile);

   { Compile une chaine arithmtique }

function evaluer(Tetepile:Pointeur_mathpile):reel;

   { Evaluer une expression compile par comp }


procedure supp(var Tetepile:Pointeur_mathpile);

   { Supprime une pile crer par comp }

implementation


{----------------------------------------- Fonctions de Calcul diverses }

function tan;

var d:reel;

begin
d:=cos(x);
if d=0 then begin
            matherr:=true;
            mathmess:=err_dz
            end
       else tan:=sin(x)/d
end;


function puiss;

begin
if (x<0) and (y=int(y)) then
          if int(y/2)=(y/2) then puiss:=-exp(y*ln(-x))
                              else puiss:= exp(y*ln(-x))
 else if (x=0) and (y>0) then puiss:=0
 else if (x>0) then puiss:=exp(y*ln(x))
 else begin matherr:=true;mathmess:=err_opinc end
end;

function racine;

begin
if x<>0 then racine:=puiss(y,(1/x))
           else begin
                matherr:=true;
                mathmess:=err_opinc
                end
end;

function fact;

var r:reel;

begin
if (int(x)<>x) or (x<0) then begin matherr:=true;mathmess:=err_opinc end
           else if x=0 then fact:=1
            else begin
                 r:=1;
                 x:=int(x);
                 while x<>1 do begin r:=r*x;x:=x-1 end;
                 fact:=r
                 end
end;

function arcsin;

begin
if abs(x)>1 then begin
                 matherr:=true;
                 mathmess:=err_opinc
                 end
  else if abs(x)=1 then arcsin:=x*pi/2
                   else arcsin:=arctan(x/sqrt(-x*x+1))
end;

function arccos;

begin
if abs(x)>1 then begin
                 matherr:=true;
                 mathmess:=err_opinc
                 end
  else if abs(x)=1 then arccos:=(pi/2)*(1-x)
                   else arccos:=-arctan(x/sqrt(-x*x+1))+pi/2
end;

function ch;

begin
ch:=(exp(x)+exp(-x))/2
end;

function sh;

begin
sh:=(exp(x)-exp(-x))/2
end;

function th;

begin
th:=1-2*exp(-x)/(exp(x)+exp(-x))
end;

function argch;

begin
if x<1 then begin
            matherr:=true;
            mathmess:=err_opinc
            end
       else argch:=ln(x+sqrt(x*x-1))
end;

function argsh;

begin
argsh:=ln(x+sqrt(x*x+1))
end;

function argth;

begin
if (x>-1) and (x<1) and (x<>0) then argth:=(ln(1+x)/ln(1-x))/2
    else if x=0 then argth:=0 else begin
                                   matherr:=true;
                                   mathmess:=err_opinc
                                   end
end;

function log;

begin
if x<=0 then begin
             matherr:=true;
             mathmess:=err_opinc
             end
        else log:=ln(x)/ln(10)
end;

{---------------------------------- Procedure cration d'un nouvel lment }

procedure nouv(var pilecalc,tetepile:Pointeur_mathpile);

begin
if tetepile=nil then begin
                     new(tetepile);
                     pilecalc:=tetepile
                     end
                else begin
                     new(pilecalc^.suivant);
                     pilecalc:=pilecalc^.suivant
                     end;
pilecalc^.suivant:=nil
end;

{--------------------------------------- Procedure suppresion de la pile }

procedure supp;

var suivant:pointer;

begin
while tetepile<>nil do begin
                       suivant:=tetepile^.suivant;
                       dispose(tetepile);
                       tetepile:=suivant
                       end
end;


{--------------------------------------- Fonction : Recherche d'un ')' final }

function findfin(var ch:string;pos:byte):byte;

var p,c:byte;

begin
p:=1;
c:=0;
while (p<>0) and (not matherr) do
    begin
    inc(c);
    if (c+pos-1)>length(ch)
       then matherr:=true
       else begin
            if ch[pos+c-1]='(' then inc(p);
            if ch[pos+c-1]=')' then dec(p)
            end
    end;
findfin:=pos+c-1
end;


{------------------------------ Fonction retourne le code de l'operation }

function codeope(c:char):byte;

begin
codeope:=7;
case c of
 '+':codeope:=0;
 '-':codeope:=1;
 '*':codeope:=2;
 '/':codeope:=3;
 '^':codeope:=4;
 '~':codeope:=5;
 '@':codeope:=6;
 '(':codeope:=8
 else matherr:=true
 end
end;


{-------------------------------- Fonction retourne le code de la fonction }

function codefonct(ch:string; var i:byte):byte;

var ch2:string[10];
    c:byte;

begin
ch2:='';
c:=0;
while ch[i] in ['A'..'Z'] do begin
                             ch2:=ch2+ch[i];
                             i:=i+1
                             end;
if (copy(ch2,1,3)='NEG') and (length(ch2)>3) then begin
                                                  c:=128;
                                                  ch2:=copy(ch2,4,10)
                                                  end;
if ch2='FACT' then c:=c+1;
if ch2='NEG' then c:=c+2;
if ch2='COS' then c:=c+3;
if ch2='SIN' then c:=c+4;
if ch2='TAN' then c:=c+5;
if ch2='ARCSIN' then c:=c+6;
if ch2='ARCCOS' then c:=c+7;
if ch2='ARCTAN' then c:=c+8;
if ch2='CH' then c:=c+9;
if ch2='SH' then c:=c+10;
if ch2='TH' then c:=c+11;
if ch2='ARGCH' then c:=c+12;
if ch2='ARGSH' then c:=c+13;
if ch2='ARGTH' then c:=c+14;
if ch2='EXP' then c:=c+15;
if ch2='LOG' then c:=c+16;
if ch2='EN' then c:=c+17;
if ch2='LN' then c:=c+18;
if ch2='INT' then c:=c+19;
if ch2='FRAC' then c:=c+20;
if ch2='ABS' then c:=c+21;
if ch2='RAND' then c:=c+22;
if ch2='SQRT' then c:=c+23;
if ch2='SQR' then c:=c+23;
if (c=128) or (c=0) then begin
                         matherr:=true;
                         mathmess:=err_syn
                         end;
codefonct:=c
end;


{---------------------------------------- Procedure de compilation }

procedure comp;

var i,l,f:byte;
    nomb:boolean;
    ope:array[0..nivmax] of byte;
    e:integer;
    pilecalc:pointeur_mathpile;


begin
matherr:=false;
if length(ch)=0 then
   begin
   matherr:=true;
   mathmess:=err_vid
   end;
for i:=1 to length(ch) do ch[i]:=upcase(ch[i]);
if not matherr then for i:=1 to length(ch)-1 do   { Codage des E par @ : 1E10 --> 1@10 }
         if (ch[i]='E') and not(ch[i+1] in ['A'..'Z']) then
                begin
                ch[i]:='@';
                if CH[i+1]='+' then CH[i+1]:='0';
                end;
i:=1;
nomb:=false;    { Insertion de * si absents : 2x+1 --> 2*x+1 }
while i<length(ch) do
   begin
   if nomb and not(ch[i] in ['0'..'9','.',')']) then
        if not(ch[i] in ['+','-','*','/','^','~','!','@']) then ch:=copy(ch,1,i-1)+'*'+copy(ch,i,255);
   nomb:=ch[i] in ['0'..'9','.'];
   i:=i+1
   end;
i:=1;          { Remplacement du signe oppos par NEG : 2*-5 --> 2*NEG(5) }
if not matherr then
  if ch[1]='-' then
        begin
        l:=2;
        while (ch[l] in ['0'..'9','.']) and (l<=length(ch)) do l:=l+1;
        if l=2 then ch:='NEG'+copy(ch,2,255)
           else ch:='NEG('+copy(ch,2,l-2)+')'+copy(ch,l,255);
        end;
while (i<length(ch)) and (not matherr) do
   begin
   if (ch[i] in ['+','-','*','/','^','~','@','(']) and (ch[i+1]='-') then
        begin
        l:=i+2;
        while (ch[l] in ['0'..'9','.']) and (l<=length(ch)) do l:=l+1;
        if l=i+2 then ch:=copy(ch,1,i)+'NEG'+copy(ch,i+2,255)
           else ch:=copy(ch,1,i)+'NEG('+copy(ch,i+2,l-i-2)+')'+copy(ch,l,255);
        end;
   if (ch[i] in ['+','-','*','/','^','~','@']) and
    (ch[i+1] in ['+','-','*','/','^','~','@']) then begin
                                                        matherr:=true;
                                                        mathmess:=err_syn
                                                        end;
   i:=i+1
   end;
i:=1;
tetepile:=nil;
ope[0]:=0;
while (i<=length(ch)) and (not matherr) do
   begin
   case ch[i] of
     '0'..'9','.':begin
                  l:=i;
                  while ch[i] in ['0'..'9','.'] do i:=i+1;
                  nouv(pilecalc,tetepile);
                  val(copy(ch,l,i-l),pilecalc^.val,e);
                  if e<>0 then begin
                               matherr:=true;
                               mathmess:=err_syn
                               end;
                  pilecalc^.typ:=0;
                  i:=i-1
                  end;
    '+','-','*','/','^','~','@':
                  begin
                  l:=codeope(ch[i]);
                  while ((ope[ope[0]] div 2)>=(l div 2)) and (ope[0]<>0)
                                and (ope[ope[0]]<>8) do
                     begin
                     nouv(pilecalc,tetepile);
                     pilecalc^.typ:=2;
                     pilecalc^.val:=ope[ope[0]];
                     dec(ope[0],1)
                     end;
                  inc(ope[0],1);
                  ope[ope[0]]:=l
                  end;
              '(':begin
                  inc(ope[0],1);
                  ope[ope[0]]:=8
                  end;
              '!':begin
                  nouv(pilecalc,tetepile);
                  pilecalc^.typ:=3;
                  pilecalc^.val:=1
                  end;
              ')':begin
                  while (not matherr) and (ope[ope[0]]<>8) do
                    if ope[0]=0 then matherr:=true
                    else begin
                         nouv(pilecalc,tetepile);
                         pilecalc^.typ:=2;
                         pilecalc^.val:=ope[ope[0]];
                         dec(ope[0],1)
                         end;
                  if not matherr then dec(ope[0],1)
                  end;
         'A'..'Z':begin
                  if (i=length(ch)) or (not (ch[i+1] in ['A'..'Z'])) then
                     begin
                     nouv(pilecalc,tetepile);
                     pilecalc^.typ:=1;
                     pilecalc^.val:=ord(ch[i])-ord('A')+1
                     end
                   else
                     begin
                     l:=codefonct(ch,i);
                     if ch[i]<>'(' then begin
                                        matherr:=true;
                                        mathmess:=err_syn
                                        end;
                     f:=i+1;
                     i:=i-1;
                     f:=findfin(ch,f);
                     if l<128 then ch:=copy(ch,1,f)+chr(l)+copy(ch,f+1,255)
                              else ch:=copy(ch,1,f)+chr(l-128)+chr(2)+copy(ch,f+1,255)
                     end
                  end;
          #1..#30:begin
                  nouv(pilecalc,tetepile);
                  pilecalc^.typ:=3;
                  pilecalc^.val:=ord(ch[i])
                  end
               end;
   i:=i+1
   end;
while (ope[0]>0) and (not matherr) do
                  begin
                  nouv(pilecalc,tetepile);
                  pilecalc^.typ:=2;
                  pilecalc^.val:=ope[ope[0]];
                  dec(ope[0],1)
                  end
end;


{---------------------- Procdure valuation d'une expression compile }

function evaluer;

var j:byte;
    mem:array[1..nivmax] of reel;
    pilecalc:pointeur_mathpile;

begin
pilecalc:=tetepile;
j:=0;
while (pilecalc<>nil) and (not matherr) do
   begin
   case pilecalc^.typ of
     0:begin    { valeur }
       inc(j,1);
       if j>nivmax then matherr:=true else mem[j]:=pilecalc^.val
       end;
     1:begin    { variable }
       inc(j,1);
       if j>nivmax then matherr:=true else mem[j]:=variable[trunc(pilecalc^.val)]
       end;
     2:begin    { opration }
       dec(j,1);
       if j<=0 then begin
                    matherr:=true;
                    mathmess:=err_syn
                    end
        else case trunc(pilecalc^.val) of
          0:mem[j]:=mem[j]+mem[j+1];
          1:mem[j]:=mem[j]-mem[j+1];
          2:mem[j]:=mem[j]*mem[j+1];
          3:if mem[j+1]<>0 then mem[j]:=mem[j]/mem[j+1] else begin
                                                             matherr:=true;
                                                             mathmess:=err_dz
                                                             end;
          4:mem[j]:=puiss(mem[j],mem[j+1]);
          5:mem[j]:=racine(mem[j],mem[j+1]);
          6:mem[j]:=mem[j]*puiss(10,mem[j+1])
          end
       end;
     3:begin    { fonction }
       case trunc(pilecalc^.val) of
         1:mem[j]:=fact(mem[j]);
         2:mem[j]:=-mem[j];
         3:mem[j]:=cos(mem[j]);
         4:mem[j]:=sin(mem[j]);
         5:mem[j]:=tan(mem[j]);
         6:mem[j]:=arcsin(mem[j]);
         7:mem[j]:=arccos(mem[j]);
         8:mem[j]:=arctan(mem[j]);
         9:mem[j]:=ch(mem[j]);
        10:mem[j]:=sh(mem[j]);
        11:mem[j]:=th(mem[j]);
        12:mem[j]:=argch(mem[j]);
        13:mem[j]:=argsh(mem[j]);
        14:mem[j]:=argth(mem[j]);
        15:mem[j]:=puiss(10,mem[j]);
        16:mem[j]:=log(mem[j]);
        17:mem[j]:=exp(mem[j]);
        18:if mem[j]>0 then mem[j]:=ln(mem[j])
                              else begin
                                   matherr:=true;
                                   mathmess:=err_opinc
                                   end;
        19:mem[j]:=int(mem[j]);
        20:mem[j]:=frac(mem[j]);
        21:mem[j]:=abs(mem[j]);
        22:if (mem[j]<0) or (mem[j]>65535) then begin
                                                matherr:=true;
                                                mathmess:=err_opinc
                                                end
            else if mem[j]=0 then mem[j]:=random
                             else mem[j]:=random(trunc(mem[j]));
        23:mem[j]:=sqrt(mem[j]);
        24:mem[j]:=sqr(mem[j]);
         end;
       end
     end;
   pilecalc:=pilecalc^.suivant
   end;
if (not matherr) and (j<>1) then begin
                                 matherr:=true;writeln(j);
                                 mathmess:=err_syn
                                 end;
evaluer:=mem[1]
end;

var f:byte;

begin
matherr:=false;
mathmess:='';
for f:=1 to 26 do variable[f]:=0;
randomize
end.
