unit import;

{$O+}
{$F+}
{$B-}

Interface

uses Dos,Crt,Drivers,Memory,Views,Menus,Objects,CompteC,Compte;

{ Importe une annee complte  partir du catalogue rep dans le compte cptname }
function Importe_Annee(rep:string; cptname:string):boolean;

{ Importe tous les compte spciaux du catalogue rep dans le compte cptname+nom_special }
function Importe_special(rep:string; cptname:string):boolean;

{ Importe les remboursements du catalogue rep dans le compte cptname }
function Importe_remb(rep:string; cptname:string):boolean;

{ Verifie si un repertoire contient des compte  importer }
function ImportRep(Rep:string):Boolean;


implementation

type Tmoisrec=record
              date:string[8];
              libelle:string[24];
              credit,debit:real
              end;


function ImportRep(Rep:string):boolean;

 Var dirinfo:searchrec;


begin
ImportRep:=true;
findfirst(Rep+'*.bsp',anyfile,dirinfo);
if doserror=0 then exit;
findfirst(Rep+'*.bud',anyfile,dirinfo);
if doserror=0 then exit;
ImportRep:=false;
end;




procedure Convert(OldFic,NewFic:string);

const LGRESERV=50;

var NbLignes,i,code:integer;
    f:file;
    Reserved:Array[1..LGRESERV] of char;
    D:array[1..7] of word;
    s100:word;
    moisrec:Tmoisrec;
    Ligne:TLigne;
    fic:file of TMoisrec;
    CreditS,SoldeS,Credit,Solde:Real;

begin
assign(fic,OldFic);
{$i-}
reset(fic);
{$i+}
if ioresult<>0 then exit;
if Filesize(fic)<2 then begin close(fic); exit; end;
assign(f,NewFic);
{$I-}
rewrite(f,1);
{$I+}
if ioresult<>0 then begin close(fic); exit; end;

read(fic,moisrec);
val(copy(moisrec.libelle,2,11),CreditS,code);
val(copy(moisrec.libelle,14,11),SoldeS,code);
Solde:=moisrec.debit;
Credit:=moisrec.credit;
blockwrite(f,CompteC.VER_UNIT,sizeof(CompteC.VER_UNIT));
blockwrite(f,Credit,sizeof(Credit));
blockwrite(f,CreditS,sizeof(CreditS));
blockwrite(f,Solde,sizeof(Solde));
blockwrite(f,SoldeS,sizeof(SoldeS));

{ Ecriture de la date et heure }
getdate(D[1],D[2],D[3],D[4]);
gettime(D[5],D[6],D[7],s100);
blockwrite(f,D,sizeof(D));

{ Ecriture d'une zone reserve }
Reserved[1]:=#0;
blockwrite(f,Reserved,LGRESERV);

NbLignes:=FileSize(fic)-1;

{ Ecriture du tableau de lignes }
blockwrite(f,NbLignes,sizeof(NbLignes));
for i:=0 to NbLignes-1 do
  begin
  read(fic,moisrec);
  if moisrec.libelle[1]<#128 then moisrec.libelle:=#255+moisrec.libelle;
  Ligne.Lib:=copy(moisrec.libelle,2,255);
  Ligne.Sel:=moisrec.Libelle[1]=#200;
  Ligne.Cre:=moisrec.Credit;
  Ligne.Deb:=moisrec.Debit;
  Ligne.Date:=moisrec.Date;
  Ligne.reserved[1]:=0;
  blockwrite(f,Ligne,sizeof(TLigne));
  end;

close(fic);
close(f);
end;


function importe_annee(rep:string; cptname:string):boolean;

var annee_actuelle,oldname:string;
    newname:Tname;
    fic:text;
    m,normal:byte;
    Def:TCptDef;
    Info:ECatalog;
    Code:Integer;

begin
importe_annee:=true;
assign(fic,rep+'annees.cat');
{$i-}
reset(fic);
{$i+}
if ioresult<>0 then exit;

{ Creation du compte }
Def.Name:=CptName;
Def.Prev:=false;
Def.Mois:=1;
Def.Annee:=1991;
Def.Mode:=mdprev or mdannuel;
Info.LIB1:=' LIBELLE ';
Info.LIB2:=' CREDIT ';
Info.LIB3:=' DEBIT  ';

makename(Def,newname,Info);

while not eof(fic) do
  begin
  readln(fic,annee_actuelle);
  for m:=1 to 12 do
   for normal:=0 to 1 do
     begin
     str(m,oldname);
     if normal=0 then oldname:='M'+annee_actuelle+'x'+oldname else oldname:='P'+annee_actuelle+'x'+oldname;
     oldname:=oldname+'.bud';

     Def.Name:=CptName;
     Def.Prev:=normal=1;
     Def.Mois:=m;
     val(annee_actuelle,Def.Annee,code);
     Def.Mode:=mdprev or mdannuel;
     makename(Def,newname,Info);

     convert(rep+oldname,newname);

     end;

  end;

close(fic);
importe_annee:=true;
end;



function importe_special(rep:string; cptname:string):boolean;

var Name,oldname:string;
    newname:Tname;
    Def:TCptDef;
    Info:ECatalog;
    dirinfo:searchrec;

begin
findfirst(rep+'*.bsp',anyfile,dirinfo);
while Doserror=0 do
     begin
     importe_special:=false;
     Name:=copy(Dirinfo.name,1,pos('.',Dirinfo.name)-1);
     { Creation du compte }
     Def.Name:=CptName+Name;
     Def.Prev:=false;
     Def.Mois:=1;
     Def.Annee:=1991;
     Def.Mode:=mdnorm or mdseul;
     Info.LIB1:=' LIBELLE ';
     Info.LIB2:=' CREDIT ';
     Info.LIB3:=' DEBIT  ';

     if ExistCpt(Def.Name,255) then exit;

     makename(Def,newname,Info);
     oldname:=Name+'.bsp';
     convert(rep+oldname,newname);
     findnext(Dirinfo)
     end;
importe_special:=true;
end;

function importe_remb(rep:string; cptname:string):boolean;

var oldname:string;
    newname:Tname;
    Def:TCptDef;
    Info:ECatalog;

begin
importe_remb:=true;
{ Creation du compte }
Def.Name:=CptName;
Def.Prev:=false;
Def.Mois:=1;
Def.Annee:=1991;
Def.Mode:=mdnorm or mdseul;
Info.LIB1:=' LIBELLE ';
Info.LIB2:=' PRET ';
Info.LIB3:=' REMB  ';
makename(Def,newname,Info);
oldname:='remb.bud';
convert(rep+oldname,newname);
end;



end.