{************************************************}
{   MOUSEDLG.PAS                                 }
{   Turbo Pascal 6.0 TVDEMOS Accessoire          }
{                                                }
{   Unit utilise par:                          }
{     TVDEMO  .PAS                               }
{     TVRDEMO .PAS                               }
{   Units rfrences:                          }
{     DIALOGS .PAS                               }
{     DRIVERS .PAS                               }
{     OBJECTS .PAS                               }
{     VIEWS   .PAS                               }
{                                                }
{   Copyright (c) 1990 by Borland International  }
{************************************************}

{ Accessoire Bote de paramtrage de souris (utilis par TVDEMO.PAS.)  }

UNIT MouseDlg;

{$F+,O+,X+,S-,D-}

INTERFACE

USES Drivers, Objects, Views, Dialogs;

CONST
  CClickTester = #7#8;

TYPE

  { TClickTester }

  { Palette layout }
  { 0 = Non cliqu }
  { 1 = Cliqu     }

  PClickTester = ^TClickTester;
  TClickTester = object(TStaticText)
    Clicked: Boolean;
    constructor Init(var Bounds: TRect; AText: String);
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Draw; virtual;
  end;

  { TMouseDialog }

  PMouseDialog = ^TMouseDialog;
  TMouseDialog = object(TDialog)
    MouseScrollBar: PScrollBar;
    OldDelay: Word;
    constructor Init;
    constructor Load(var S: TStream);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
  end;

IMPLEMENTATION

{ TClickTester }

constructor TClickTester.Init(var Bounds: TRect; AText: String);
begin
  TStaticText.Init(Bounds, AText);
  Clicked := False;
end;

function TClickTester.GetPalette: PPalette;
const
  P: String[Length(CClickTester)] = CClickTester;
begin
  GetPalette := @P;
end;

procedure TClickTester.HandleEvent(var Event: TEvent);
begin
  TStaticText.HandleEvent(Event);
  if (Event.What = evMouseDown) then
  begin
    if Event.Double then
    begin
      Clicked := not Clicked;
      DrawView;
    end;
    ClearEvent(Event);
  end;
end;

procedure TClickTester.Draw;
var
  B: TDrawBuffer;
  C: Byte;
begin
  if Clicked then C := GetColor(2)
  else C := GetColor(1);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, Text^, C);
  WriteLine(0, 0, Size.X, 1, B);
end;

{ TMouseDialog }

constructor TMouseDialog.Init;
var
  R: TRect;
begin
  R.Assign(0, 0, 34, 12);
  TDialog.Init(R, 'Paramtres de souris');
  Options := Options or ofCentered;

  R.Assign(3, 4, 30, 5);
  MouseScrollBar := New(PScrollBar, Init(R));
  MouseScrollBar^.SetParams(1, 1, 20, 20, 1);
  MouseScrollBar^.Options := MouseScrollBar^.Options or ofSelectable;
  MouseScrollBar^.SetValue(DoubleDelay);
  Insert(MouseScrollBar);
  R.Assign(2, 2, 21, 3);
  Insert(New(PLabel, Init(R, '~D~ouble clic', MouseScrollBar)));

  R.Assign(3, 3, 30, 4);
  Insert(New(PClickTester, Init(R, 'Rapide      Moyen      Lent')));

  R.Assign(3, 6, 30, 7);
  Insert(New(PCheckBoxes, Init(R,
    NewSItem('~I~nversion boutons', nil))));

  OldDelay := DoubleDelay;

  R.Assign(9, 9, 19, 11);
  Insert(New(PButton, Init(R, 'O~K~', cmOk, bfDefault)));
  Inc(R.A.X, 12); Inc(R.B.X, 13);
  Insert(New(PButton, Init(R, 'Annuler', cmCancel, bfNormal)));

  SelectNext(False);
end;

constructor TMouseDialog.Load(var S: TStream);
begin
  TDialog.Load(S);
  GetSubViewPtr(S, MouseScrollBar);
  MouseScrollBar^.SetValue(DoubleDelay);
end;

procedure TMouseDialog.HandleEvent(var Event: TEvent);
begin
  TDialog.HandleEvent(Event);
  case Event.What of
    evCommand:
      if Event.Command = cmCancel then DoubleDelay := OldDelay;
    evBroadcast:
      if Event.Command = cmScrollBarChanged then
      begin
        DoubleDelay := MouseScrollBar^.Value;
        ClearEvent(Event);
      end;
  end;
end;

procedure TMouseDialog.Store(var S: TStream);
begin
  TDialog.Store(S);
  PutSubViewPtr(S, MouseScrollBar);
end;

end.

{   EOS MOUSEDLG.PAS                                 }
