{ Unit de gestion d'un bip sonore }

unit XBeep;

{$O+}
{$F+}

interface

uses Drivers,crt,Views,App,Objects,Dialogs;

procedure Beep;

procedure SetBeepMode;


const cmbeepmode=10100;

var BeepTyp:byte;
    InsType:byte;
    hbdialog,hbok,hbcancel,hbtest,hbtype,hbinst:byte;

implementation

type RData=record
           Mode:word;
           Ins:string[1];
           end;


type PBeepDialog = ^TBeepDialog;
     TBeepDialog = object(TDialog)

      procedure HandleEvent(var E:TEvent); virtual;

     end;

procedure TBeepDialog.HandleEvent(var E:TEvent);

var OldBeep,OldIns:byte;
    Bdata:RData;
    ERR:integer;

begin
if (E.what=evcommand) and (E.command=cmerror) then
  begin
  OldIns:=insType;
  OldBeep:=BeepTyp;
  GetData(BData);
  BeepTyp:=BData.Mode;
  val(BData.Ins,InsType,ERR);
  Beep;
  BeepTyp:=OldBeep;
  InsType:=OldIns;
  clearEvent(E);
  end;
TDialog.HandleEvent(E);
end;

procedure SBsound(on:boolean;channel,octave:byte;freq:integer);

var von:byte;

begin
 if on then von:=1 else von:=0;
 port[$388]:=($A0)+channel;
 delay(1);
 port[$389]:=freq and 255;
 delay(1);
 port[$388]:=($B0)+channel;
 delay(1);
 port[$389]:=(von shl 5) or (octave shl 2) or (freq shr 8);
 delay(1);
end;

procedure SBDef(i,chanel:byte);


const
     MULT_M:array[0..8] of byte  = ( $20,$21,$22,$28,$29,$2A,$30,$31,$32 );
     MULT_C:array[0..8] of byte  = ( $23,$24,$25,$2B,$2C,$2D,$33,$34,$35 );

     KSLTL_M:array[0..8] of byte = ( $40,$41,$42,$48,$49,$4A,$50,$51,$52 );
     KSLTL_C:array[0..8] of byte = ( $43,$44,$45,$4B,$4C,$4D,$53,$54,$55 );

     AD_M:array[0..8] of byte = ( $60,$61,$62,$68,$69,$6A,$70,$71,$72 );
     AD_C:array[0..8] of byte = ( $63,$64,$65,$6B,$6C,$6D,$73,$74,$75 );

     SR_M:array[0..8] of byte = ( $80,$81,$82,$88,$89,$8A,$90,$91,$92 );
     SR_C:array[0..8] of byte = ( $83,$84,$85,$8B,$8C,$8D,$93,$94,$95 );

     WS_M:array[0..8] of byte = ( $E0,$E1,$E2,$E8,$E9,$EA,$F0,$F1,$F2 );
     WS_C:array[0..8] of byte = ( $E3,$E4,$E5,$EB,$EC,$ED,$F3,$F4,$F5 );

     FEEDCON:array[0..8] of byte = ( $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8 );

     INST:array[0..9] of array [0..15] of byte =
     	   (
	       (   $21,$11,$4C,$00,$F1,$F2,$63,$72,
		   $00,$00,$04,$00,$00,$00,$00,000 ),

	       (   $0A5,$0B1,$0D2,$080,$081,$0F1,$003,$005,
		   $000,$000,$002,$000,$000,$000,$000,$000 ),

	       (   $072,$062,$01C,$005,$051,$052,$003,$013,
		   $000,$000,$00E,$000,$000,$000,$000,$000 ),

	       (   $011,$001,$08A,$040,$0F1,$0F1,$011,$0B3,
		   $000,$000,$006,$000,$000,$000,$000,$000 ),

	       (   $021,$011,$011,$000,$0A3,$0C4,$043,$022,
		   $002,$000,$00D,$000,$000,$000,$000,$000 ),

	       (   $031,$0A1,$01C,$080,$041,$092,$00B,$03B,
		   $000,$000,$00E,$000,$000,$000,$000,$000 ),

	       (   $071,$062,$0C5,$005,$06E,$08B,$017,$00E,
		   $000,$000,$002,$000,$000,$000,$000,$000 ),

	       (   $041,$091,$083,$000,$065,$032,$005,$074,
		   $000,$000,$00A,$000,$000,$000,$000,$000 ),

	       (   $032,$016,$087,$080,$0A1,$07D,$010,$033,
		   $000,$000,$008,$000,$000,$000,$000,$000 ),

	       (   $001,$013,$08D,$000,$051,$052,$053,$07C,
		   $001,$000,$00C,$000,$000,$000,$000,$000 )
           );


begin
 port[$388]:=MULT_M[chanel];
 delay(1);
 port[$389]:=inst[i,0];
 delay(1);
 port[$388]:=MULT_C[chanel];
 delay(1);
 port[$389]:=inst[i,1];
 delay(1);
 port[$388]:=KSLTL_M[chanel];
 delay(1);
 port[$389]:=inst[i,2];
 delay(1);
 port[$388]:=KSLTL_C[chanel];
 delay(1);
 port[$389]:=inst[i,3];
 delay(1);
 port[$388]:=AD_M[chanel];
 delay(1);
 port[$389]:=inst[i,4];
 delay(1);
 port[$388]:=AD_C[chanel];
 delay(1);
 port[$389]:=inst[i,5];
 delay(1);
 port[$388]:=SR_M[chanel];
 delay(1);
 port[$389]:=inst[i,6];
 delay(1);
 port[$388]:=SR_C[chanel];
 delay(1);
 port[$389]:=inst[i,7];
 delay(1);
 port[$388]:=WS_M[chanel];
 delay(1);
 port[$389]:=inst[i,8];
 delay(1);
 port[$388]:=WS_C[chanel];
 delay(1);
 port[$389]:=inst[i,9];
 delay(1);
 port[$388]:=FEEDCON[chanel];
 delay(1);
 port[$389]:=inst[i,10];
 delay(1);


end;


procedure beep;

begin
case BeepTyp of
 1:begin
   sound(500);
   delay(20);
   sound(1000);
   delay(20);
   sound(1500);
   delay(20);
   nosound;
   end;
 2:begin
   sound(1000);
   delay(50);
   nosound;
   end;
 3:begin
   sound(200);
   delay(80);
   sound(500);
   delay(80);
   sound(1000);
   delay(80);
   nosound;
   end;
 4:begin
   SBDef(InsType,0);
   SBsound(true,0,2,500);
   delay(100);
   SBsound(false,0,2,500);
   end;
 end;
end;

procedure SetBeepMode;

var R:TRect;
    C:PRadioButtons;
    I:PinputLine;
    Dialog:PBeepDialog;
    Control:Word;
    BData:RData;
    ERR:integer;
    V:PView;

begin
R.Assign(19,5,61,16);
Dialog:=New(PBeepDialog,Init(R, 'Slction du bip'));
with Dialog^ do
  begin
  R.Assign(3,7,13,9);
  V:=(New (PButton, Init(R,' ~O~k', cmok, bfDefault)));
  V^.helpCtx:=hbok;
  insert(V);
  R.Assign(15,7,28,9);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.HelpCtx:=hbcancel;
  insert(V);
  R.Assign(30,7,40,9);
  V:=(New (PButton, Init(R,'Test', cmerror, bfNormal)));
  V^.helpCtx:=hbtest;
  insert(V);
  R.assign(2,2,40,6);
  C:=New(PRadioButtons, Init(R, NewSItem('~P~as de Bip',
                                NewSItem('~C~ruic',
                                NewSItem('~B~ip',
                                NewSItem('~M~lodie',
                                NewSitem('~S~ound Blaster',
                                nil)))))));
  C^.helpCtx:=hbtype;
  insert(C);

  R.Assign(21,3,40,6);
  insert(new(PStatictext, Init(R,'')));

  R.Assign(36,4,39,5);
  I:=New(PInputLine, Init(R,1));
  I^.helpCtx:=hbinst;
  insert(I);
  R.Assign(22,4,36,5);
  Insert(New(PLabel, Init(R, '~I~nstrument : ' , I)));

  BData.Mode:=BeepTyp;
  str(InsType,BData.Ins);
  SetData(BData);
  Options:=Options or ofCentered;
  helpCtx:=hbdialog;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then exit;
Dialog^.GetData(BData);

Dispose(Dialog,Done);
BeepTyp:=BData.Mode;
val(BData.Ins,InsType,ERR);
end;

begin
BeepTyp:=0;
InsType:=0;
hbdialog:=hcnocontext;
hbok:=hcnocontext;
hbcancel:=hcnocontext;
hbtest:=hcnocontext;
hbtype:=hcnocontext;
hbinst:=hcnocontext;
end.
