
unit XPrint;   { Toujours lancer Init avant d'utiliser Xprint }

{$O+}
{$F+}

interface

uses Crt,Dos;

const prInit        = 1; { Commandes d'impression }
      prGras        = 2;
      prFinGras     = 3;
      prDoubFrap    = 4;
      prFinDoubFrap = 5;
      prCondense    = 6;
      prFinCondense = 7;
      prDoubLarg    = 8;
      prFinDoubLarg = 9;
      prDoubHaut    =10;
      prFinDoubHaut =11;
      pr10CPI       =12;
      pr12CPI       =13;
      pr15CPI       =14;
      prUnidDir     =15;
      prDoubDir     =16;
      prChargeurOn  =17;
      prChargeurOff =18;
      prInterLigne8 =19; { 1/8 eme de pouce }
      prInterLigne6 =20; { 1/6 eme de pouce }
      prBrouillon   =21;
      prCourrier    =22;
      prPropChar    =23; { Caractres proportionnels }
      prFinPropChar =24;
      prExposant    =25;
      prFinExposant =26;
      prIndice      =27;
      prFinIndice   =28;
      prSouligne    =29;
      prFinSouligne =30;
      prItalique    =31;
      prFinItalique =32;
      prJustifierG  =33;
      prJustifierC  =34;
      prJustifierD  =35;
      prJustifierGD =36;
      prNormal      =37;
      prOutLine     =38;
      prOmbre       =39;
      prOutLineOmbr =40;
      prRoman       =41;
      prSansSherif  =42;


var PrintedLines:word;     { Nb de ligne imprimes dans la page en cours }
    PrintDriver:string;    { Chemin d'accs au driver de l'imprimante }
    BaseDir:string;        { Chemin d'accs au fichiers spooler }

function timer:longint;    { Retourne une valeur augmentant de 1 tous les 100eme de secondes }

procedure stopall(Purge:boolean);  { Arrette Tout avec reset si Purge }

procedure endpage;          { Saut de page }

procedure endprint;         { Cloture le document et l'imprime }

procedure print(ch:string);

procedure println(ch:string);

procedure printcmd(cmd:word); { Envoi une commande d'impression }

procedure setprintmode(Spooled:boolean; timeout:word);  { Selection ou pas le mode spool avec timeout (0=pas de delai) }

function ItPrint:boolean;   { It impression - Retourne Vrai si on a imprim }

function Empty:boolean;     { Retourne Faux si impression en attente }

procedure Destroy;          { Detruit tous les fichiers temporaires }

procedure Init;             { Initialise xprint - BaseDir doit tre modifier avant !}

implementation

var lst,prn,CurFic:text;
    Spooler,inprint,openlst:boolean;
    Time_out,LastDoc,CurDoc:word;
    Nextprint:Longint;
    Today:word;
    stockdir:string;
    WINPRINT:BOOLEAN;        { indique si impression sur windows spooler }
    REG:REGISTERS;

{ Procdure interne pour stocker ou restituer le directorie }

const PrintDir=true; DefaultDir=false;


procedure GoDir(Ou:Boolean);

begin
if Ou=PrintDir then
  begin
  getdir(0,StockDir);
  chdir(BaseDir);
  end
 else
  begin
  chdir(StockDir);
  end;
end;


procedure printcmd(cmd:word);

var ch:string;
    fic:text;
    f:word;

begin
assign(fic,PrintDriver);
{$I-}
reset(fic);
{$I+}
if ioresult<>0 then exit;
for f:=1 to cmd do
 if not eof(fic) then readln(fic,ch);
close(fic);
print(ch);
end;


function timer:longint;

var Tim:longint;
    xx,jj,hh,mm,ss,s1:word;

begin
getdate(xx,xx,jj,xx);
gettime(hh,mm,ss,s1);
tim:=longint(hh)*360000+longint(mm)*6000+ss*100+s1;
if today>jj then jj:=today+1;
if today<>jj then tim:=tim+8640000*longint(jj-today);
timer:=tim;
end;

procedure Destroy;

var DirInfo:SearchRec;

begin
GoDir(PrintDir);
if openlst then begin close(lst); openlst:=false; end;
findfirst('$SPOOL$.*',AnyFile,DirInfo);
while DosError=0 do
  begin
  assign(lst,DirInfo.Name);
  erase(lst);
  findnext(DirInfo);
  end;
godir(defaultdir);
end;

procedure name(var f:text; Doc:byte);

var NUM:string;

begin
str(Doc,NUM);
assign(f,'$SPOOL$.'+NUM);
end;

function Empty:boolean;

begin
if WINPRINT then
   begin
   REG.AX:=$0007;
   intr($47,REG);
   Empty:=REG.BL=LastDoc;
   exit;
   end;
Empty:=(not inprint) and (CurDoc>=LastDoc);
end;


function ItPrint:boolean;

var S:char;
    REG:REGISTERS;

begin
ItPrint:=false;
if not spooler then exit;
if WINPRINT then exit;
if (timer<nextprint) and (time_out<>0) then exit;
Nextprint:=0;
REG.AH:=2;                  { Lecture etat de l'imprimante par le BIOS) }
REG.DX:=0;
if (time_out<>0) then
  begin
  intr(23,REG);
  if (REG.AH and 177)<>144 then begin
                              nextprint:=timer+time_out;
                              exit;
                              end;
  end;
if (CurDoc=LastDoc) and (not inprint) then exit;
if (not inprint) then
   begin
   inc(CurDoc);
   inprint:=true;
   name(CurFic,CurDoc);
   godir(PrintDir);
   reset(CurFic);
   godir(defaultdir);
   end;
if eof(CurFic) then
  begin
  godir(printdir);
  { write(prn,#12); }
  close(CurFic);
  erase(CurFic);
  inprint:=false;
  godir(defaultdir);
  end;
if inprint then
  begin
  read(CurFic,S);
  ItPrint:=true;
  write(prn,S);
  { nextprint:=timer+time_out; }
  end;
end;

procedure setprintmode(Spooled:boolean;timeout:word);

begin
GoDir(PrintDir);
Time_out:=timeout;
if openlst then
   begin
   close(lst);
   openlst:=false;
   if spooled then close(prn);
   end;
if spooled then
  begin
  Name(lst,LastDoc+1);
  rewrite(lst);
  openlst:=true;
  assign(prn,'PRN');
  rewrite(prn); 
  end;
Spooler:=Spooled;
godir(defaultdir);
end;


procedure stopall(Purge:boolean);

var REG:registers;
    ch:string;
    fic:text;
    f:word;

begin
PrintedLines:=0;
CurDoc:=0;
LastDoc:=0;
Inprint:=false;
if WINPRINT then
      begin
      REG.AX:=$0000;
      intr($47,REG);
      end;
Destroy;
setprintmode(Spooler,Time_out);
if WINPRINT then exit;
{ Reset de l'imprimante par le BIOS)  - Attention avec windows 95 : Purge }
if Purge then
   begin
   REG.AH:=1;
   REG.DX:=0;
   intr(23,REG);
   if (REG.AH and 8)=8 then begin write(#7); exit; end;
   end;
if Spooler then
  begin
  assign(fic,PrintDriver);
  {$I-}
  reset(fic);
  {$I+}
  if ioresult<>0 then exit;
  for f:=1 to 1 do
   if not eof(fic) then readln(fic,ch);
  close(fic);
  {$I-}
  write(prn,ch);
  {$I-}
  if ioresult<>0 then exit;
  end;
end;


procedure endprint;

var i:byte;
    CH:string;
begin
if spooler then
  begin
  GoDir(PrintDir);
  if openlst then close(lst);
  openlst:=false;
  inc(LastDoc);
  Name(lst,LastDoc+1);
  rewrite(lst);
  godir(defaultdir);
  end;
if WINPRINT then
  begin
  str(LastDoc,CH);
  CH:=copy('VBUDGET:'+CH+'               ',1,15);
  for i:=1 to 15 do
    begin
    REG.AX:=0001;
    REG.BL:=ord(CH[i]);
    REG.BH:=i-1;
    intr($47,REG);
    end;
  REG.AX:=0002;
  REG.BX:=0;
  REG.BL:=LastDoc;
  intr($47,REG);
  inc(CurDoc);
  end
 else if not spooler then begin close(lst); openlst:=false; end;
end;

procedure endpage;

begin
if not openlst then begin assign(lst,'PRN'); rewrite(lst); openlst:=true; end;
PrintedLines:=0;
write(lst,#12);
end;


procedure print(ch:string);

begin
if not openlst then begin assign(lst,'PRN'); rewrite(lst); openlst:=true; end;
write(lst,ch);
end;


procedure println(ch:string);

begin
writeln(lst,ch);
Inc(PrintedLines);
end;

procedure Init;

begin
Openlst:=false;
BaseDir:='C:\';
GoDir(PrintDir);
getdate(time_out,time_out,today,time_out);
Spooler:=false;
Inprint:=false;
CurDoc:=0;
LastDoc:=0;
godir(defaultdir);
Destroy;
Time_out:=0;
NextPrint:=0;
PrintedLines:=0;
printDriver:='';
end;

begin
BaseDir:='C:\';
{
  Winprint hors service
REG.AX:=$0000;
intr($47,REG);
WINPRINT:=REG.AX=$1111;
}
WINPRINT:=false;
openlst:=false;
end.